"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AppControls = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _PureComponent2 = _interopRequireDefault(require("./PureComponent"));

var _pdfSpreadsheet = _interopRequireDefault(require("./pdfSpreadsheet"));

var _pdfChart = _interopRequireDefault(require("./pdfChart"));

var _app_bar = _interopRequireDefault(require("react-toolbox/lib/app_bar"));

var _SampleSearch = require("./views/SampleSearch");

var _uuid = _interopRequireDefault(require("./uuid"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var React = require('react');

var _ = require('./underscore_ext')["default"];

var konami = require('./konami');

var widgets = require('./columnWidgets');

var classNames = require('classnames');

var gaEvents = require('./gaEvents');

var _require = require('./models/fieldSpec'),
    signatureField = _require.signatureField;

// Styles
var compStyles = require('./AppControls.module.css');

var modePdf = {
  chart: _pdfChart["default"],
  heatmap: _pdfSpreadsheet["default"]
};
var modeIcon = {
  chart: 'view_column',
  heatmap: 'insert_chart'
};
var modeEvent = {
  chart: 'heatmap',
  heatmap: 'chart'
};
var modeHelp = {
  chart: 'View as columns',
  heatmap: 'View as chart'
};

function download(_ref) {
  var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      fields = _ref2[0],
      rows = _ref2[1];

  var txt = _.map([fields].concat(rows), function (row) {
    return row.join('\t');
  }).join('\n'); // use blob for bug in chrome: https://code.google.com/p/chromium/issues/detail?id=373182


  var url = URL.createObjectURL(new Blob([txt], {
    type: 'text/tsv'
  }));
  var a = document.createElement('a');
  var filename = 'denseDataOnlyDownload.tsv';

  _.extend(a, {
    id: filename,
    download: filename,
    href: url
  });

  document.body.appendChild(a);
  a.click();
  document.body.removeChild(a);
}

var asciiB = 66;

var Actions = function Actions(_ref3) {
  var onPdf = _ref3.onPdf,
      onDownload = _ref3.onDownload,
      onShowWelcome = _ref3.onShowWelcome,
      showWelcome = _ref3.showWelcome,
      onMode = _ref3.onMode,
      mode = _ref3.mode,
      hasColumn = _ref3.hasColumn;
  return /*#__PURE__*/React.createElement("div", {
    className: compStyles.actions
  }, hasColumn ? /*#__PURE__*/React.createElement("i", {
    className: "material-icons",
    onClick: onMode,
    title: modeHelp[mode]
  }, modeIcon[mode]) : null, hasColumn ? /*#__PURE__*/React.createElement("i", {
    className: "material-icons",
    onClick: onPdf,
    title: "Download as PDF"
  }, "picture_as_pdf") : null, hasColumn ? /*#__PURE__*/React.createElement("i", {
    className: "material-icons",
    onClick: onDownload,
    title: "Download as tsv"
  }, "cloud_download") : null, showWelcome ? null : /*#__PURE__*/React.createElement("i", {
    className: "material-icons",
    onClick: onShowWelcome
  }, "help"));
};

var BasicSearch = function BasicSearch(_ref4) {
  var help = _ref4.help,
      onTies = _ref4.onTies,
      tiesEnabled = _ref4.tiesEnabled,
      searchProps = (0, _objectWithoutProperties2["default"])(_ref4, ["help", "onTies", "tiesEnabled"]);
  return /*#__PURE__*/React.createElement("div", {
    className: compStyles.filter
  }, /*#__PURE__*/React.createElement(_SampleSearch.SampleSearch, searchProps), help ? /*#__PURE__*/React.createElement("a", {
    href: help,
    target: "_blank",
    className: compStyles.filterHelp
  }, /*#__PURE__*/React.createElement("i", {
    className: "material-icons"
  }, "help_outline")) : null, tiesEnabled ? /*#__PURE__*/React.createElement("a", {
    onClick: onTies,
    className: compStyles.ties
  }, /*#__PURE__*/React.createElement("i", {
    className: "material-icons"
  }, "toys")) : null);
};

var TiesSearch = function TiesSearch() {
  return /*#__PURE__*/React.createElement("div", {
    className: compStyles.filter
  }, /*#__PURE__*/React.createElement("span", null, "Pathology Report Search and Filter by TIES"));
};

var TiesActions = function TiesActions(_ref5) {
  var onTies = _ref5.onTies,
      onTiesColumn = _ref5.onTiesColumn;
  return /*#__PURE__*/React.createElement("div", {
    className: compStyles.actions
  }, /*#__PURE__*/React.createElement("button", {
    onClick: onTiesColumn
  }, "Create filtered column"), /*#__PURE__*/React.createElement("a", {
    onClick: onTies,
    className: compStyles.filterHelp
  }, /*#__PURE__*/React.createElement("i", {
    className: "material-icons"
  }, "close")));
};

function getFilterColumn(title, sampleSets, exprs) {
  var opts = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

  var field = signatureField(title, _objectSpread({
    columnLabel: 'Subgroup',
    valueType: 'coded',
    signature: ['cross', sampleSets, exprs]
  }, opts)),
      settings = _.assoc(field, 'width', 136, 'user', _.pick(field, ['columnLabel', 'fieldLabel']));

  return {
    id: (0, _uuid["default"])(),
    settings: settings
  };
} // XXX drop this.props.style? Not sure it's used.


var AppControls = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(AppControls, _PureComponent);

  var _super = _createSuper(AppControls);

  function AppControls() {
    var _this;

    (0, _classCallCheck2["default"])(this, AppControls);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onFilter", function () {
      var _this$props = _this.props,
          callback = _this$props.callback,
          _this$props$appState = _this$props.appState,
          samplesMatched = _this$props$appState.samplesMatched,
          cohortSamples = _this$props$appState.cohortSamples,
          matching = _.map(samplesMatched, function (i) {
        return cohortSamples[i];
      });

      gaEvents('spreadsheet', 'samplesearch', 'filter');
      callback(['sampleFilter', matching]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onFilterZoom", function () {
      var _this$props2 = _this.props,
          _this$props2$appState = _this$props2.appState,
          samples = _this$props2$appState.samples,
          samplesMatched = _this$props2$appState.samplesMatched,
          height = _this$props2$appState.zoom.height,
          callback = _this$props2.callback,
          toOrder = _.object(samples, _.range(samples.length)),
          index = toOrder[_.min(samplesMatched, function (s) {
        return toOrder[s];
      })],
          last = toOrder[_.max(samplesMatched, function (s) {
        return toOrder[s];
      })];

      gaEvents('spreadsheet', 'samplesearch', 'zoom');
      callback(['zoom', {
        index: index,
        height: height,
        count: last - index + 1
      }]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onFilterColumn", function () {
      var _this$props3 = _this.props,
          _this$props3$appState = _this$props3.appState,
          cohortSamples = _this$props3$appState.cohortSamples,
          sampleSearch = _this$props3$appState.sampleSearch,
          allMatches = _this$props3$appState.allMatches,
          callback = _this$props3.callback,
          matching = _.map(allMatches.matches, function (matchSet) {
        return _.map(matchSet, function (i) {
          return cohortSamples[i];
        });
      });

      gaEvents('spreadsheet', 'samplesearch', 'new column');
      callback(['add-column', 0, getFilterColumn(sampleSearch, matching, allMatches.exprs, {
        filter: sampleSearch
      })]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onTiesColumn", function () {
      var _this$props4 = _this.props,
          _this$props4$appState = _this$props4.appState,
          _this$props4$appState2 = _this$props4$appState.ties,
          filter = _this$props4$appState2.filter,
          docs = _this$props4$appState2.docs,
          cohortSamples = _this$props4$appState.cohortSamples,
          patient = _this$props4$appState.survival.patient,
          callback = _this$props4.callback,
          pindex = patient.data.req.values[0],
          pcodes = patient.data.codes,
          keep = new Set(Object.keys(filter).filter(function (k) {
        return filter[k];
      }).map(function (i) {
        return docs[i].patient;
      })),
          matching = cohortSamples.filter(function (s, i) {
        return keep.has(pcodes[pindex[i]]);
      });
      callback(['add-column', 0, getFilterColumn('TIES selection', matching)]); // XXX broken

      callback(['ties-dismiss']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onMode", function () {
      var _this$props5 = _this.props,
          callback = _this$props5.callback,
          mode = _this$props5.appState.mode;
      gaEvents('spreadsheet', 'mode', modeEvent[mode]);
      callback([modeEvent[mode]]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onRefresh", function () {
      var callback = _this.props.callback;
      callback(['refresh-cohorts']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onPdf", function () {
      var mode = _this.props.appState.mode;
      gaEvents('spreadsheet', 'pdf', mode === 'heatmap' ? 'spreadsheet' : 'chart');
      modePdf[mode](_this.props.appState);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onCohortSelect", function (value) {
      _this.props.callback(['cohort', value]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onTies", function () {
      var ties = _this.props.appState.ties;

      _this.props.callback([_.get(ties, 'open') ? 'ties-dismiss' : 'ties-open']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onDownload", function () {
      var sampleFormat = _this.props.sampleFormat,
          _this$props$appState2 = _this.props.appState,
          samples = _this$props$appState2.samples,
          columns = _this$props$appState2.columns,
          columnOrder = _this$props$appState2.columnOrder,
          index = _this$props$appState2.index,
          data = _this$props$appState2.data,
          rectData = columnOrder.filter(function (id) {
        return _.contains(['float', 'coded', 'segmented'], columns[id].valueType) && _.getIn(data, [id, 'status']) === 'loaded';
      }),
          datasets = rectData.map(function (id) {
        return widgets.download({
          samples: samples,
          column: columns[id],
          index: index[id],
          data: data[id],
          sampleFormat: sampleFormat
        });
      }),
          combinedRows = _.mmap.apply(_, (0, _toConsumableArray2["default"])(_.pluck(datasets, 1)).concat([function () {
        for (var _len2 = arguments.length, rows = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          rows[_key2] = arguments[_key2];
        }

        rows.pop(); // mmap passes index

        return [].concat((0, _toConsumableArray2["default"])(rows[0]), (0, _toConsumableArray2["default"])(_.flatten(rows.slice(1).map(function (cols) {
          return cols.slice(1);
        }))));
      }])),
          combinedHeaders = _.flatmap(datasets, function (_ref6, i) {
        var _ref7 = (0, _slicedToArray2["default"])(_ref6, 1),
            headers = _ref7[0];

        return i === 0 ? headers : headers.slice(1);
      });

      gaEvents('spreadsheet', 'download', 'spreadsheet');
      download([combinedHeaders, combinedRows]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onShowWelcome", function () {
      _this.props.onShowWelcome();
    });
    return _this;
  }

  (0, _createClass2["default"])(AppControls, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      this.nsub = konami(asciiB).subscribe(function () {
        _this2.props.callback(['notifications-enable']);
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.nsub.unsubscribe();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props6 = this.props,
          _this$props6$appState = _this$props6.appState,
          cohort = _this$props6$appState.cohort,
          samplesOver = _this$props6$appState.samplesOver,
          allowOverSamples = _this$props6$appState.allowOverSamples,
          mode = _this$props6$appState.mode,
          columnOrder = _this$props6$appState.columnOrder,
          showWelcome = _this$props6$appState.showWelcome,
          samples = _this$props6$appState.samples,
          sampleSearch = _this$props6$appState.sampleSearch,
          samplesMatched = _this$props6$appState.samplesMatched,
          ties = _this$props6$appState.ties,
          onReset = _this$props6.onReset,
          help = _this$props6.help,
          onResetSampleFilter = _this$props6.onResetSampleFilter,
          onHighlightChange = _this$props6.onHighlightChange,
          onHighlightSelect = _this$props6.onHighlightSelect,
          onAllowOverSamples = _this$props6.onAllowOverSamples,
          callback = _this$props6.callback,
          displayOver = samplesOver && !allowOverSamples ? '' : compStyles.hidden,
          matches = _.get(samplesMatched, 'length', samples.length),
          onPdf = this.onPdf,
          onDownload = this.onDownload,
          onShowWelcome = this.onShowWelcome,
          onMode = this.onMode,
          tiesOpen = _.get(ties, 'open'),
          cohortName = _.get(cohort, 'name'),
          hasColumn = !!columnOrder.length,
          sampleFilter = _.get(cohort, 'sampleFilter'),
          filter = sampleFilter ? /*#__PURE__*/React.createElement("span", {
        onClick: onResetSampleFilter,
        className: compStyles.appliedFilter
      }, "Filtered to ") : null;

      return /*#__PURE__*/React.createElement(_app_bar["default"], null, /*#__PURE__*/React.createElement("div", {
        className: classNames(compStyles.appBarContainer, compStyles.cohort)
      }, /*#__PURE__*/React.createElement("div", {
        className: compStyles.titleContainer
      }, /*#__PURE__*/React.createElement("span", {
        className: compStyles.title
      }, cohortName), /*#__PURE__*/React.createElement("span", {
        className: compStyles.subtitle
      }, filter, " ", samples.length, " Samples", /*#__PURE__*/React.createElement("i", {
        onClick: onAllowOverSamples,
        title: "Samples on screen limited to 50000 for performance. Click to see all samples.",
        className: "".concat(compStyles.overWarning, " ").concat(displayOver, " material-icons")
      }, "warning"))), /*#__PURE__*/React.createElement("i", {
        className: "material-icons",
        onClick: this.onRefresh,
        title: "Reload cohort data"
      }, "refresh"), /*#__PURE__*/React.createElement("i", {
        className: "material-icons",
        onClick: onReset,
        title: "Pick new cohort"
      }, "close")), /*#__PURE__*/React.createElement("div", {
        className: classNames(compStyles.appBarContainer, compStyles.tools)
      }, tiesOpen ? /*#__PURE__*/React.createElement(TiesSearch, {
        onTies: this.onTies
      }) : /*#__PURE__*/React.createElement(BasicSearch, {
        value: sampleSearch,
        matches: matches,
        onHighlightSelect: onHighlightSelect,
        sampleCount: samples.length,
        onFilter: this.onFilter,
        onZoom: this.onFilterZoom,
        onCreateColumn: this.onFilterColumn,
        onChange: onHighlightChange,
        mode: mode,
        onResetSampleFilter: onResetSampleFilter,
        cohort: cohort,
        callback: callback,
        help: help,
        onTies: this.onTies,
        tiesEnabled: false
      }), tiesOpen ? /*#__PURE__*/React.createElement(TiesActions, {
        onTies: this.onTies,
        onTiesColumn: this.onTiesColumn
      }) : /*#__PURE__*/React.createElement(Actions, {
        onPdf: onPdf,
        onDownload: onDownload,
        onShowWelcome: onShowWelcome,
        showWelcome: showWelcome,
        onMode: onMode,
        mode: mode,
        hasColumn: hasColumn
      })));
    }
  }]);
  return AppControls;
}(_PureComponent2["default"]);

exports.AppControls = AppControls;