"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _reactMaterialResponsiveGrid = require("react-material-responsive-grid");

var _AppControls = require("./AppControls");

var _KmPlot = require("./KmPlot");

var _SheetControls = _interopRequireDefault(require("./SheetControls"));

var _StateError = require("./StateError");

var _Stepper = require("./views/Stepper");

var _WelcomeContainer = _interopRequireDefault(require("./containers/WelcomeContainer"));

require("../css/index.css");

var _reactCssThemr = require("react-css-themr");

var _appTheme = _interopRequireDefault(require("./appTheme"));

var _nav = _interopRequireDefault(require("./nav"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var _ = require('./underscore_ext')["default"];

var gaEvents = require('./gaEvents'); //var Perf = require('react/lib/ReactDefaultPerf');


var stepperSteps = [{
  label: 'Select a Study to Explore'
}, {
  label: 'Select Your First Variable'
}, {
  label: 'Select Your Second Variable'
}];
var stepperStateIndex = {
  'COHORT': 0,
  'FIRST_COLUMN': 1,
  'SECOND_COLUMN': 2
}; // should really be in a config file.

var searchHelp = 'https://ucsc-xena.gitbook.io/project/overview-of-features/filter-and-subgrouping';

function clearZoom(samples, zoom) {
  return _.merge(zoom, {
    count: samples,
    index: 0
  });
}

function zoomOut(samples, zoom) {
  var count = zoom.count,
      index = zoom.index;
  var nCount = Math.min(samples, Math.round(count * 3)),
      maxIndex = samples - nCount,
      nIndex = Math.max(0, Math.min(Math.round(index + (count - nCount) / 2), maxIndex));
  return _.merge(zoom, {
    count: nCount,
    index: nIndex
  });
}

var Application = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Application, _Component);

  var _super = _createSuper(Application);

  function Application() {
    var _this;

    (0, _classCallCheck2["default"])(this, Application);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onClearZoom", function () {
      var _this$props$state = _this.props.state,
          samples = _this$props$state.samples,
          zoom = _this$props$state.zoom;

      _this.props.callback(['zoom', clearZoom(samples.length, zoom)]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onHideError", function () {
      _this.props.callback(['stateError', undefined]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onShowWelcome", function () {
      _this.props.onShowWelcome(true);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onHideWelcome", function () {
      _this.props.onShowWelcome(false);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onZoomOut", function () {
      var _this$props$state2 = _this.props.state,
          samples = _this$props$state2.samples,
          zoom = _this$props$state2.zoom;
      gaEvents('spreadsheet', 'zoom', 'out');

      _this.props.callback(['zoom', zoomOut(samples.length, zoom)]);

      _this.props.callback(['enableTransition', false]);
    });
    return _this;
  }

  (0, _createClass2["default"])(Application, [{
    key: "componentDidUpdate",
    //	onPerf = () => {
    //		if (this.perf) {
    //			this.perf = false;
    //			console.log('stop perf');
    //			Perf.stop();
    //			var m = Perf.getLastMeasurements();
    //			console.log('inclusive');
    //			Perf.printInclusive(m);
    //			console.log('exclusive');
    //			Perf.printExclusive(m);
    //			console.log('wasted');
    //			Perf.printWasted(m);
    //		} else {
    //			this.perf = true;
    //			console.log('start perf');
    //			Perf.start();
    //		}
    //	}
    value: function componentDidUpdate() {
      var _this$props = this.props,
          getState = _this$props.getState,
          onImport = _this$props.onImport,
          onNavigate = _this$props.onNavigate,
          isPublic = _this$props.state.isPublic; // nested render to different DOM tree

      (0, _nav["default"])({
        isPublic: isPublic,
        getState: getState,
        onImport: onImport,
        onNavigate: onNavigate,
        activeLink: 'heatmap'
      });
    }
  }, {
    key: "render",
    //	onSearchIDAndFilterColumn = (qsamplesList) => {
    //		var {state: {samples, cohortSamples}} = this.props,
    //			qsampleListObj = {},
    //			cohortSamplesList = [];
    //
    //		_.map(qsamplesList, (s, i)=>{
    //			qsampleListObj[s] = i + 1;
    //		});
    //		cohortSamplesList = _.flatten(_.map(Object.keys(cohortSamples), i => cohortSamples[i]));
    //
    //		var matches = _.filter(samples, s => qsampleListObj[cohortSamplesList[s]]),
    //			fieldLabel = matches.length + ((matches.length === 1) ? ' match' : ' matches');
    //		this.onFilterColumn(matches, 'sample list', fieldLabel);
    //	};
    value: function render() {
      var _this$props2 = this.props,
          state = _this$props2.state,
          stateError = _this$props2.stateError,
          children = _this$props2.children,
          stepperState = _this$props2.stepperState,
          loadPending = _this$props2.loadPending,
          otherProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["state", "stateError", "children", "stepperState", "loadPending"]),
          callback = otherProps.callback,
          editing = state.editing,
          wizardMode = state.wizardMode,
          showWelcome = state.showWelcome,
          zoom = state.zoom; //			onSearchIDAndFilterColumn = this.onSearchIDAndFilterColumn;

      if (loadPending) {
        return /*#__PURE__*/_react["default"].createElement("p", {
          style: {
            margin: 10
          }
        }, "Loading your view...");
      }

      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
        style: {
          position: 'relative'
        }
      }, " ", showWelcome ? /*#__PURE__*/_react["default"].createElement(_WelcomeContainer["default"], {
        onClick: this.onHideWelcome
      }) : null, wizardMode ? /*#__PURE__*/_react["default"].createElement(_Stepper.Stepper, {
        mode: stepperState,
        steps: stepperSteps,
        stateIndex: stepperStateIndex
      }) : /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_AppControls.AppControls, (0, _extends2["default"])({}, otherProps, {
        appState: state,
        help: searchHelp,
        zoom: zoom,
        onShowWelcome: this.onShowWelcome
      })), /*#__PURE__*/_react["default"].createElement(_SheetControls["default"], {
        actionsDisabled: true,
        appState: state,
        clearZoom: this.onClearZoom,
        statusDisabled: editing !== null,
        zoom: zoom,
        zoomOut: this.onZoomOut
      })), /*#__PURE__*/_react["default"].createElement(_reactMaterialResponsiveGrid.Grid, {
        onClick: this.onClick
      }, /*#__PURE__*/_react["default"].createElement(_reactMaterialResponsiveGrid.Row, null, /*#__PURE__*/_react["default"].createElement(_reactMaterialResponsiveGrid.Col, {
        xs4: 4,
        style: {
          position: 'relative'
        }
      }, children))), _.getIn(state, ['km', 'id']) ? /*#__PURE__*/_react["default"].createElement(_KmPlot.KmPlot, {
        callback: callback,
        survivalKeys: _.keys(state.survival),
        km: state.km,
        cohort: state.cohort.name
      }) : null, stateError ? /*#__PURE__*/_react["default"].createElement(_StateError.StateError, {
        onHide: this.onHideError,
        error: stateError
      }) : null));
    }
  }]);
  return Application;
}(_react.Component);

var ThemedApplication = function ThemedApplication(props) {
  return /*#__PURE__*/_react["default"].createElement(_reactCssThemr.ThemeProvider, {
    theme: _appTheme["default"]
  }, /*#__PURE__*/_react["default"].createElement(Application, props));
};

module.exports = ThemedApplication;