var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

var _slicedToArray = require("@babel/runtime/helpers/slicedToArray");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var tickPadding = 3;

function horzLayout(domain, range, scale, tickfn, tickHeight) {
  return tickfn.apply(null, domain).map(function (x) {
    return [[scale(x), 0], [0, tickHeight], [0, tickHeight + tickPadding], x.toLocaleString(), 'middle', '.71em'];
  });
}

function vertLayout(domain, range, scale, tickfn, tickHeight) {
  return tickfn.apply(null, domain).map(function (y) {
    return [[0, scale(y)], [-tickHeight, 0], [-(tickHeight + tickPadding), 0], y.toLocaleString(), 'end', '.32em'];
  });
}

var layout = {
  bottom: horzLayout,
  left: vertLayout
};
var domainPath = {
  bottom: function bottom(_ref, height) {
    var _ref2 = _slicedToArray(_ref, 2),
        start = _ref2[0],
        end = _ref2[1];

    return "M".concat(start, ",").concat(height, "V0H").concat(end, "V").concat(height);
  },
  left: function left(_ref3, height) {
    var _ref4 = _slicedToArray(_ref3, 2),
        start = _ref4[0],
        end = _ref4[1];

    return "M".concat(-height, ",").concat(start, "H0V").concat(end, "H").concat(-height);
  }
};

var Axis = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(Axis, _React$Component);

  var _super = _createSuper(Axis);

  function Axis() {
    _classCallCheck(this, Axis);

    return _super.apply(this, arguments);
  }

  _createClass(Axis, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          domain = _this$props.domain,
          range = _this$props.range,
          scale = _this$props.scale,
          tickfn = _this$props.tickfn,
          orientation = _this$props.orientation,
          _this$props$groupProp = _this$props.groupProps,
          groupProps = _this$props$groupProp === void 0 ? {} : _this$props$groupProp,
          _this$props$tickHeigh = _this$props.tickHeight,
          tickHeight = _this$props$tickHeigh === void 0 ? 6 : _this$props$tickHeigh;
      var ticks = layout[orientation](domain, range, scale, tickfn, tickHeight);
      return /*#__PURE__*/React.createElement("g", groupProps, /*#__PURE__*/React.createElement("path", {
        className: "domain",
        d: domainPath[orientation](range, tickHeight)
      }), ticks.map(function (_ref5, i) {
        var _ref6 = _slicedToArray(_ref5, 6),
            _ref6$ = _slicedToArray(_ref6[0], 2),
            x = _ref6$[0],
            y = _ref6$[1],
            _ref6$2 = _slicedToArray(_ref6[1], 2),
            dx = _ref6$2[0],
            dy = _ref6$2[1],
            _ref6$3 = _slicedToArray(_ref6[2], 2),
            lx = _ref6$3[0],
            ly = _ref6$3[1],
            label = _ref6[3],
            anchor = _ref6[4],
            off = _ref6[5];

        return /*#__PURE__*/React.createElement("g", {
          key: i,
          transform: "translate(".concat(x, ", ").concat(y, ")")
        }, /*#__PURE__*/React.createElement("line", {
          x2: dx,
          y2: dy
        }), /*#__PURE__*/React.createElement("text", {
          dy: off,
          y: ly,
          x: lx,
          style: {
            textAnchor: anchor
          }
        }, label));
      }), this.props.children);
    }
  }]);

  return Axis;
}(React.Component);

module.exports = Axis;