var _extends = require("@babel/runtime/helpers/extends");

var _objectWithoutProperties = require("@babel/runtime/helpers/objectWithoutProperties");

var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _assertThisInitialized = require("@babel/runtime/helpers/assertThisInitialized");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

var _defineProperty = require("@babel/runtime/helpers/defineProperty");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

// React component to manages redrawing a canvas element.
var _ = require('./underscore_ext')["default"];

var vgmixed = require('./vgmixed');

var React = require('react');

var ReactDOM = require('react-dom'); // Styles


var compStyles = require('./CanvasDrawing.module.css');

var classNames = require('classnames');

var CanvasDrawing = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(CanvasDrawing, _React$Component);

  var _super = _createSuper(CanvasDrawing);

  function CanvasDrawing() {
    var _this;

    _classCallCheck(this, CanvasDrawing);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "setHeight", function (height) {
      _this.vg.height(height);

      _this.refs.div.style.height = "".concat(height, "px");
      _this.refs.labels.style.height = "".concat(height, "px");
      _this.refs.labels.style.top = "-".concat(height, "px");
    });

    _defineProperty(_assertThisInitialized(_this), "setWidth", function (width) {
      _this.vg.width(width);

      _this.refs.div.style.width = "".concat(width, "px");
      _this.refs.labels.style.width = "".concat(width, "px");
    });

    _defineProperty(_assertThisInitialized(_this), "draw", function (props) {
      var draw = props.draw,
          drawProps = _objectWithoutProperties(props, ["draw"]),
          zoom = drawProps.zoom,
          width = drawProps.width,
          height = zoom.height,
          vg = _this.vg;

      if (vg.width() !== width) {
        _this.setWidth(width);
      }

      if (vg.height() !== height) {
        _this.setHeight(height);
      }

      draw(vg, drawProps);
    });

    return _this;
  }

  _createClass(CanvasDrawing, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(newProps) {
      if (this.vg && !_.isEqual(newProps, this.props)) {
        this.draw(newProps);
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      return false;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          width = _this$props.width,
          height = _this$props.zoom.height,
          wrapperProps = _this$props.wrapperProps,
          _ref = wrapperProps || {},
          className = _ref.className,
          props = _objectWithoutProperties(_ref, ["className"]),
          classes = classNames(className, compStyles.wrapper); // Must add tooltip class, if specified in props


      return /*#__PURE__*/React.createElement("div", _extends({
        ref: "div"
      }, props, {
        className: classes,
        style: {
          width: width,
          height: height
        }
      }), /*#__PURE__*/React.createElement("canvas", {
        className: compStyles.canvas,
        ref: "canvas"
      }), /*#__PURE__*/React.createElement("div", {
        className: compStyles.labels,
        style: {
          top: -height,
          width: width,
          height: height
        },
        ref: "labels"
      }));
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props2 = this.props,
          width = _this$props2.width,
          height = _this$props2.zoom.height;
      this.vg = vgmixed(ReactDOM.findDOMNode(this.refs.canvas), width, height, ReactDOM.findDOMNode(this.refs.labels));
      this.draw(this.props);
    }
  }]);

  return CanvasDrawing;
}(React.Component);

module.exports = CanvasDrawing;