"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

// React component to manages redrawing a canvas element.
var _ = require('./underscore_ext')["default"];

var vgcanvas = require('./vgcanvas');

var React = require('react');

var ReactDOM = require('react-dom'); // This is a quick hack to work around the very different styling requirements
// of BandLegend, vs. the other canvas elements we have. Here we never change
// the pixel buffer size, but manipulate the canvas css size to scale over
// resize. The main point of this is that the size of the canvas width is
// driven by the css, so we're not holding the final width when we draw.


var CanvasDrawing = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(CanvasDrawing, _React$Component);

  var _super = _createSuper(CanvasDrawing);

  function CanvasDrawing() {
    var _this;

    (0, _classCallCheck2["default"])(this, CanvasDrawing);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setHeight", function (height) {
      _this.vg.height(height);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setWidth", function (width) {
      _this.vg.width(width);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "draw", function (props) {
      var draw = props.draw,
          drawProps = (0, _objectWithoutProperties2["default"])(props, ["draw"]),
          zoom = drawProps.zoom,
          width = drawProps.width,
          height = zoom.height,
          vg = _this.vg;

      if (vg.width() !== width) {
        _this.setWidth(width);
      }

      if (vg.height() !== height) {
        _this.setHeight(height);
      }

      draw(vg, drawProps);
    });
    return _this;
  }

  (0, _createClass2["default"])(CanvasDrawing, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(newProps) {
      if (this.vg && !_.isEqual(newProps, this.props)) {
        this.draw(newProps);
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      return false;
    }
  }, {
    key: "render",
    value: function render() {
      var style = this.props.style;
      return /*#__PURE__*/React.createElement("canvas", {
        style: style,
        ref: "canvas"
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          width = _this$props.width,
          height = _this$props.zoom.height;
      this.vg = vgcanvas(ReactDOM.findDOMNode(this.refs.canvas), width, height);
      this.draw(this.props);
    }
  }]);
  return CanvasDrawing;
}(React.Component);

var _default = CanvasDrawing;
exports["default"] = _default;