var _slicedToArray = require("@babel/runtime/helpers/slicedToArray");

var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _assertThisInitialized = require("@babel/runtime/helpers/assertThisInitialized");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

var _defineProperty = require("@babel/runtime/helpers/defineProperty");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var ReactDOM = require('react-dom');

var vgcanvas = require('./vgcanvas');

var addCommas = require('./util')["default"].addCommas;

var labelHeight = 12;
var font = 10;

function metric(n) {
  var str = String(n);

  if (str.match(/000000$/)) {
    str = str.replace(/000000$/, 'Mb');
  } else if (str.match(/000$/)) {
    str = str.replace(/000$/, 'kb');
  } else {
    str = str + 'bp';
  }

  return str;
}

function pickRange(size) {
  return Math.pow(10, Math.floor(Math.log(size) / Math.log(10)));
}

function abrev(n) {
  var s = String(n);
  return {
    1: function _(s) {
      return s;
    },
    2: function _(s) {
      return s;
    },
    3: function _(s) {
      return s;
    },
    4: function _(s) {
      return "".concat(s[0], ".").concat(s[1], "k");
    },
    5: function _(s) {
      return "".concat(s.slice(0, 2), "k");
    },
    6: function _(s) {
      return "".concat(s.slice(0, 3), "k");
    },
    7: function _(s) {
      return "".concat(s[0], ".").concat(s[1], "M");
    },
    8: function _(s) {
      return "".concat(s.slice(0, 2), "M");
    },
    9: function _(s) {
      return "".concat(s.slice(0, 3), "M");
    }
  }[s.length](s);
}

function numberOrAbrev(vg, width, font, n) {
  var s = addCommas(n),
      w = vg.textWidth(font, s + ' '); // pad with one space

  return w > width ? abrev(n) : s;
}

var margin = 8;

var ChromPosition = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(ChromPosition, _React$Component);

  var _super = _createSuper(ChromPosition);

  function ChromPosition() {
    var _this;

    _classCallCheck(this, ChromPosition);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "draw", function (width, height, layout) {
      var mode = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "coordinate";
      var vg = _this.vg;

      if (vg.width() !== width) {
        vg.width(width);
      }

      vg.box(0, 0, width, height, 'white'); // white background

      if (!layout) {
        return;
      }

      if (mode === "geneExon") {
        vg.text(margin, height - 4, 'black', font, "5'");
        vg.text(width - margin - vg.textWidth(font, "3'"), height - 4, 'black', font, "3'");
      } else {
        var _layout$chrom$ = _slicedToArray(layout.chrom[0], 2),
            baseStart = _layout$chrom$[0],
            baseEnd = _layout$chrom$[1],
            _layout$screen$ = _slicedToArray(layout.screen[0], 2),
            pixelStart = _layout$screen$[0],
            pixelEnd = _layout$screen$[1],
            pixelWidth = pixelEnd - pixelStart,
            baseWidth = baseEnd - baseStart + 1,
            range = pickRange(baseWidth / 2),
            rangeWidth = pixelWidth * range / baseWidth,
            startText = numberOrAbrev(vg, width / 4, font, baseStart),
            endText = numberOrAbrev(vg, width / 4, font, baseEnd),
            rangeText = metric(range),
            rangeTextWidth = vg.textWidth(font, rangeText),
            pushLeft = Math.max(width - rangeTextWidth - rangeWidth - 1, 0),
            rangePos = Math.min(pushLeft, (pixelWidth - rangeWidth) / 2);

        if (mode === "geneIntron") {
          startText = "5'";
          endText = "3'";
        }

        var gap = width / 2 - margin - rangeWidth / 2 - vg.textWidth(font, endText); // Render start & end position, abreviating if constrained for width.

        if (mode === "coordinate" || gap > vg.textWidth(font, rangeText)) {
          vg.text(pixelStart + margin, height - 4, 'black', font, startText); // start position at left

          vg.text(pixelEnd - margin - vg.textWidth(font, endText), height - 4, 'black', font, endText); // end position at right
        }

        if (mode === 'geneIntron' || gap > vg.textWidth(font, rangeText)) {
          if (range >= 1) {
            // Render centered scale, pushing to left if constrained for width.
            vg.box(rangePos, labelHeight / 2, rangeWidth, 1, 'grey');
            vg.box(rangePos, labelHeight / 4, 1, labelHeight / 2, 'black');
            vg.box(rangePos + rangeWidth, labelHeight / 4, 1, labelHeight / 2, 'black');
            vg.text(rangePos + rangeWidth + 1, labelHeight - font / 4, 'black', font, rangeText);
          } else {
            vg.text((width - rangeWidth) / 2, labelHeight - font / 4, 'black', font, '1bp');
          }
        }
      }
    });

    return _this;
  }

  _createClass(ChromPosition, [{
    key: "componentDidMount",
    //shouldComponentUpdate: () => false,
    value: function componentDidMount() {
      var _this$props = this.props,
          width = _this$props.width,
          layout = _this$props.layout,
          scaleHeight = _this$props.scaleHeight,
          mode = _this$props.mode;
      this.vg = vgcanvas(ReactDOM.findDOMNode(this.refs.canvas), width, scaleHeight);
      this.draw(width, scaleHeight, layout, mode);
    }
    /*componentWillReceiveProps() {
    	var {width, layout, scaleHeight, mode} = this.props;
    	this.draw(width, scaleHeight, layout, mode);
    },*/

  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          width = _this$props2.width,
          layout = _this$props2.layout,
          scaleHeight = _this$props2.scaleHeight,
          mode = _this$props2.mode;

      if (this.vg) {
        this.draw(width, scaleHeight, layout, mode);
      }

      return /*#__PURE__*/React.createElement("canvas", {
        className: "Tooltip-target",
        onMouseMove: this.props.onMouseMove,
        onMouseOut: this.props.onMouseOut,
        onMouseOver: this.props.onMouseOver,
        onClick: this.props.onClick,
        ref: "canvas"
      });
    }
  }]);

  return ChromPosition;
}(React.Component);

module.exports = {
  ChromPosition: ChromPosition,
  abrev: abrev
};