"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _link = _interopRequireDefault(require("react-toolbox/lib/link"));

var _nav = _interopRequireDefault(require("./nav"));

var _checkbox = require("react-toolbox/lib/checkbox");

var _button = require("react-toolbox/lib/button");

var _dialog = _interopRequireDefault(require("react-toolbox/lib/dialog"));

var _urlParams = require("./urlParams");

var _reactCssThemr = require("react-css-themr");

var _PureComponent3 = _interopRequireDefault(require("./PureComponent"));

var _LaunchHelper = _interopRequireDefault(require("./LaunchHelper"));

var _xss = _interopRequireDefault(require("./xss"));

var _class, _temp, _temp2;

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

require('./base');

var React = require('react');

var _require$default = require('./underscore_ext')["default"],
    uniq = _require$default.uniq,
    flatten = _require$default.flatten,
    sortBy = _require$default.sortBy,
    groupBy = _require$default.groupBy,
    map = _require$default.map,
    flatmap = _require$default.flatmap,
    partitionN = _require$default.partitionN,
    mapObject = _require$default.mapObject,
    contains = _require$default.contains,
    get = _require$default.get,
    updateIn = _require$default.updateIn,
    range = _require$default.range,
    Let = _require$default.Let,
    pick = _require$default.pick,
    zip = _require$default.zip,
    identity = _require$default.identity,
    getIn = _require$default.getIn,
    sum = _require$default.sum,
    keys = _require$default.keys,
    values = _require$default.values,
    mmap = _require$default.mmap;

var _require$default2 = require('./rx')["default"],
    from = _require$default2.Observable.from,
    animationFrame = _require$default2.Scheduler.animationFrame;

var _require = require('./xenaQuery'),
    parseDsID = _require.parseDsID;

var styles = require('./Datapages.module.css');

var showdown = require('showdown');

var _require2 = require('./dom_helper'),
    stripHTML = _require2.stripHTML;

var treehouseImg = require('../images/Treehouse.jpg');

var _require3 = require('./react-utils'),
    rxEvents = _require3.rxEvents;

var _require4 = require('./defaultServers'),
    localHub = _require4.servers.localHub,
    serverNames = _require4.serverNames;

var _require$default3 = require('./util')["default"],
    encodeObject = _require$default3.encodeObject,
    urlParams = _require$default3.urlParams;

var appTheme = require('./appTheme');

var classNames = require('classnames');

var _require5 = require('./hubParams'),
    getHubParams = _require5.getHubParams;

var getHubName = function getHubName(host) {
  return get(serverNames, host, host);
};

var isLocalHub = function isLocalHub(host) {
  return host === localHub;
};

var pluralize = function pluralize(str, count) {
  return count === 1 ? "1 ".concat(str) : "".concat(count, " ").concat(str, "s");
}; // Get params from the anchor href. With RT Link, the anchor is parentElement.


var paramFromHref = function paramFromHref(ev) {
  return mapObject(urlParams(ev.target.parentElement.href), function (a) {
    return a[0];
  });
}; //
// event handler for navigating within datapages. Prevents page load, and
// sets url params.
//


function navHandler(ev) {
  ev.preventDefault();
  this.props.callback(['navigate', 'datapages', paramFromHref(ev, this.props.state)]);
}

var getUserServers = function getUserServers(servers) {
  return keys(servers).filter(function (k) {
    return servers[k].user;
  });
}; //
// Data hubs sidebar
//


var hubLink = function hubLink(host, onClick, hubParams) {
  return /*#__PURE__*/React.createElement(_link["default"], {
    className: classNames(styles.link, styles.checkboxLink),
    href: '?' + encodeObject(_objectSpread({
      host: host
    }, hubParams)),
    label: getHubName(host),
    onClick: onClick
  });
};

var DataHubs = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(DataHubs, _React$Component);

  var _super = _createSuper(DataHubs);

  function DataHubs() {
    var _this;

    (0, _classCallCheck2["default"])(this, DataHubs);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onHub", function (ev) {
      navHandler.call((0, _assertThisInitialized2["default"])(_this), ev);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSelect", function (isOn, ev) {
      var checked = ev.target.checked,
          host = ev.target.getAttribute('data-host');

      _this.props.callback([checked ? 'enable-host' : 'disable-host', host, 'user']);
    });
    return _this;
  }

  (0, _createClass2["default"])(DataHubs, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          hubParams = _this$props.hubParams,
          servers = _this$props.state.spreadsheet.servers;
      return /*#__PURE__*/React.createElement("div", {
        className: styles.dataHubs
      }, /*#__PURE__*/React.createElement("h2", null, "Active Data Hubs"), /*#__PURE__*/React.createElement("ul", null, map(servers, function (_ref, host) {
        var user = _ref.user;
        return /*#__PURE__*/React.createElement("li", {
          key: host
        }, /*#__PURE__*/React.createElement(_checkbox.Checkbox, {
          label: hubLink(host, _this2.onHub, hubParams),
          onChange: _this2.onSelect,
          checked: user,
          "data-host": host
        }));
      })));
    }
  }]);
  return DataHubs;
}(React.Component); //
// Cohort Summary Page
//


var treehouse = function treehouse(cohort) {
  return cohort.search(/^Treehouse/gi) === -1 ? null : /*#__PURE__*/React.createElement("img", {
    src: treehouseImg,
    height: "40px"
  });
};

var cohortLink = function cohortLink(cohort, onClick, hubParams) {
  return /*#__PURE__*/React.createElement(_link["default"], {
    className: styles.link,
    href: '?' + encodeObject(_objectSpread({
      cohort: cohort
    }, hubParams)),
    label: cohort,
    onClick: onClick
  });
};

var collateCohorts = function collateCohorts(hubCohorts) {
  return flatten(values(hubCohorts)).reduce(function (acc, cohort) {
    return cohort.cohort ? updateIn(acc, [cohort.cohort], function () {
      var v = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      return cohort.count + v;
    }) : acc;
  }, {});
};

var CohortSummary = function CohortSummary(_ref2) {
  var cohorts = _ref2.cohorts,
      onCohort = _ref2.onCohort,
      hubParams = _ref2.hubParams,
      action = _ref2.action;
  var names = sortBy(keys(cohorts), function (c) {
    return c.toLowerCase();
  }),
      nCohorts = names.length,
      nDatasets = sum(values(cohorts));
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("h2", null, pluralize('Cohort', nCohorts), ", ", pluralize('Dataset', nDatasets), " ", action), /*#__PURE__*/React.createElement("ul", {
    className: styles.list
  }, map(names, function (name) {
    return /*#__PURE__*/React.createElement("li", {
      key: name
    }, treehouse(name), cohortLink(name, onCohort, hubParams), " (".concat(pluralize('dataset', cohorts[name]), ")"));
  })));
};

var CohortHeader = function CohortHeader(_ref3) {
  var inHubs = _ref3.inHubs,
      host = _ref3.host,
      onImport = _ref3.onImport,
      badge = _ref3.badge;
  var localHubUp = getIn(badge, ['props', 'title']) === "Connected to local Xena Hub";
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("h2", {
    className: styles.inline
  }, getHubName(host), inHubs, badge), isLocalHub(host) && /*#__PURE__*/React.createElement("div", {
    className: styles.headerButtons
  }, localHubUp ? /*#__PURE__*/React.createElement(_button.Button, {
    label: "Load Data",
    onClick: onImport,
    accent: true
  }) : null, /*#__PURE__*/React.createElement(_button.Button, {
    label: "Help",
    target: "_blank",
    href: "https://ucsc-xena.gitbook.io/project/local-xena-hub",
    accent: true
  })), isLocalHub(host) ? null : /*#__PURE__*/React.createElement("p", null, "Hub address: ", host), isLocalHub(host) && /*#__PURE__*/React.createElement("div", {
    className: styles.descriptionBox
  }, /*#__PURE__*/React.createElement("p", null, "A Local Xena Hub is an application on your computer for loading and storing data."), /*#__PURE__*/React.createElement("p", null, "We support most types of genomic and/or phenotypic/clinical/annotation data. This data can be your own or from another source, such as a publication."), /*#__PURE__*/React.createElement("p", null, "Data on a Local Xena Hub can only be viewed or accessed by the same computer on which it is running.")));
};

var CohortSummaryPage = /*#__PURE__*/function (_React$Component2) {
  (0, _inherits2["default"])(CohortSummaryPage, _React$Component2);

  var _super2 = _createSuper(CohortSummaryPage);

  function CohortSummaryPage() {
    var _this3;

    (0, _classCallCheck2["default"])(this, CohortSummaryPage);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this3 = _super2.call.apply(_super2, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "onCohort", function (ev) {
      navHandler.call((0, _assertThisInitialized2["default"])(_this3), ev);
    });
    return _this3;
  }

  (0, _createClass2["default"])(CohortSummaryPage, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          hubParams = _this$props2.hubParams,
          state = _this$props2.state,
          servers = state.spreadsheet.servers,
          userServers = getUserServers(servers),
          cohorts = getIn(this.props.state, ['datapages', 'cohorts'], {}),
          activeCohorts = pick(cohorts, userServers),
          combined = collateCohorts(activeCohorts);
      return /*#__PURE__*/React.createElement("div", {
        className: styles.datapages
      }, /*#__PURE__*/React.createElement(DataHubs, this.props), /*#__PURE__*/React.createElement(CohortSummary, {
        hubParams: hubParams,
        cohorts: combined,
        onCohort: this.onCohort
      }));
    }
  }]);
  return CohortSummaryPage;
}(React.Component); //
// Dataset delete button
//


var DeleteButton = /*#__PURE__*/function (_React$Component3) {
  (0, _inherits2["default"])(DeleteButton, _React$Component3);

  var _super3 = _createSuper(DeleteButton);

  function DeleteButton() {
    var _this4;

    (0, _classCallCheck2["default"])(this, DeleteButton);

    for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    _this4 = _super3.call.apply(_super3, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this4), "state", {
      active: false
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this4), "onDelete", function () {
      _this4.setState({
        active: !_this4.state.active
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this4), "onReally", function () {
      var name = _this4.props.name;

      _this4.setState({
        active: false
      });

      _this4.props.callback(['delete-dataset', localHub, name]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this4), "actions", function () {
      return [{
        label: 'Cancel',
        onClick: _this4.onDelete
      }, {
        label: 'Really Delete',
        onClick: _this4.onReally
      }];
    });
    return _this4;
  }

  (0, _createClass2["default"])(DeleteButton, [{
    key: "render",
    value: function render() {
      var active = this.state.active,
          label = this.props.label;
      return /*#__PURE__*/React.createElement("div", {
        className: styles.deleteButton
      }, /*#__PURE__*/React.createElement(_dialog["default"], {
        actions: this.actions(),
        active: active,
        onEscKeyDown: this.onDelete,
        onOverlayClick: this.onDelete,
        title: "Delete dataset"
      }, label), /*#__PURE__*/React.createElement(_button.Button, {
        onClick: this.onDelete,
        accent: true
      }, "Delete"));
    }
  }]);
  return DeleteButton;
}(React.Component);

var canDelete = function canDelete(_ref4, host) {
  var status = _ref4.status;
  return host === localHub && contains(['loaded', 'error'], status);
};

var markdownValue = function markdownValue(value) {
  if (value && !value.error) {
    var converter = new showdown.Converter();
    return /*#__PURE__*/React.createElement("div", {
      className: styles.header,
      dangerouslySetInnerHTML: {
        __html: (0, _xss["default"])(converter.makeHtml(value))
      }
    });
  }
}; //
// Cohort Datasets Page
//


var datasetLink = function datasetLink(callback, preferred, onClick, hubParams) {
  return function (ds) {
    var _parseDsID = parseDsID(ds.dsID),
        _parseDsID2 = (0, _slicedToArray2["default"])(_parseDsID, 1),
        host = _parseDsID2[0];

    return /*#__PURE__*/React.createElement("li", {
      key: ds.name
    }, /*#__PURE__*/React.createElement(_link["default"], {
      className: styles.link,
      href: '?' + encodeObject(_objectSpread({
        dataset: ds.name,
        host: host
      }, hubParams)),
      label: ds.label,
      onClick: onClick
    }), preferred.has(ds.dsID) ? /*#__PURE__*/React.createElement("span", {
      className: styles.star
    }, "*") : null, ds.status !== 'loaded' ? /*#__PURE__*/React.createElement("span", {
      className: styles.count
    }, " [", ds.status, "]") : null, ds.status === 'loaded' ? /*#__PURE__*/React.createElement("span", {
      className: styles.count
    }, " (n=", (ds.count || 0).toLocaleString(), ")") : null, /*#__PURE__*/React.createElement("span", null, " ", getHubName(host)), canDelete(ds, host) ? /*#__PURE__*/React.createElement(DeleteButton, {
      callback: callback,
      name: ds.name,
      label: ds.label || ds.name
    }) : null, /*#__PURE__*/React.createElement("div", {
      className: styles.lineClamp
    }, /*#__PURE__*/React.createElement("span", {
      className: styles.description
    }, stripHTML(ds.description))));
  };
};

var drawGroup = function drawGroup(callback, groups, preferred, onClick, hubParams) {
  return function (dataSubType) {
    var list = sortBy(groups[dataSubType], function (g) {
      return g.label.toLowerCase();
    });
    return /*#__PURE__*/React.createElement("div", {
      key: dataSubType
    }, /*#__PURE__*/React.createElement("h3", null, dataSubType), /*#__PURE__*/React.createElement("ul", {
      className: styles.groupList
    }, map(list, datasetLink(callback, preferred, onClick, hubParams))));
  };
};

var COHORT_NULL = '(unassigned)';

var getPreferred = function getPreferred(wizard, cohort) {
  return new Set(values(getIn(wizard, ['cohortPreferred', cohort], {})));
};

var CohortPage = /*#__PURE__*/function (_React$Component4) {
  (0, _inherits2["default"])(CohortPage, _React$Component4);

  var _super4 = _createSuper(CohortPage);

  function CohortPage() {
    var _this5;

    (0, _classCallCheck2["default"])(this, CohortPage);

    for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
      args[_key4] = arguments[_key4];
    }

    _this5 = _super4.call.apply(_super4, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this5), "onViz", function () {
      var _this5$props$state = _this5.props.state,
          params = _this5$props$state.params,
          currentCohort = _this5$props$state.spreadsheet.cohort,
          cohort = params.cohort;

      if (cohort !== get(currentCohort, 'name')) {
        _this5.props.callback(['cohort', cohort]);
      }

      _this5.props.callback(['navigate', 'heatmap']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this5), "clickVizButton", function (ev) {
      if (ev.target.className === 'cohortButton') {
        ev.target.dataset.bookmark ? window.open("".concat(document.location.origin, "/?bookmark=").concat(ev.target.dataset.bookmark), "_self") : _this5.onViz();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this5), "onDataset", function (ev) {
      navHandler.call((0, _assertThisInitialized2["default"])(_this5), ev);
    });
    return _this5;
  }

  (0, _createClass2["default"])(CohortPage, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          hubParams = _this$props3.hubParams,
          callback = _this$props3.callback,
          _this$props3$state = _this$props3.state,
          datapages = _this$props3$state.datapages,
          spreadsheet = _this$props3$state.spreadsheet,
          cohort = _this$props3$state.params.cohort,
          wizard = _this$props3$state.wizard,
          servers = getUserServers(spreadsheet.servers),
          meta = getIn(datapages, ['cohort', cohort]),
          datasetsByHost = pick(getIn(datapages, ['cohortDatasets', cohort], {}), servers),
          datasets = flatten(values(datasetsByHost)),
          dsGroups = groupBy(values(datasets), 'dataSubType'),
          dataSubTypes = sortBy(keys(dsGroups), function (g) {
        return g.toLowerCase();
      }),
          preferred = getPreferred(wizard, cohort);
      return /*#__PURE__*/React.createElement("div", {
        className: styles.datapages,
        onClick: this.clickVizButton
      }, markdownValue(meta), /*#__PURE__*/React.createElement("div", {
        className: styles.sidebar
      }, /*#__PURE__*/React.createElement(_button.Button, {
        onClick: this.onViz,
        accent: true
      }, "Visualize")), /*#__PURE__*/React.createElement("h2", null, "cohort: ", treehouse(cohort), cohort), dataSubTypes.map(drawGroup(callback, dsGroups, preferred, this.onDataset, hubParams)), preferred.size === 0 ? null : /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement("span", {
        className: styles.star
      }, "*"), /*#__PURE__*/React.createElement("span", null, "default dataset in visualization")));
    }
  }]);
  return CohortPage;
}(React.Component); //
// Dataset Page
//


var TYPE_NULL = 'genomicMatrix',
    FORMAT_MAPPING = {
  'clinicalMatrix': "ROWs (samples)  x  COLUMNs (identifiers) (i.e. clinicalMatrix)",
  'genomicMatrix': "ROWs (identifiers)  x  COLUMNs (samples) (i.e. genomicMatrix)",
  'mutationVector': "Variant by Position (i.e. mutationVector)",
  'genomicSegment': 'Genomic Segment (i.e. genomicSegment)',
  'unknown': "unknown"
};

var dataPair = function dataPair(key, value) {
  var method = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : identity;
  return value == null ? [] : [/*#__PURE__*/React.createElement("span", {
    className: styles.key
  }, key), /*#__PURE__*/React.createElement("span", {
    className: styles.value
  }, method(value)), /*#__PURE__*/React.createElement("br", null)];
};

var toLink = function toLink(value) {
  return /*#__PURE__*/React.createElement("a", {
    href: value
  }, value);
};

var toCohortLink = function toCohortLink(onClick, hubParams) {
  return function (cohort) {
    return /*#__PURE__*/React.createElement(_link["default"], {
      href: '?' + encodeObject(_objectSpread({
        cohort: cohort
      }, hubParams)),
      onClick: onClick,
      label: cohort
    });
  };
};

var toPMIDLink = function toPMIDLink(value) {
  return /*#__PURE__*/React.createElement("a", {
    href: "http://www.ncbi.nlm.nih.gov/pubmed/?term=".concat(value.toString())
  }, value);
};

var jsonLink = function jsonLink(link) {
  return link.replace(/(.gz)?$/, '.json');
};

var toDownloadLink = function toDownloadLink(value) {
  return /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement("a", {
    href: value
  }, value), '; ', /*#__PURE__*/React.createElement("a", {
    href: jsonLink(value)
  }, "Full metadata"));
};

var toHTML = function toHTML(value) {
  return /*#__PURE__*/React.createElement("span", {
    dangerouslySetInnerHTML: {
      __html: (0, _xss["default"])(value)
    }
  });
};

var headerValue = function headerValue(value) {
  return value && /*#__PURE__*/React.createElement("p", {
    className: styles.header
  }, value);
};

var htmlValue = function htmlValue(value) {
  return value && /*#__PURE__*/React.createElement("p", {
    className: styles.header,
    dangerouslySetInnerHTML: {
      __html: (0, _xss["default"])(value)
    }
  });
}; // XXX Does not display load warning in pop-up
// XXX Does not use red/blue coloring for error vs. other load status (e.g. 'loading')


var getStatus = function getStatus(status, loaderWarning) {
  return status === 'loaded' && !loaderWarning ? [] : status === 'loaded' ? dataPair('status', 'loaded with warning') : dataPair('status', status);
}; // split, handling falsey values


var split = function split(str, pat) {
  return str ? str.split(pat) : [];
};

var resolveCodes = function resolveCodes(probes, codes, data) {
  return mmap(probes, data, function (probe, row) {
    return codes[probe] ? map(row, function (v) {
      return isNaN(v) ? v : codes[probe][v];
    }) : row;
  });
}; // not the most efficient algorithm :-/


var addHeaders = function addHeaders(fields, samples, data) {
  return mmap([''].concat((0, _toConsumableArray2["default"])(fields)), [samples].concat((0, _toConsumableArray2["default"])(data)), function (header, row) {
    return [header].concat((0, _toConsumableArray2["default"])(row));
  });
};

var transpose = function transpose(data) {
  return zip.apply(null, data);
}; // Transpose matrix if it's clinical


var transposeClinical = function transposeClinical(meta, data) {
  return get(meta, 'type') === 'clinicalMatrix' ? transpose(data) : data;
};

var table = function table(data) {
  return /*#__PURE__*/React.createElement("table", {
    className: styles.dataSnippetTable
  }, /*#__PURE__*/React.createElement("tbody", null, map(data, function (row, i) {
    return /*#__PURE__*/React.createElement("tr", {
      key: i
    }, map(row, function (c, j) {
      return /*#__PURE__*/React.createElement("td", {
        key: j
      }, c);
    }));
  })));
};

var matrixTable = function matrixTable(meta, _ref5) {
  var fields = _ref5.fields,
      samples = _ref5.samples,
      codes = _ref5.codes,
      data = _ref5.data;
  return table(transposeClinical(meta, addHeaders(fields, samples, resolveCodes(fields, codes, data))));
}; // swap chromend & chromstart when sorting fields


var cmpSparseFields = function cmpSparseFields(a, b) {
  return a === 'chromend' && b === 'chromstart' ? 1 : a === 'chromstart' && b === 'chromend' ? -1 : a.localeCompare(b);
};

var sparseTable = function sparseTable(meta, data) {
  var fields = keys(data).sort(cmpSparseFields),
      rows = fields.map(function (field) {
    return data[field];
  }),
      samples = data.sampleID;
  return table(transpose(addHeaders(fields, samples, rows)));
};

var noTable = function noTable() {
  return null;
};

var dataMethod = function dataMethod() {
  var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref6$type = _ref6.type,
      type = _ref6$type === void 0 ? 'genomicMatrix' : _ref6$type,
      status = _ref6.status;

  return status !== 'loaded' ? noTable : type === 'genomicMatrix' ? matrixTable : type === 'clinicalMatrix' ? matrixTable : type === 'mutationVector' ? sparseTable : type === 'genomicSegment' ? sparseTable : noTable;
};

var setKey = function setKey(arr) {
  return arr.map(function (el, i) {
    return React.cloneElement(el, {
      key: i
    });
  });
};

var DatasetPage = (0, _LaunchHelper["default"])(function (props) {
  return getIn(props, ['state', 'params', 'host']) === localHub;
}, (_temp = _class = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(_class, _PureComponent);

  var _super5 = _createSuper(_class);

  function _class() {
    var _this6;

    (0, _classCallCheck2["default"])(this, _class);

    for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
      args[_key5] = arguments[_key5];
    }

    _this6 = _super5.call.apply(_super5, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this6), "onCohort", function (ev) {
      navHandler.call((0, _assertThisInitialized2["default"])(_this6), ev);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this6), "onViz", function () {
      var _this6$props$state = _this6.props.state,
          _this6$props$state$pa = _this6$props$state.params,
          host = _this6$props$state$pa.host,
          dataset = _this6$props$state$pa.dataset,
          datapages = _this6$props$state.datapages,
          currentCohort = _this6$props$state.spreadsheet.cohort,
          cohort = getIn(datapages, ['dataset', host, dataset, 'meta', 'cohort'], COHORT_NULL);

      if (getIn(_this6.props.state, ['spreadsheet', 'servers', host, 'user']) !== true) {
        _this6.props.callback(['add-host', host]);
      }

      if (cohort !== get(currentCohort, 'name')) {
        _this6.props.callback(['cohort', cohort]);
      }

      _this6.props.callback(['navigate', 'heatmap']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this6), "onIdentifiers", function (ev) {
      navHandler.call((0, _assertThisInitialized2["default"])(_this6), ev);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this6), "onSamples", function (ev) {
      navHandler.call((0, _assertThisInitialized2["default"])(_this6), ev);
    });
    return _this6;
  }

  (0, _createClass2["default"])(_class, [{
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
          callback = _this$props4.callback,
          state = _this$props4.state,
          hubParams = _this$props4.hubParams,
          children = _this$props4.children,
          badge = _this$props4.badge,
          _state$params = state.params,
          host = _state$params.host,
          dataset = _state$params.dataset,
          datapages = state.datapages,
          _getIn = getIn(datapages, ['dataset', host, dataset], {}),
          meta = _getIn.meta,
          _getIn$probeCount = _getIn.probeCount,
          probeCount = _getIn$probeCount === void 0 ? 0 : _getIn$probeCount,
          data = _getIn.data,
          downloadLink = _getIn.downloadLink,
          probemapLink = _getIn.probemapLink,
          githubDescripton = getIn(datapages, ['datasetDescription', dataset], null);

      if (!meta) {
        return /*#__PURE__*/React.createElement("div", {
          className: styles.datapages
        }, children
        /* LaunchHelper */
        , /*#__PURE__*/React.createElement("h2", null, "dataset: ", dataset, "..."), /*#__PURE__*/React.createElement("h3", null, "hub: ", host, badge));
      }

      var name = meta.name,
          _meta$label = meta.label,
          label = _meta$label === void 0 ? name : _meta$label,
          description = meta.description,
          longTitle = meta.longTitle,
          _meta$cohort = meta.cohort,
          cohort = _meta$cohort === void 0 ? COHORT_NULL : _meta$cohort,
          dataSubType = meta.dataSubType,
          platform = meta.platform,
          unit = meta.unit,
          assembly = meta.assembly,
          version = meta.version,
          url = meta.url,
          articletitle = meta.articletitle,
          citation = meta.citation,
          pmid = meta.pmid,
          dataproducer = meta.dataproducer,
          _meta$author = meta.author,
          author = _meta$author === void 0 ? dataproducer : _meta$author,
          wranglingProcedure = meta['wrangling_procedure'],
          _meta$type = meta.type,
          type = _meta$type === void 0 ? TYPE_NULL : _meta$type,
          status = meta.status,
          loader = meta.loader,
          count = meta.count;
      return /*#__PURE__*/React.createElement("div", {
        className: styles.datapages
      }, children
      /* LaunchHelper */
      , /*#__PURE__*/React.createElement("div", {
        className: styles.sidebar
      }, /*#__PURE__*/React.createElement(_button.Button, {
        onClick: this.onViz,
        accent: true
      }, "Visualize"), canDelete(meta, host) ? /*#__PURE__*/React.createElement(DeleteButton, {
        callback: callback,
        name: name,
        label: label
      }) : null), /*#__PURE__*/React.createElement("h2", null, "dataset: ", (dataSubType ? dataSubType + ' - ' : '') + label), /*#__PURE__*/React.createElement("h3", null, "hub: ", host, badge), headerValue(longTitle), markdownValue(githubDescripton) || htmlValue(description), setKey(flatten([dataPair('cohort', cohort, toCohortLink(this.onCohort, hubParams)), dataPair('dataset ID', name), getStatus(status, loader), dataPair('download', downloadLink, toDownloadLink), dataPair('samples', count), dataPair('version', version), dataPair('type of data', dataSubType), dataPair('assembly', assembly), dataPair('unit', unit), dataPair('platform', platform), dataPair('ID/Gene Mapping', probemapLink, toDownloadLink), dataPair('publication', articletitle), dataPair('citation', citation), dataPair('author', author), dataPair('PMID', pmid, toPMIDLink), flatmap(uniq(split(url, /,/)), function (url) {
        return dataPair('raw data', url, toLink);
      }), dataPair('wrangling', wranglingProcedure, toHTML), dataPair('input data format', FORMAT_MAPPING[type])])), status === 'loaded' ? /*#__PURE__*/React.createElement("span", {
        className: styles.tableControls
      }, type === 'genomicMatrix' ? "".concat(probeCount.toLocaleString(), " identifiers X ").concat(count, " samples ") : null, type === 'clinicalMatrix' ? "".concat(count, " samples X ").concat(probeCount.toLocaleString(), " identifiers ") : null, /*#__PURE__*/React.createElement(_link["default"], {
        href: '?' + encodeObject(_objectSpread({
          host: host,
          dataset: dataset,
          allIdentifiers: true
        }, hubParams)),
        onClick: this.onIdentifiers,
        label: "All Identifiers"
      }), /*#__PURE__*/React.createElement(_link["default"], {
        href: '?' + encodeObject(_objectSpread({
          host: host,
          dataset: dataset,
          allSamples: true
        }, hubParams)),
        onClick: this.onSamples,
        label: "All Samples"
      })) : null, dataMethod(meta)(meta, data));
    }
  }]);
  return _class;
}(_PureComponent3["default"]), (0, _defineProperty2["default"])(_class, "displayName", 'DatasetPage'), _temp)); //
// Hub page
//

var HubPage = (0, _LaunchHelper["default"])(function (props) {
  return (0, _urlParams.defaultHost)(props.state.params).host === localHub;
}, (_temp2 = /*#__PURE__*/function (_PureComponent2) {
  (0, _inherits2["default"])(_temp2, _PureComponent2);

  var _super6 = _createSuper(_temp2);

  function _temp2() {
    var _this7;

    (0, _classCallCheck2["default"])(this, _temp2);

    for (var _len6 = arguments.length, args = new Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
      args[_key6] = arguments[_key6];
    }

    _this7 = _super6.call.apply(_super6, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this7), "onCohort", function (ev) {
      navHandler.call((0, _assertThisInitialized2["default"])(_this7), ev);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this7), "onImport", function () {
      _this7.props.callback(['reset-import-state']);

      _this7.props.callback(['navigate', 'import']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this7), "onViz", function (cohort) {
      if (!cohort) {
        return;
      }

      var currentCohort = _this7.props.state.spreadsheet.cohort;

      if (cohort !== get(currentCohort, 'name')) {
        _this7.props.callback(['cohort', cohort]);
      }

      _this7.props.callback(['navigate', 'heatmap']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this7), "clickVizButton", function (ev) {
      if (ev.target.className === 'hubButton') {
        _this7.onViz(ev.target.dataset.cohort);
      }
    });
    return _this7;
  }

  (0, _createClass2["default"])(_temp2, [{
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
          state = _this$props5.state,
          hubParams = _this$props5.hubParams,
          badge = _this$props5.badge,
          children = _this$props5.children,
          servers = state.spreadsheet.servers,
          userServers = getUserServers(servers),
          _defaultHost = (0, _urlParams.defaultHost)(state.params),
          host = _defaultHost.host,
          hubCohorts = getIn(state, ['datapages', 'cohorts', host], []),
          coll = collateCohorts(hubCohorts),
          inHubs = contains(userServers, host) ? '' : ' (not in my data hubs)';

      if (!contains(userServers, host)) {
        this.props.callback(['add-host', host]);
      }

      return /*#__PURE__*/React.createElement("div", {
        className: styles.datapages,
        onClick: this.clickVizButton
      }, children
      /* LaunchHelper */
      , markdownValue(getIn(state, ['datapages', 'hubMeta', host])), /*#__PURE__*/React.createElement(CohortHeader, {
        inHubs: inHubs,
        host: host,
        onImport: this.onImport,
        badge: badge
      }), /*#__PURE__*/React.createElement(CohortSummary, {
        hubParams: hubParams,
        cohorts: coll,
        onCohort: this.onCohort
      }));
    }
  }]);
  return _temp2;
}(_PureComponent3["default"]), _temp2)); //
// Samples / Identifiers page
//

var binSize = 1000; // The point of ListPage is to render a potentially very long list
// incrementally, so we get a fast first render, and don't lock up the UI.
// We do that by rendering binSize rows at a time, on a requestAnimationFrame
// timeout.

var ListPage = /*#__PURE__*/function (_React$Component5) {
  (0, _inherits2["default"])(ListPage, _React$Component5);

  var _super7 = _createSuper(ListPage);

  function ListPage() {
    var _this8;

    (0, _classCallCheck2["default"])(this, ListPage);

    for (var _len7 = arguments.length, args = new Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
      args[_key7] = arguments[_key7];
    }

    _this8 = _super7.call.apply(_super7, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this8), "state", {});
    return _this8;
  }

  (0, _createClass2["default"])(ListPage, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this9 = this;

      var events = rxEvents(this, 'list');
      var chunks = events.list.startWith(this.props.list).distinctUntilChanged().filter(identity).switchMap(function (ids) {
        var chunks = partitionN(ids, binSize).map(function (a) {
          return a.join('\n');
        });
        return from(range(chunks.length), animationFrame).map(function (i) {
          return {
            chunks: chunks.slice(0, i + 1),
            total: chunks.length
          };
        });
      });
      this.sub = chunks.subscribe(function (chunks) {
        _this9.setState(chunks);
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.sub.unsubscribe();
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(props) {
      this.on.list(props.list);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props6 = this.props,
          dataset = _this$props6.dataset,
          title = _this$props6.title,
          _this$state = this.state,
          chunks = _this$state.chunks,
          total = _this$state.total,
          percent = !chunks ? ' 0%' : chunks.length === total ? '' : " ".concat(Math.floor(chunks.length / total * 100), "%");
      return /*#__PURE__*/React.createElement("div", {
        className: styles.datapages
      }, /*#__PURE__*/React.createElement("h3", null, "dataset: ", dataset), /*#__PURE__*/React.createElement("h4", null, title, percent), chunks ? chunks.map(function (c, i) {
        return /*#__PURE__*/React.createElement("pre", {
          key: i,
          className: styles.list
        }, c);
      }) : 'Loading...');
    }
  }]);
  return ListPage;
}(React.Component);

var markdownPage = /*#__PURE__*/function (_React$Component6) {
  (0, _inherits2["default"])(markdownPage, _React$Component6);

  var _super8 = _createSuper(markdownPage);

  function markdownPage() {
    (0, _classCallCheck2["default"])(this, markdownPage);
    return _super8.apply(this, arguments);
  }

  (0, _createClass2["default"])(markdownPage, [{
    key: "render",
    value: function render() {
      var state = this.props.state,
          content = getIn(state, ['datapages', 'markdown', state.params.markdown]);
      return /*#__PURE__*/React.createElement("div", {
        className: styles.datapages
      }, markdownValue(content));
    }
  }]);
  return markdownPage;
}(React.Component);

var IdentifiersPage = function IdentifiersPage(props) {
  return Let(function () {
    var _ref7 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : props,
        _ref7$state$params = _ref7.state.params,
        host = _ref7$state$params.host,
        dataset = _ref7$state$params.dataset;

    return /*#__PURE__*/React.createElement(ListPage, {
      title: "Identifiers",
      dataset: dataset,
      list: getIn(props.state, ['datapages', 'identifiers', host, dataset])
    });
  });
};

var SamplesPage = function SamplesPage(props) {
  return Let(function () {
    var _ref8 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : props,
        _ref8$state$params = _ref8.state.params,
        host = _ref8$state$params.host,
        dataset = _ref8$state$params.dataset;

    return /*#__PURE__*/React.createElement(ListPage, {
      title: "Samples",
      dataset: dataset,
      list: getIn(props.state, ['datapages', 'samples', host, dataset])
    });
  });
}; //
// Top-level dispatch to sub-pages
//


var getPage = function getPage(_ref9) {
  var dataset = _ref9.dataset,
      host = _ref9.host,
      cohort = _ref9.cohort,
      allIdentifiers = _ref9.allIdentifiers,
      allSamples = _ref9.allSamples,
      markdown = _ref9.markdown;
  return markdown ? markdownPage : allSamples ? SamplesPage : allIdentifiers ? IdentifiersPage : dataset && host ? DatasetPage : host ? HubPage : cohort ? CohortPage : CohortSummaryPage;
};

var Datapages = /*#__PURE__*/function (_React$Component7) {
  (0, _inherits2["default"])(Datapages, _React$Component7);

  var _super9 = _createSuper(Datapages);

  function Datapages() {
    var _this10;

    (0, _classCallCheck2["default"])(this, Datapages);

    for (var _len8 = arguments.length, args = new Array(_len8), _key8 = 0; _key8 < _len8; _key8++) {
      args[_key8] = arguments[_key8];
    }

    _this10 = _super9.call.apply(_super9, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this10), "onNavigate", function (page, params) {
      _this10.props.callback(['navigate', page, params]);
    });
    return _this10;
  }

  (0, _createClass2["default"])(Datapages, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      (0, _nav["default"])({
        activeLink: 'datapages',
        onNavigate: this.onNavigate
      });
    }
  }, {
    key: "render",
    value: function render() {
      var state = this.props.state,
          params = state.params,
          hubParams = getHubParams(state),
          Page = getPage((0, _urlParams.defaultHost)(params));
      return /*#__PURE__*/React.createElement(Page, (0, _extends2["default"])({}, this.props, {
        hubParams: hubParams
      }));
    }
  }]);
  return Datapages;
}(React.Component);

var ThemedDatapages = /*#__PURE__*/function (_React$Component8) {
  (0, _inherits2["default"])(ThemedDatapages, _React$Component8);

  var _super10 = _createSuper(ThemedDatapages);

  function ThemedDatapages() {
    (0, _classCallCheck2["default"])(this, ThemedDatapages);
    return _super10.apply(this, arguments);
  }

  (0, _createClass2["default"])(ThemedDatapages, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(_reactCssThemr.ThemeProvider, {
        theme: appTheme
      }, /*#__PURE__*/React.createElement(Datapages, this.props));
    }
  }]);
  return ThemedDatapages;
}(React.Component);

var selector = function selector(state) {
  return state;
};

var _default = function _default(props) {
  return /*#__PURE__*/React.createElement(ThemedDatapages, (0, _extends2["default"])({}, props, {
    selector: selector
  }));
};

exports["default"] = _default;