"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.KmPlot = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _kmModule = _interopRequireDefault(require("./km.module.css"));

var _PureComponent4 = _interopRequireDefault(require("./PureComponent"));

var _button = require("react-toolbox/lib/button");

var _dropdown = _interopRequireDefault(require("react-toolbox/lib/dropdown"));

var _dialog = _interopRequireDefault(require("react-toolbox/lib/dialog"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var _ = require('./underscore_ext')["default"];

var React = require('react');

var Axis = require('./Axis');

var _require = require('./scale'),
    linear = _require.linear,
    linearTicks = _require.linearTicks;

var pdf = require('./kmpdf');

var NumberForm = require('./views/NumberForm');

var _require2 = require('./models/km'),
    survivalOptions = _require2.survivalOptions,
    getSplits = _require2.getSplits;

var gaEvents = require('./gaEvents'); // Basic sizes. Should make these responsive. How to make the svg responsive?


var margin = {
  top: 20,
  right: 30,
  bottom: 30,
  left: 50
}; // XXX point at 100%? [xdomain[0] - 1, 1]

function line(xScale, yScale, values) {
  var coords = values.map(function (_ref) {
    var t = _ref.t,
        s = _ref.s;
    return [xScale(t), yScale(s)];
  });
  return ['M0,0'].concat((0, _toConsumableArray2["default"])(coords.map(function (_ref2) {
    var _ref3 = (0, _slicedToArray2["default"])(_ref2, 2),
        t = _ref3[0],
        s = _ref3[1];

    return "H".concat(t, "V").concat(s);
  }))).join(' ');
}

function censorLines(xScale, yScale, censors, className) {
  return censors.map(function (_ref4, i) {
    var t = _ref4.t,
        s = _ref4.s;
    return /*#__PURE__*/React.createElement("line", {
      key: i,
      className: className,
      x1: 0,
      x2: 0,
      y1: -5,
      y2: 5,
      transform: "translate(".concat(xScale(t), ",").concat(yScale(s), ")")
    });
  });
}

function calcDims(viewDims, sizeRatios) {
  return _.mapObject(sizeRatios, function (section) {
    return _.mapObject(section, function (ratio, side) {
      return viewDims[side] * ratio;
    });
  });
}

function checkIfActive(currentLabel, activeLabel) {
  // check whether this line group should be set to Active
  return !!activeLabel && activeLabel === currentLabel;
}

var LineGroup = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(LineGroup, _React$Component);

  var _super = _createSuper(LineGroup);

  function LineGroup() {
    (0, _classCallCheck2["default"])(this, LineGroup);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(LineGroup, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(newProps) {
      return !_.isEqual(_.omit(newProps, 'xScale', 'yScale'), _.omit(this.props, 'xScale', 'yScale'));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          xScale = _this$props.xScale,
          yScale = _this$props.yScale,
          g = _this$props.g,
          setActiveLabel = _this$props.setActiveLabel,
          isActive = _this$props.isActive;

      var _g = (0, _slicedToArray2["default"])(g, 3),
          color = _g[0],
          label = _g[1],
          curve = _g[2];

      var censors = curve.filter(function (pt) {
        return !pt.e;
      });
      var outlineStyle = isActive ? _kmModule["default"].outlineHover : _kmModule["default"].outline;
      var lineStyle = isActive ? _kmModule["default"].lineHover : _kmModule["default"].line;
      return /*#__PURE__*/React.createElement("g", {
        key: label,
        className: _kmModule["default"].subgroup,
        stroke: color,
        onMouseOver: function onMouseOver(e) {
          return setActiveLabel(e, label);
        },
        onMouseOut: function onMouseOut(e) {
          return setActiveLabel(e, '');
        }
      }, /*#__PURE__*/React.createElement("path", {
        className: outlineStyle,
        d: line(xScale, yScale, curve)
      }), /*#__PURE__*/React.createElement("path", {
        className: lineStyle,
        d: line(xScale, yScale, curve)
      }), censorLines(xScale, yScale, censors, outlineStyle), censorLines(xScale, yScale, censors, lineStyle));
    }
  }]);
  return LineGroup;
}(React.Component);

var bounds = function bounds(x) {
  return [_.min(x), _.max(x)];
};

function svg(_ref5, setActiveLabel, activeLabel, size) {
  var colors = _ref5.colors,
      labels = _ref5.labels,
      curves = _ref5.curves;
  var height = size.height - margin.top - margin.bottom,
      width = size.width - margin.left - margin.right,
      xdomain = bounds(_.pluck(_.flatten(curves), 't')),
      xrange = [0, width],
      ydomain = [0, 1],
      yrange = [height, 0],
      xScale = linear(xdomain, xrange),
      yScale = linear(ydomain, yrange);

  var groupSvg = _.zip(colors, labels, curves).map(function (g, index) {
    var _g2 = (0, _slicedToArray2["default"])(g, 2),
        label = _g2[1]; // passing bounds to force update when scales change


    return /*#__PURE__*/React.createElement(LineGroup, {
      key: index,
      bounds: [xdomain, xrange, ydomain, yrange],
      xScale: xScale,
      yScale: yScale,
      g: g,
      isActive: label === activeLabel,
      setActiveLabel: setActiveLabel
    });
  });

  return /*#__PURE__*/React.createElement("svg", {
    width: size.width,
    height: size.height
  }, /*#__PURE__*/React.createElement("g", {
    transform: "translate(".concat(margin.left, ", ").concat(margin.top, ")")
  }, /*#__PURE__*/React.createElement(Axis, {
    groupProps: {
      className: "x ".concat(_kmModule["default"].axis),
      transform: "translate(0, ".concat(height, ")")
    },
    domain: xdomain,
    range: xrange,
    scale: xScale,
    tickfn: linearTicks,
    orientation: "bottom"
  }), /*#__PURE__*/React.createElement(Axis, {
    groupProps: {
      className: "y ".concat(_kmModule["default"].axis)
    },
    domain: ydomain,
    range: yrange,
    scale: yScale,
    tickfn: linearTicks,
    orientation: "left"
  }, /*#__PURE__*/React.createElement("text", {
    transform: "rotate(-90)",
    y: "5",
    x: -height + 5,
    dy: ".71em",
    textAnchor: "start"
  }, "Survival probability")), groupSvg));
}

var formatPValue = function formatPValue(v) {
  return v == null ? String.fromCharCode(8709) : v.toPrecision(4);
};

var WarningTrigger = /*#__PURE__*/function (_React$Component2) {
  (0, _inherits2["default"])(WarningTrigger, _React$Component2);

  var _super2 = _createSuper(WarningTrigger);

  function WarningTrigger() {
    var _this;

    (0, _classCallCheck2["default"])(this, WarningTrigger);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super2.call.apply(_super2, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      show: false
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "close", function () {
      _this.setState({
        show: false
      });
    });
    return _this;
  }

  (0, _createClass2["default"])(WarningTrigger, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          header = _this$props2.header,
          body = _this$props2.body;
      return /*#__PURE__*/React.createElement("div", {
        className: _kmModule["default"].warningContainer
      }, /*#__PURE__*/React.createElement(_button.Button, {
        onClick: function onClick() {
          return _this2.setState({
            show: true
          });
        },
        className: _kmModule["default"].showPWarningButton
      }, /*#__PURE__*/React.createElement("i", {
        className: "material-icons ".concat(_kmModule["default"].pWarningIcon)
      }, "warning")), this.state.show ? /*#__PURE__*/React.createElement(WarningDialog, {
        onHide: this.close,
        header: header,
        body: body
      }) : null);
    }
  }]);
  return WarningTrigger;
}(React.Component);

var WarningDialog = /*#__PURE__*/function (_React$Component3) {
  (0, _inherits2["default"])(WarningDialog, _React$Component3);

  var _super3 = _createSuper(WarningDialog);

  function WarningDialog() {
    (0, _classCallCheck2["default"])(this, WarningDialog);
    return _super3.apply(this, arguments);
  }

  (0, _createClass2["default"])(WarningDialog, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      document.documentElement.scrollTop = 0;
      var body = document.getElementById("body");
      body.style.overflow = "auto";
    }
  }, {
    key: "render",
    value: function render() {
      var actions = [{
        children: [/*#__PURE__*/React.createElement("i", {
          className: "material-icons"
        }, "close")],
        className: _kmModule["default"].warningDialogClose,
        onClick: this.props.onHide
      }];
      return /*#__PURE__*/React.createElement(_dialog["default"], {
        actions: actions,
        active: true,
        title: this.props.header,
        className: _kmModule["default"].warningDialog,
        onEscKeyDown: this.props.onHide,
        onOverlayClick: this.props.onHide,
        theme: {
          wrapper: _kmModule["default"].dialogWrapper,
          overlay: _kmModule["default"].dialogOverlay
        }
      }, this.props.body);
    }
  }]);
  return WarningDialog;
}(React.Component);

var PValue = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(PValue, _PureComponent);

  var _super4 = _createSuper(PValue);

  function PValue() {
    (0, _classCallCheck2["default"])(this, PValue);
    return _super4.apply(this, arguments);
  }

  (0, _createClass2["default"])(PValue, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          logRank = _this$props3.logRank,
          pValue = _this$props3.pValue,
          patientWarning = _this$props3.patientWarning;
      return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
        className: _kmModule["default"].PValueArea
      }, /*#__PURE__*/React.createElement("div", {
        className: _kmModule["default"].PValueP
      }, /*#__PURE__*/React.createElement("i", null, "P"), "-value = ", formatPValue(pValue)), patientWarning ? /*#__PURE__*/React.createElement(WarningTrigger, {
        header: "P value warning",
        body: patientWarning
      }) : null), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("span", null, "Log-rank test statistics = ", formatPValue(logRank))));
    }
  }]);
  return PValue;
}(_PureComponent4["default"]); // Sample count is 'n' at 1st time point.


function sampleCount(curve) {
  return _.getIn(curve, [0, 'n'], String.fromCharCode(8709));
}

function makeLegendKey(_ref6, setActiveLabel, activeLabel) {
  var _ref7 = (0, _slicedToArray2["default"])(_ref6, 3),
      color = _ref7[0],
      curves = _ref7[1],
      label = _ref7[2];

  // show colored line and category of curve
  var isActive = checkIfActive(label, activeLabel);
  var labelClassName = isActive ? _kmModule["default"].activeListItem : _kmModule["default"].listItem;
  var legendLineStyle = {
    backgroundColor: color,
    border: (isActive ? 2 : 1).toString() + 'px solid',
    display: 'inline-block',
    height: 6,
    width: 25,
    verticalAlign: 'middle'
  };
  return /*#__PURE__*/React.createElement("li", {
    key: label,
    className: labelClassName,
    onMouseOver: function onMouseOver(e) {
      return setActiveLabel(e, label);
    },
    onMouseOut: function onMouseOut(e) {
      return setActiveLabel(e, '');
    }
  }, /*#__PURE__*/React.createElement("span", {
    style: legendLineStyle
  }), " ", label, " (n=", sampleCount(curves), ")");
}

var Legend = /*#__PURE__*/function (_PureComponent2) {
  (0, _inherits2["default"])(Legend, _PureComponent2);

  var _super5 = _createSuper(Legend);

  function Legend() {
    (0, _classCallCheck2["default"])(this, Legend);
    return _super5.apply(this, arguments);
  }

  (0, _createClass2["default"])(Legend, [{
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
          groups = _this$props4.groups,
          setActiveLabel = _this$props4.setActiveLabel,
          activeLabel = _this$props4.activeLabel;
      var colors = groups.colors,
          curves = groups.curves,
          labels = groups.labels;

      var sets = _.zip(colors, curves, labels).map(function (set) {
        return makeLegendKey(set, setActiveLabel, activeLabel);
      });

      return /*#__PURE__*/React.createElement("div", {
        className: _kmModule["default"].legend
      }, sets);
    }
  }]);
  return Legend;
}(_PureComponent4["default"]);

var survURL = {
  "TCGA PanCanAtlas": encodeURI("https://www.cell.com/action/showFullTableImage?isHtml=true&tableId=tbl3&pii=S0092867418302290&code=cell-site")
};

function makeSurvivalTypeUI(cohort, survInfoURL, survType, survivalTypes, onSurvType) {
  return /*#__PURE__*/React.createElement("div", {
    className: _kmModule["default"].survTypeContainer
  }, /*#__PURE__*/React.createElement(_dropdown["default"], {
    className: _kmModule["default"].survType,
    source: survivalTypes.map(function (t) {
      return {
        value: t,
        label: survivalOptions[t].label
      };
    }),
    value: survType || survivalTypes[0],
    onChange: onSurvType
  }), survInfoURL ? /*#__PURE__*/React.createElement(_button.IconButton, {
    onClick: function onClick() {
      return window.location.href = survInfoURL;
    }
  }, /*#__PURE__*/React.createElement("i", {
    className: "material-icons ".concat(_kmModule["default"].infoIcon)
  }, "info")) : null);
}

function makeGraph(groups, setActiveLabel, activeLabel, size, cohort, survInfoURL, survType, survivalTypes, onSurvType, min, max, onCutoff, cutoff) {
  return /*#__PURE__*/React.createElement("div", {
    className: _kmModule["default"].graph
  }, svg(groups, setActiveLabel, activeLabel, {
    height: 0.8 * size.height,
    width: 0.9 * size.width
  }), makeSurvivalTypeUI(cohort, survInfoURL, survType, survivalTypes, onSurvType), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(NumberForm, {
    onChange: onCutoff,
    dflt: max,
    min: min,
    max: max,
    initialValue: cutoff
  })));
}

function makeSplits(splits, onSplits) {
  return /*#__PURE__*/React.createElement("form", null, /*#__PURE__*/React.createElement("div", {
    className: _kmModule["default"].splits
  }, /*#__PURE__*/React.createElement("label", {
    className: _kmModule["default"].splitLabel,
    title: "2 groups: top 50%, bottom 50%"
  }, /*#__PURE__*/React.createElement("input", {
    value: 2,
    type: "radio",
    name: "splits",
    checked: splits === 2,
    onChange: onSplits
  }), /*#__PURE__*/React.createElement("span", {
    className: _kmModule["default"].splitHint
  }, "2 groups")), /*#__PURE__*/React.createElement("label", {
    className: _kmModule["default"].splitLabel,
    title: "3 groups: top 33%, middle 33%, bottom 33%"
  }, /*#__PURE__*/React.createElement("input", {
    value: 3,
    type: "radio",
    name: "splits",
    checked: splits === 3,
    onChange: onSplits
  }), /*#__PURE__*/React.createElement("span", {
    className: _kmModule["default"].splitHint
  }, "3 groups")), /*#__PURE__*/React.createElement("label", {
    className: _kmModule["default"].splitLabel,
    title: "Quartiles: top 25%, bottom 25%"
  }, /*#__PURE__*/React.createElement("input", {
    value: -4,
    type: "radio",
    name: "splits",
    checked: splits === -4,
    onChange: onSplits
  }), /*#__PURE__*/React.createElement("span", {
    className: _kmModule["default"].splitHint
  }, "Quartiles"))));
}

function makeDefinitions(groups, setActiveLabel, activeLabel, size, maySplit, splits, onSplits, label, clarification, warning) {
  // get new size based on size ratio for definitions column
  return /*#__PURE__*/React.createElement("div", {
    className: _kmModule["default"].definitions,
    style: {
      width: size.width
    }
  }, /*#__PURE__*/React.createElement(PValue, {
    pValue: groups.pValue,
    logRank: groups.KM_stats,
    patientWarning: groups.patientWarning
  }), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("label", null, label, " ", clarification), /*#__PURE__*/React.createElement(Legend, {
    groups: groups,
    setActiveLabel: setActiveLabel,
    activeLabel: activeLabel
  }), maySplit ? makeSplits(getSplits(splits), onSplits) : null, warning);
}

var plotSize = {
  ratios: {
    graph: {
      width: 0.75,
      height: 1.0
    },
    definitions: {
      width: 0.4,
      height: 1.0
    }
  }
};

var KmPlot = /*#__PURE__*/function (_PureComponent3) {
  (0, _inherits2["default"])(KmPlot, _PureComponent3);

  var _super6 = _createSuper(KmPlot);

  function KmPlot() {
    var _this3;

    (0, _classCallCheck2["default"])(this, KmPlot);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this3 = _super6.call.apply(_super6, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "state", {
      activeLabel: ''
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "hide", function () {
      var _this3$props = _this3.props,
          callback = _this3$props.callback,
          eventClose = _this3$props.eventClose;
      callback([eventClose]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "onCutoff", function (v) {
      var callback = _this3.props.callback;
      callback(['km-cutoff', v]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "setActiveLabel", function (e, label) {
      _this3.setState({
        activeLabel: label
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "pdf", function () {
      gaEvents('spreadsheet', 'pdf', 'km');
      pdf(_this3.props.km.groups);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "help", function () {
      window.location.href = "https://ucsc-xena.gitbook.io/project/overview-of-features/kaplan-meier-plots";
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "onSplits", function (ev) {
      var callback = _this3.props.callback;
      callback(['km-splits', parseInt(ev.target.value, 10)]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "onSurvType", function (ev) {
      var callback = _this3.props.callback;
      callback(['km-survivalType', ev]);
    });
    return _this3;
  }

  (0, _createClass2["default"])(KmPlot, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      document.documentElement.scrollTop = 0;
      var body = document.getElementById("body");
      body.style.overflow = "auto";
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
          _this$props5$km = _this$props5.km,
          _this$props5$km$split = _this$props5$km.splits,
          splits = _this$props5$km$split === void 0 ? 2 : _this$props5$km$split,
          title = _this$props5$km.title,
          label = _this$props5$km.label,
          groups = _this$props5$km.groups,
          cutoff = _this$props5$km.cutoff,
          survivalType = _this$props5$km.survivalType,
          survivalKeys = _this$props5.survivalKeys,
          cohort = _this$props5.cohort,
          dims = _this$props5.dims,
          maySplit = _.get(groups, 'maySplit', false),
          min = _.getIn(groups, ['domain', 0]),
          max = _.getIn(groups, ['domain', 1]),
          warning = _.get(groups, 'warning'),
          clarification = _.get(groups, 'clarification'),
          activeLabel = this.state.activeLabel,
          sectionDims = calcDims(dims, plotSize.ratios),
          survivalTypes = _.intersection(survivalKeys, _.keys(survivalOptions)),
          survInfoURL = _.getIn(survURL, [cohort], null);

      var Content = _.isEmpty(groups) ? /*#__PURE__*/React.createElement("div", {
        style: {
          height: dims.height,
          textAlign: 'center',
          verticalAlign: 'center'
        }
      }, /*#__PURE__*/React.createElement("h1", null, "Loading...")) : _.isEmpty(groups.colors) ? /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", null, makeSurvivalTypeUI(cohort, survInfoURL, survivalType, survivalTypes, this.onSurvType)), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("h3", null, "Unfortunately, KM plot can not be made. There is no survival data overlapping column data."))) : /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(_button.Button, {
        onClick: this.pdf,
        className: _kmModule["default"].PDFButton
      }, /*#__PURE__*/React.createElement("i", {
        className: "material-icons ".concat(_kmModule["default"].buttonIcon)
      }, "file_download"), /*#__PURE__*/React.createElement("span", {
        className: _kmModule["default"].buttonText
      }, "PDF")), /*#__PURE__*/React.createElement(_button.Button, {
        onClick: this.help,
        className: _kmModule["default"].helpButton
      }, /*#__PURE__*/React.createElement("i", {
        className: "material-icons ".concat(_kmModule["default"].buttonIcon)
      }, "help"), /*#__PURE__*/React.createElement("span", {
        className: _kmModule["default"].buttonText
      }, "Help")), makeGraph(groups, this.setActiveLabel, activeLabel, sectionDims.graph, cohort, survInfoURL, survivalType, survivalTypes, this.onSurvType, min, max, this.onCutoff, cutoff), makeDefinitions(groups, this.setActiveLabel, activeLabel, sectionDims.definitions, maySplit, splits, this.onSplits, label, clarification, warning));
      var actions = [{
        children: [/*#__PURE__*/React.createElement("i", {
          className: "material-icons"
        }, "close")],
        className: _kmModule["default"].mainDialogClose,
        onClick: this.hide
      }];
      return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(_dialog["default"], {
        actions: actions,
        active: true,
        title: 'Kaplan Meier ' + title,
        className: _kmModule["default"].mainDialog,
        onEscKeyDown: this.hide,
        onOverlayClick: this.hide,
        theme: {
          wrapper: _kmModule["default"].dialogWrapper,
          overlay: _kmModule["default"].dialogOverlay
        }
      }, Content));
    }
  }]);
  return KmPlot;
}(_PureComponent4["default"]);

exports.KmPlot = KmPlot;
(0, _defineProperty2["default"])(KmPlot, "defaultProps", {
  eventClose: 'km-close',
  dims: {
    height: 450,
    width: 700
  }
});