"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var _require = require('react'),
    Component = _require.Component;

var isEqual = require('./underscore_ext')["default"].isEqual;

var logDiff; //eslint-disable-line no-unused-vars

if (process.env.NODE_ENV !== 'production') {
  logDiff = function logDiff(comp, nextProps, nextState) {
    if (!isEqual(comp.props, nextProps)) {
      console.log(comp.constructor.displayName, 'props differ:');
      Object.keys(comp.props).forEach(function (p) {
        if (!nextProps.hasOwnProperty(p)) {
          console.log('key deleted:', p);
        } else if (!isEqual(comp.props[p], nextProps[p])) {
          console.log('key changed:', p);
        }
      });
      Object.keys(nextProps).forEach(function (p) {
        if (!comp.props.hasOwnProperty(p)) {
          console.log('key added:', p);
        }

        ;
      });
    }

    if (!isEqual(comp.state, nextState)) {
      console.log(comp.constructor.displayName, 'state differs:');
      Object.keys(comp.state).forEach(function (p) {
        if (!nextState.hasOwnProperty(p)) {
          console.log('key deleted:', p);
        } else if (!isEqual(comp.state[p], nextState[p])) {
          console.log('key changed:', p);
        }
      });
      Object.keys(nextState).forEach(function (p) {
        if (!comp.state.hasOwnProperty(p)) {
          console.log('key added:', p);
        }

        ;
      });
    }
  };
}

var PureComponent = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(PureComponent, _Component);

  var _super = _createSuper(PureComponent);

  function PureComponent() {
    (0, _classCallCheck2["default"])(this, PureComponent);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(PureComponent, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      //		logDiff(this, nextProps, nextState);
      return !isEqual(nextProps, this.props) || !isEqual(nextState, this.state);
    }
  }]);
  return PureComponent;
}(Component);

var _default = PureComponent;
exports["default"] = _default;