"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _tooltip = _interopRequireDefault(require("react-toolbox/lib/tooltip"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Standard Xena spreadsheet control toolbar. Displays state of zoom and filter and,
 * additional actions to show/hide null data or show/hide gene zoom.
 *
 */
// Core dependencies, components
var React = require('react');

var _ = require('./underscore_ext')["default"]; // App dependencies


var SheetStatus = require('./views/SheetStatus');

// Styles
var compStyles = require('./SheetControls.module.css');

var classNames = require('classnames');

var SheetControls = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(SheetControls, _React$Component);

  var _super = _createSuper(SheetControls);

  function SheetControls() {
    (0, _classCallCheck2["default"])(this, SheetControls);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(SheetControls, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          appState = _this$props.appState,
          clearZoom = _this$props.clearZoom,
          statusDisabled = _this$props.statusDisabled,
          zoomOut = _this$props.zoomOut,
          count = _.getIn(this.props, ['zoom', 'count']) || 0,
          index = _.getIn(this.props, ['zoom', 'index']) || 0,
          mode = appState.mode,
          zoomed = count !== appState.samples.length,
          zoomLabel = zoomed ? 'Zoomed' : 'Zoom:',
          zoomState = zoomed ? index === index + count - 1 ? "to row ".concat(index + 1) : "to rows ".concat(index + 1, " - ").concat(index + count) : 'None',
          zoomStatus = /*#__PURE__*/React.createElement(SheetStatus, {
        className: compStyles.zoomAnimate,
        disabled: statusDisabled,
        label: zoomLabel,
        sheetState: zoomState
      }),
          ZoomTooltip = (0, _tooltip["default"])('zoomStatus');
      return /*#__PURE__*/React.createElement("div", {
        className: compStyles.sheetControls
      }, mode === "chart" ? null : /*#__PURE__*/React.createElement("div", {
        className: compStyles.sheetStatus
      }, zoomed ? zoomStatus : /*#__PURE__*/React.createElement(ZoomTooltip, {
        tooltip: "Click and drag to zoom"
      }, zoomStatus), zoomed ? /*#__PURE__*/React.createElement("div", {
        className: classNames(compStyles.zoomActions, compStyles.zoomAnimate)
      }, /*#__PURE__*/React.createElement("span", {
        className: compStyles.action,
        onClick: zoomOut
      }, "Zoom Out"), /*#__PURE__*/React.createElement("span", {
        className: compStyles.action,
        onClick: clearZoom
      }, "Clear Zoom")) : null));
    }
  }]);
  return SheetControls;
}(React.Component);

var _default = SheetControls;
exports["default"] = _default;