var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _assertThisInitialized = require("@babel/runtime/helpers/assertThisInitialized");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

var _defineProperty = require("@babel/runtime/helpers/defineProperty");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var _ = require('./underscore_ext')["default"];

var vgcanvas = require('./vgcanvas');

var tickWidth = 5,
    borderWidth = 5;
var style = {
  position: 'absolute',
  background: 'transparent',
  left: -(tickWidth + borderWidth),
  top: -borderWidth,
  pointerEvents: 'none',
  zIndex: 2,
  borderWidth: borderWidth,
  borderColor: 'transparent',
  borderStyle: 'solid',
  transition: 'border-color 0.3s linear'
};

var SpreadSheetHighlight = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(SpreadSheetHighlight, _React$Component);

  var _super = _createSuper(SpreadSheetHighlight);

  function SpreadSheetHighlight() {
    var _this;

    _classCallCheck(this, SpreadSheetHighlight);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      animate: false
    });

    _defineProperty(_assertThisInitialized(_this), "draw", function (props) {
      var samples = props.samples,
          samplesMatched = props.samplesMatched,
          height = props.height,
          _assertThisInitialize = _assertThisInitialized(_this),
          vg = _assertThisInitialize.vg;

      if (vg.height() !== height) {
        vg.height(height);
      }

      vg.clear(0, 0, tickWidth, height);

      if (!samplesMatched) {
        return;
      } // Previously we used _.object, but hit a Safari bug https://bugs.webkit.org/show_bug.cgi?id=177772
      // with assigning numeric values to numeric keys. So, using an Array instead.


      var matchMap = samplesMatched.reduce(function (acc, v, i) {
        acc[v] = i;
        return acc;
      }, new Array(samples.length)),
          stripeGroups = _.groupByConsec(samples, function (s) {
        return _.has(matchMap, s);
      }),
          stripes = _.scan(stripeGroups, function (acc, g) {
        return acc + g.length;
      }, 0),
          hasMatch = _.map(stripeGroups, function (s, i) {
        return _.has(matchMap, stripeGroups[i][0]);
      }),
          pixPerRow = height / samples.length;

      vg.box(0, 0, tickWidth, height, 'rgba(0, 0, 0, 0)'); // transparent black

      var rects = _.flatmap(_.initial(stripes).map(function (offset, i) {
        return !hasMatch[i] ? [] : [[0, offset * pixPerRow, tickWidth, Math.max(pixPerRow * (stripes[i + 1] - offset), 1)]];
      }));

      if (rects.length > 0) {
        vg.drawRectangles(rects, {
          fillStyle: 'rgba(0, 0, 0, 1)'
        });
      }
    });

    return _this;
  }

  _createClass(SpreadSheetHighlight, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      // ignore props.
      return !_.isEqual(this.state, nextState);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var height = this.props.height;
      this.vg = vgcanvas(this.refs.canvas, tickWidth, height);
      this.draw(this.props);
      this.animate = this.props.animate.subscribe(function (ev) {
        return _this2.setState({
          animate: ev
        });
      }); //eslint-disable-line react/no-did-mount-set-state
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.animate.unsubscribe();
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(newProps) {
      if (this.vg && !_.isEqual(newProps, this.props)) {
        this.draw(newProps);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var animate = this.state.animate,
          border = animate ? {
        borderColor: 'red'
      } : {};
      return /*#__PURE__*/React.createElement("canvas", {
        style: _objectSpread(_objectSpread({}, style), border),
        ref: "canvas"
      });
    }
  }]);

  return SpreadSheetHighlight;
}(React.Component);

module.exports = SpreadSheetHighlight;