"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StateError = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _PureComponent2 = _interopRequireDefault(require("./PureComponent"));

var _StateErrorModule = _interopRequireDefault(require("./StateError.module.css"));

var _dialog = _interopRequireDefault(require("react-toolbox/lib/dialog"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var contains = require('./underscore_ext')["default"].contains;

var stateTypes = ['bookmark', 'import', 'session'];

var getMsg = function getMsg(error) {
  return contains(stateTypes, error) ? "We were unable to restore the view from your ".concat(error, ", possibly due to software updates. Sorry about that!") : error;
};

var StateError = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(StateError, _PureComponent);

  var _super = _createSuper(StateError);

  function StateError() {
    (0, _classCallCheck2["default"])(this, StateError);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(StateError, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      document.documentElement.scrollTop = 0;
      var body = document.getElementById("body");
      body.style.overflow = "auto";
    }
  }, {
    key: "render",
    value: function render() {
      var message = getMsg(this.props.error);
      var actions = [{
        label: /*#__PURE__*/React.createElement("i", {
          className: "material-icons"
        }, "close"),
        className: _StateErrorModule["default"].dialogClose,
        onClick: this.props.onHide
      }];
      return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(_dialog["default"], {
        actions: actions,
        active: true,
        title: "Whoops...",
        className: _StateErrorModule["default"].dialog,
        onEscKeyDown: this.props.onHide,
        onOverlayClick: this.props.onHide,
        theme: {
          wrapper: _StateErrorModule["default"].dialogWrapper,
          overlay: _StateErrorModule["default"].dialogOverlay
        }
      }, /*#__PURE__*/React.createElement("p", {
        style: {
          wordWrap: 'break-word'
        }
      }, message)));
    }
  }]);
  return StateError;
}(_PureComponent2["default"]);

exports.StateError = StateError;