"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var ReactDOM = require('react-dom');

var Rx = require('../rx')["default"];

var main = window.document.getElementById('main');

var allParameters = require('../util')["default"].allParameters;

var sortBy = require('../underscore_ext')["default"].sortBy;

var compStyles = require('./bookmarks.module.css');

var Weekly = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Weekly, _Component);

  var _super = _createSuper(Weekly);

  function Weekly() {
    var _this;

    (0, _classCallCheck2["default"])(this, Weekly);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      weeks: null
    });
    return _this;
  }

  (0, _createClass2["default"])(Weekly, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      Rx.Observable.ajax({
        url: '/api/bookmarks/weekly',
        method: 'GET'
      }).subscribe(function (req) {
        _this2.setState({
          weeks: req.response
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var weeks = this.state.weeks;
      return weeks ? /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("h2", null, "Bookmarks last-use-date by week"), /*#__PURE__*/_react["default"].createElement("ul", {
        className: compStyles.weeks
      }, weeks.map(function (w) {
        return /*#__PURE__*/_react["default"].createElement("li", {
          key: w.week
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: compStyles.week
        }, w.week.split(/ /)[0]), /*#__PURE__*/_react["default"].createElement("a", {
          href: "?week=".concat(w.week)
        }, /*#__PURE__*/_react["default"].createElement("span", null, w.count)));
      }))) : /*#__PURE__*/_react["default"].createElement("span", null, "Loading...");
    }
  }]);
  return Weekly;
}(_react.Component);

var Week = /*#__PURE__*/function (_Component2) {
  (0, _inherits2["default"])(Week, _Component2);

  var _super2 = _createSuper(Week);

  function Week() {
    var _this3;

    (0, _classCallCheck2["default"])(this, Week);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this3 = _super2.call.apply(_super2, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "state", {
      list: null
    });
    return _this3;
  }

  (0, _createClass2["default"])(Week, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this4 = this;

      var week = this.props.week;
      Rx.Observable.ajax({
        url: "/api/bookmarks/weekof?week=".concat(encodeURIComponent(week)),
        method: 'GET'
      }).subscribe(function (req) {
        _this4.setState({
          list: sortBy(req.response, 'lastUse')
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var list = this.state.list,
          week = this.props.week;
      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("h2", null, "Bookkmarks for week of ", week.split(/ /)[0]), list ? /*#__PURE__*/_react["default"].createElement("ul", {
        className: compStyles.bookmarks
      }, list.map(function (b) {
        return /*#__PURE__*/_react["default"].createElement("li", {
          key: b.id
        }, /*#__PURE__*/_react["default"].createElement("a", {
          href: "".concat(window.location.origin, "/heatmap/?bookmark=_").concat(b.id)
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: compStyles.id
        }, b.id)), /*#__PURE__*/_react["default"].createElement("span", null, b.lastUse));
      })) : /*#__PURE__*/_react["default"].createElement("span", null, "Loading..."), /*#__PURE__*/_react["default"].createElement("br", null), /*#__PURE__*/_react["default"].createElement("a", {
        href: "".concat(window.location.origin, "/bookmarks/")
      }, "All bookmarks"));
    }
  }]);
  return Week;
}(_react.Component);

var params = allParameters();
var Main = params.week ? Week : Weekly;
ReactDOM.render( /*#__PURE__*/_react["default"].createElement(Main, {
  week: params.week && params.week[0]
}), main);