"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _reduxDevtoolsLogMonitor = _interopRequireDefault(require("redux-devtools-log-monitor"));

var _reduxDevtoolsDockMonitor = _interopRequireDefault(require("redux-devtools-dock-monitor"));

var _urlParams = _interopRequireDefault(require("./urlParams"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _ = require('./underscore_ext')["default"];

var Rx = require('./rx')["default"];

var React = require('react');

var ReactDOM = require('react-dom');

var _require = require('./controllers/devtools'),
    createDevTools = _require.createDevTools;

var nostate = require('./nostate');

var LZ = require('./lz-string');

var _require2 = require('./compactData'),
    compactState = _require2.compactState,
    expandState = _require2.expandState;

var migrateState = require('./migrateState');

var _require3 = require('./schemaCheck'),
    schemaCheckThrow = _require3.schemaCheckThrow;

function logError(err) {
  if ((typeof window === "undefined" ? "undefined" : (0, _typeof2["default"])(window)) === 'object' && typeof window.chrome !== 'undefined') {
    // In Chrome, rethrowing provides better source map support
    setTimeout(function () {
      throw err;
    });
  } else {
    console.error(err.stack || err);
  }
}

var dropTransient = function dropTransient(state) {
  return _.assoc(state, 'wizard', {}, 'datapages', undefined, 'localStatus', undefined, 'localQueue', undefined, 'import', undefined);
}; // serialization


function stringify(state) {
  return LZ.compressToUTF16(JSON.stringify(_objectSpread(_objectSpread({}, _.omit(state, 'computedStates', 'committedState')), {}, {
    committedState: compactState(dropTransient(state.committedState))
  })));
}

function parse(str) {
  var state = JSON.parse(LZ.decompressFromUTF16(str));
  return _objectSpread(_objectSpread({}, state), {}, {
    committedState: schemaCheckThrow(expandState(migrateState(state.committedState)))
  });
} //


var unwrapDevState = function unwrapDevState(state) {
  return _.last(state.computedStates).state;
};

function getSavedState(persist) {
  delete sessionStorage.xena; // Free up space & don't try to share with prod.

  if (persist && nostate('debugSession')) {
    try {
      return parse(sessionStorage.debugSession);
    } catch (err) {
      console.log("Unable to load saved debug session", err);
    }
  }

  return null;
}

var historyObs = Rx.Observable.fromEvent(window, 'popstate').map(function () {
  return ['history', {
    path: location.pathname,
    params: (0, _urlParams["default"])()
  }];
});

module.exports = function (_ref) {
  var Page = _ref.Page,
      controller = _ref.controller,
      persist = _ref.persist,
      initialState = _ref.initialState,
      serverBus = _ref.serverBus,
      serverCh = _ref.serverCh,
      uiBus = _ref.uiBus,
      uiCh = _ref.uiCh,
      main = _ref.main,
      selector = _ref.selector;

  var dom = {
    main: main
  },
      updater = function updater(ac) {
    return uiBus.next(ac);
  },
      devBus = new Rx.Subject(),
      devCh = devBus,
      devtoolsVisible = false; // Change this to turn on the debug window at start.


  var DevTools = createDevTools( /*#__PURE__*/React.createElement(_reduxDevtoolsDockMonitor["default"], {
    defaultIsVisible: devtoolsVisible,
    toggleVisibilityKey: "ctrl-h",
    changePositionKey: "ctrl-q"
  }, /*#__PURE__*/React.createElement(_reduxDevtoolsLogMonitor["default"], {
    preserveScrollTop: false,
    expandStateRoot: false
  }))),
      devReducer = DevTools.instrument(controller, initialState),
      savedState = getSavedState(persist),
      // Here we need not just the initial state, but to know if we have a
  // saved state. The initial state is used in devtools as the 'reset'
  // target. So, we can't replace initial state with saved state.
  devInitialState = devReducer(null, savedState ? {
    type: 'IMPORT_STATE',
    nextLiftedState: savedState
  } : {}); // Side-effects (e.g. async) happen here. Ideally we wouldn't call this
  // from 'scan', since 'scan' should be side-effect free. However we've lost
  // the action by the time scan is complete, so we do it in the scan.

  var inEffectsReducer = false;

  var effectsReducer = function effectsReducer(state, ac) {
    if (inEffectsReducer) {
      throw new Error("Reentry in reducer. Reducers must not invoke actions.");
    }

    inEffectsReducer = true;
    var nextState = devReducer(state, ac);

    if (ac.type === 'PERFORM_ACTION') {
      try {
        controller.postAction(serverBus, unwrapDevState(state), unwrapDevState(nextState), ac.action);
      } catch (err) {
        logError(err);
      }
    } // We have an implicit async action on page load: 'init'. redux-devtools
    // 'RESET' command will return us to the initial state, but never
    // re-issues async actions (which would break the devtools functionality).
    // This leaves our app in an unusable state after RESET: initial state w/o any
    // way of issuing the 'init' action. The effect is the cohort list never
    // loads. Here we intercept the devtools actions & re-issue 'init' on
    // RESET.


    if (ac.type === 'RESET') {
      setTimeout(function () {
        return uiBus.next(['init', location.pathname, (0, _urlParams["default"])()]);
      }, 0);
    }

    inEffectsReducer = false;
    return nextState;
  };

  var devStateObs = Rx.Observable.merge(serverCh, uiCh, historyObs).map(function (ac) {
    return {
      type: 'PERFORM_ACTION',
      action: ac
    };
  }).merge(devCh).scan(effectsReducer, devInitialState) // XXX side effects!
  .share(); // XXX double check that this expression is doing what we want: don't draw faster
  // than rAF.
  // pass the selector into Page, so we catch errors while rendering & can display an error message.

  devStateObs.debounceTime(0, Rx.Scheduler.animationFrame).subscribe(function (devState) {
    return ReactDOM.render( /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Page, {
      callback: updater,
      selector: selector,
      state: unwrapDevState(devState)
    }), /*#__PURE__*/React.createElement(DevTools, (0, _extends2["default"])({
      dispatch: devBus.next.bind(devBus)
    }, devState))), dom.main);
  }, function (err) {
    return console.log('err', err);
  });

  if (persist) {
    // Save state in sessionStorage on page unload.
    devStateObs.sample(Rx.Observable.fromEvent(window, 'beforeunload')).map(function (state) {
      return sessionStorage.saveDevState ? state : effectsReducer(state, {
        type: 'COMMIT'
      });
    }).subscribe(function (state) {
      return sessionStorage.debugSession = stringify(state);
    });
  } // This causes us to always load cohorts on page load. This is important after
  // setting hubs, for example.


  uiBus.next(['init', location.pathname, (0, _urlParams["default"])()]);
  return dom;
};