"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _LaunchHelper = _interopRequireDefault(require("../LaunchHelper"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

// XXX move Application to views
var React = require('react'); //var _ = require('../underscore_ext').default;


var _require = require('./SpreadsheetContainer'),
    getSpreadsheetContainer = _require.getSpreadsheetContainer;

var ChartView = require('../ChartView');

var Column = require('../views/Column');

var _ = require('../underscore_ext')["default"];

var _require2 = require('../react-utils'),
    rxEvents = _require2.rxEvents;

var Rx = require('../rx')["default"]; // Spreadsheet options


var addTooltip = require('./addTooltip'); //var disableSelect = require('./disableSelect');


var addWizardColumns = require('./addWizardColumns');

var addVizEditor = require('./addVizEditor');

var makeSortable = require('./makeSortable');

var addColumnAdd = require('./addColumnAdd');

var addLegend = require('./addLegend');

var addHelp = require('./addHelp');

var getSpreadsheet = require('../Spreadsheet');

var getStepperState = require('./getStepperState');

var Application = require('../Application'); //import TiesContainer from './TiesContainer';


var _require3 = require('../schemaCheck'),
    schemaCheckThrow = _require3.schemaCheckThrow;

var migrateState = require('../migrateState');

function getFieldFormat(uuid, columns, data) {
  var columnFields = _.getIn(columns, [uuid, 'fields']),
      label = _.getIn(columns, [uuid, 'fieldLabel']),
      fields = _.getIn(data, [uuid, 'req', 'probes'], columnFields);

  if (fields.length === 1) {
    // 1 gene/probe, or 1 probe in gene
    return function (field) {
      return field === label ? label : "".concat(label, " (").concat(field, ")");
    };
  } else if (fields.length === columnFields.length) {
    // n > 1 genes/probes
    return _.identity;
  } else {
    // n > 1 probes in gene
    return function (field) {
      return "".concat(label, " (").concat(field, ")");
    };
  }
}

var columnsWrapper = function columnsWrapper(c) {
  return addHelp(addTooltip(addWizardColumns(addColumnAdd(addLegend(makeSortable(addVizEditor(c)))))));
};

var Spreadsheet = getSpreadsheet(columnsWrapper); // XXX without tooltip, we have no mouse pointer. Should make the wrapper add the css
// that hides the mouse. Currently this is in Column.
//var columnsWrapper = c => makeSortable(disableSelect(c));

var SpreadsheetContainer = getSpreadsheetContainer(Column, Spreadsheet);

var ApplicationContainer = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(ApplicationContainer, _React$Component);

  var _super = _createSuper(ApplicationContainer);

  function ApplicationContainer() {
    var _this;

    (0, _classCallCheck2["default"])(this, ApplicationContainer);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSearch", function (value) {
      var callback = _this.props.callback;
      callback(['sample-search', value]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "fieldFormat", function (uuid) {
      var _this$props$state$spr = _this.props.state.spreadsheet,
          columns = _this$props$state$spr.columns,
          data = _this$props$state$spr.data;
      return getFieldFormat(uuid, columns, data);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "sampleFormat", function (index) {
      var cohortSamples = _this.props.state.spreadsheet.cohortSamples;
      return _.get(cohortSamples, index);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getState", function () {
      return _.pick(_this.props.state, 'version', 'page', 'spreadsheet');
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onWizardMode", function (mode) {
      _this.props.callback(['wizardMode', mode]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onShowWelcome", function (show) {
      _this.props.callback(['showWelcome', show]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onReset", function () {
      _this.props.callback(['cohortReset']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onResetSampleFilter", function () {
      _this.props.callback(['sampleFilter', null]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onNavigate", function (page, params) {
      _this.props.callback(['navigate', page, params]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onImport", function (content) {
      try {
        _this.props.callback(['import', schemaCheckThrow(migrateState(JSON.parse(content)))]);
      } catch (err) {
        _this.props.callback(['import-error']);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onHighlightSelect", function (highlight) {
      _this.props.callback(['highlightSelect', highlight]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onAllowOverSamples", function () {
      _this.props.callback(['allowOverSamples', true]);
    });
    return _this;
  }

  (0, _createClass2["default"])(ApplicationContainer, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var events = rxEvents(this, 'highlightChange');
      this.change = events.highlightChange.debounceTime(200).subscribe(this.onSearch); // high on 1st change, low after some delay

      this.highlight = events.highlightChange.switchMap(function () {
        return Rx.Observable.of(true).concat(Rx.Observable.of(false).delay(300));
      }).distinctUntilChanged(_.isEqual);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.change.unsubscribe();
      this.highlight.unsubscribe();
    }
  }, {
    key: "render",
    // XXX Change state to appState in Application, for consistency.
    value: function render() {
      var _this$props = this.props,
          state = _this$props.state,
          selector = _this$props.selector,
          callback = _this$props.callback,
          children = _this$props.children,
          stateError = state.stateError,
          computedState = selector(state),
          _computedState$spread = computedState.spreadsheet,
          mode = _computedState$spread.mode,
          _computedState$spread2 = _computedState$spread.ties;
      _computedState$spread2 = _computedState$spread2 === void 0 ? {} : _computedState$spread2;
      var open = _computedState$spread2.open,
          loadPending = computedState.loadPending,
          stepperState = getStepperState(computedState.spreadsheet),
          View = {
        heatmap: SpreadsheetContainer,
        chart: ChartView //				ties: TiesContainer,

      }[open ? 'ties' : mode];
      return /*#__PURE__*/React.createElement(Application, {
        onReset: this.onReset,
        onResetSampleFilter: this.onResetSampleFilter,
        onWizardMode: this.onWizardMode,
        onShowWelcome: this.onShowWelcome,
        stepperState: stepperState,
        Spreadsheet: SpreadsheetContainer,
        onHighlightChange: this.on.highlightChange,
        onHighlightSelect: this.onHighlightSelect,
        onAllowOverSamples: this.onAllowOverSamples,
        sampleFormat: this.sampleFormat,
        getState: this.getState,
        onNavigate: this.onNavigate,
        onImport: this.onImport,
        loadPending: loadPending,
        stateError: stateError,
        state: computedState.spreadsheet,
        callback: callback
      }, /*#__PURE__*/React.createElement(View, {
        stepperState: stepperState,
        searching: this.highlight,
        fieldFormat: this.fieldFormat,
        sampleFormat: this.sampleFormat,
        appState: computedState.spreadsheet,
        wizard: computedState.wizard,
        callback: callback
      }), children);
    }
  }]);
  return ApplicationContainer;
}(React.Component); // add pop-up notification for old hubs.


var _default = (0, _LaunchHelper["default"])(function (props) {
  return _.getIn(props, ['state', 'localStatus']) === 'old';
}, ApplicationContainer);

exports["default"] = _default;