"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _ApplicationContainer = _interopRequireDefault(require("./ApplicationContainer"));

var _hubPage = _interopRequireDefault(require("../hubPage"));

var _Datapages = _interopRequireDefault(require("../Datapages"));

var _TranscriptPage = _interopRequireDefault(require("../transcript_views/TranscriptPage"));

var _reactToolbox = require("react-toolbox");

var _ImportPage = _interopRequireDefault(require("../import/ImportPage"));

var _reactHotLoader = require("react-hot-loader");

function hotOrNot(component) {
  return module.hot ? (0, _reactHotLoader.hot)(module)(component) : component;
} // react hot loader messes up class checks in react-toolbox. Override
// the class checker in dev.


function defaultChecker(classType, reactElement) {
  if (process.env.NODE_ENV !== 'production') {
    // https://github.com/gaearon/react-hot-loader/blob/v3.0.0-beta.7/docs/Known%20Limitations.md#checking-element-types
    classType = /*#__PURE__*/_react["default"].createElement(classType).type; // eslint-disable-line no-param-reassign
  }

  return reactElement && reactElement.type === classType;
}

(0, _reactToolbox.overrideComponentTypeChecker)(defaultChecker);
var pages = {
  'hub': _hubPage["default"],
  'heatmap': _ApplicationContainer["default"],
  'datapages': _Datapages["default"],
  'transcripts': _TranscriptPage["default"],
  'import': _ImportPage["default"]
};

var notFound = function notFound() {
  return /*#__PURE__*/_react["default"].createElement("p", null, "Oops... can't find this page");
};

var PageContainer = function PageContainer(props) {
  var page = props.state.page;
  var Page = pages[page] || notFound;
  return /*#__PURE__*/_react["default"].createElement(Page, props);
};

var _default = hotOrNot(PageContainer);

exports["default"] = _default;