"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var Rx = require('../rx')["default"];

var Welcome = require('../views/Welcome');

var _require = require('../react-utils'),
    rxEvents = _require.rxEvents;

var links = [['heatmap', 'bc7f3f46b042bcf5c099439c2816ff01', 'FOXM1a, FOXM1b, FOXM1c transcript expression in tumor vs. normal samples'], ['heatmap', 'cd6d8adead7d720fea7df197dc807147', 'ERG-TMPRSS2 fusion by chr21 deletion in prostate cancer'], ['heatmap', 'ff06e17b50faa9ec3045ab174dd19907', 'KM plot (overall survival) of breast cancer PAM50 subtypes'], ['heatmap', '6451afae2ee964475a2eb9c79d46900c', 'Genetic separation of lower grade gliomas: one characterized by loss of chromosomes 1p & 19q, \
		the other by TP53 & ATRX mutations.'], ['heatmap', '3f4b3fa8901f4c24f5f791e036566424', 'PDL1 and PD1 expression across 39 cancer types in TCGA and TARGET'], ['heatmap', '2dc4735dd97964b7c2a57afe053a9764', 'MGMT promoter DNA methylation is inversely correlated with MGMT expression'], ['heatmap', '0f9954a525987445ba7faef1e2081027', 'Copy number for EGFR, PTEN, chromosome 1, 7, 10, 19 in TCGA brain tumors'], ['transcripts', '75fd7d99bbc1bb04aae9b4e5e34b077f', 'KRAS isoform expression in TCGA pancreatic cancer vs. GTEx pancreas normal'], ['heatmap', 'dfc37064d62ea0c0302881c05277b7b3', 'Mutation pile-ups in intron enhancers in ICGC lymphoma']];

var evToIndex = function evToIndex(ev) {
  return parseInt(ev.currentTarget.dataset.index, 10);
};

var refresh = 5000; // ms between link switch

var WelcomeContainer = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(WelcomeContainer, _PureComponent);

  var _super = _createSuper(WelcomeContainer);

  function WelcomeContainer() {
    var _this;

    (0, _classCallCheck2["default"])(this, WelcomeContainer);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      link: 0
    });
    return _this;
  }

  (0, _createClass2["default"])(WelcomeContainer, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      var events = rxEvents(this, 'mouseover', 'mouseout', 'bulletover');
      var mouseover = events.mouseover,
          mouseout = events.mouseout,
          bulletover = events.bulletover; // Emit events on an interval, pausing if the user mouses-over
      // the target link. The timer restarts on mouse-out, so it won't
      // change immediately.

      this.sub = Rx.Observable.of(true).merge(mouseout).flatMap(function () {
        return Rx.Observable.interval(refresh).takeUntil(mouseover.merge(bulletover)).map(function () {
          return undefined;
        });
      }).merge(bulletover.map(evToIndex)).subscribe(function (i) {
        return _this2.setState({
          link: i === undefined ? (_this2.state.link + 1) % links.length : i
        });
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.sub.unsubscribe();
    }
  }, {
    key: "render",
    value: function render() {
      var link = this.state.link;
      return /*#__PURE__*/React.createElement(Welcome, (0, _extends2["default"])({
        count: links.length,
        i: link,
        linkProps: {
          onMouseOver: this.on.mouseover,
          onMouseOut: this.on.mouseout
        },
        bulletProps: {
          onMouseOver: this.on.bulletover,
          onMouseOut: this.on.mouseout
        }
      }, this.props, {
        link: links[link]
      }));
    }
  }]);
  return WelcomeContainer;
}(_PureComponent2["default"]);

var _default = WelcomeContainer;
exports["default"] = _default;