"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var Tooltip = require('../views/Tooltip');

var React = require('react');

var _require = require('../react-utils'),
    rxEvents = _require.rxEvents;

var meta = require('../meta');

var _ = require('../underscore_ext')["default"];

var Rx = require('../rx')["default"];

function addTooltip(Component) {
  var _class, _temp;

  return _temp = _class = /*#__PURE__*/function (_PureComponent) {
    (0, _inherits2["default"])(_class, _PureComponent);

    var _super = _createSuper(_class);

    function _class() {
      var _this;

      (0, _classCallCheck2["default"])(this, _class);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _super.call.apply(_super, [this].concat(args));
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
        tooltip: {
          open: false
        }
      });
      return _this;
    }

    (0, _createClass2["default"])(_class, [{
      key: "componentWillMount",
      value: function componentWillMount() {
        var _this2 = this;

        var events = this.ev = rxEvents(this, 'tooltip', 'click', 'close');
        var toggle = events.click.filter(function (ev) {
          return ev[meta.key];
        }).map(function () {
          return 'toggle';
        }),
            close = events.close.map(function () {
          return 'toggle';
        });
        var tooltip = events.tooltip.merge(toggle).merge(close) // If open + user clicks, toggle freeze of display.
        .scan(function (_ref, ev) {
          var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
              tt = _ref2[0],
              frozen = _ref2[1];

          return ev === 'toggle' ? [tt, tt.open && !frozen] : [ev, frozen];
        }, [{
          open: false
        }, false]) // Filter frozen events until frozen state changes.
        .distinctUntilChanged(_.isEqual, function (_ref3) {
          var _ref4 = (0, _slicedToArray2["default"])(_ref3, 2),
              ev = _ref4[0],
              frozen = _ref4[1];

          return frozen ? frozen : [ev, frozen];
        }).map(function (_ref5) {
          var _ref6 = (0, _slicedToArray2["default"])(_ref5, 2),
              ev = _ref6[0],
              frozen = _ref6[1];

          return _.assoc(ev, 'frozen', frozen);
        }).share(); // XXX Overwrite this.ev.tooltip with a Subject that includes
        // the 'frozen' functionality. This allows listeners to 'freeze',
        // e.g. the probe position highlight.

        this.ev.tooltip = Rx.Subject.create(events.tooltip, tooltip);
        this.sub = tooltip.subscribe(function (ev) {
          return _this2.setState({
            tooltip: ev
          });
        });
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.sub.unsubscribe();
      }
    }, {
      key: "render",
      value: function render() {
        var _this3 = this;

        var _this$props = this.props,
            children = _this$props.children,
            props = (0, _objectWithoutProperties2["default"])(_this$props, ["children"]),
            appState = props.appState,
            interactive = props.interactive,
            wizardMode = appState.wizardMode,
            open = this.state.tooltip.open && interactive,
            onClick = interactive ? this.on.click : null;
        return /*#__PURE__*/React.createElement(Component, (0, _extends2["default"])({}, props, {
          onClick: onClick,
          append: wizardMode ? null : /*#__PURE__*/React.createElement(Tooltip, (0, _extends2["default"])({
            show: interactive,
            onClose: this.on.close,
            onClick: this.on.click
          }, _objectSpread(_objectSpread({}, this.state.tooltip), {}, {
            open: open
          })))
        }), React.Children.map(children, function (el) {
          return React.cloneElement(el, {
            tooltip: _this3.ev.tooltip,
            frozen: _this3.state.tooltip.frozen
          });
        }));
      }
    }]);
    return _class;
  }(_PureComponent2["default"]), (0, _defineProperty2["default"])(_class, "displayName", 'SpreadsheetTooltip'), _temp;
}

module.exports = addTooltip;