"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _toArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _agnes = require("../agnes");

var _jStat = require("jStat");

var getIn = require('../underscore_ext')["default"].getIn;

var Rx = require('../rx')["default"];

var fromEvent = Rx.Observable.fromEvent;

var pearson = function pearson(a, b) {
  return 1 - _jStat.jStat.corrcoeff(a, b);
};

var fillNulls = function fillNulls(data, mean) {
  return data.map(function (row, i) {
    return row.map(function (v) {
      return v == null ? mean(i) : v;
    });
  });
}; // filter and create map of old index to new index, plus list of
// elided indices.


var filterWithMap = function filterWithMap(list, pred) {
  var out = [],
      map = [],
      omitted = [];
  list.forEach(function (v, i) {
    if (pred(v, i)) {
      out.push(v);
      map.push(i);
    } else {
      omitted.push(i);
    }
  });
  return [out, map, omitted];
};

var cmds = {
  cluster: function cluster(data) {
    var mean = getIn(data, ['avg', 'mean'], []),
        all = getIn(data, ['req', 'values'], []),
        _filterWithMap = filterWithMap(all, function (_, i) {
      return mean[i] != null;
    }),
        _filterWithMap2 = (0, _slicedToArray2["default"])(_filterWithMap, 3),
        cols = _filterWithMap2[0],
        mapping = _filterWithMap2[1],
        omit = _filterWithMap2[2],
        values = fillNulls(cols, function (i) {
      return mean[mapping[i]];
    });

    if (!values.length) {
      return omit;
    }

    var c = (0, _agnes.agnes)(values, pearson);
    return (0, _agnes.treeOrder)(c).map(function (i) {
      return mapping[i];
    }).concat(omit);
  }
}; // currently only have one method to dispatch, so this is a bit of overkill,
// but whatever.

function dispatch(ev) {
  var msg = ev.msg,
      id = ev.id,
      _msg = (0, _toArray2["default"])(msg),
      tag = _msg[0],
      args = _msg.slice(1);

  try {
    return {
      id: id,
      msg: cmds[tag].apply(cmds, (0, _toConsumableArray2["default"])(args))
    };
  } catch (err) {
    return {
      id: id,
      msg: {
        workerError: err.message
      }
    };
  }
}

var recvQ = fromEvent(self, 'message').map(function (_ref) {
  var data = _ref.data;
  return data;
});
recvQ.map(dispatch).subscribe(function (ev) {
  return postMessage(ev);
});