var _toConsumableArray = require("@babel/runtime/helpers/toConsumableArray");

// Utilities for handling errors in async actions.
var Rx = require('../rx')["default"];

var _ = require('../underscore_ext')["default"];

var _require = require('../errors'),
    compositeError = _require.compositeError; // Put error object on stream, extending with context.


function reifyErrors(obs, context) {
  return obs["catch"](function (err) {
    return Rx.Observable.of(_.extend(err, {
      context: context
    }));
  });
} // From an array of values, some of them errors, combine the successes into a
// single event, combine the errors and re-throw. This is a flatmap function.


var collectResults = _.curry(function (filter, arr, selector) {
  var groups = _.groupBy(arr, function (r) {
    return r instanceof Error;
  }),
      response = selector(filter ? groups["false"] || [] : arr),
      errors = groups["true"]; // XXX This mechanism needs work. It doesn't compose well. Operators on
  // this (e.g. zip) may cause the error to be caught in the wrong place.


  return errors ? Rx.Observable.of(response).concat(Rx.Observable["throw"](compositeError.apply(void 0, ['Composite Error'].concat(_toConsumableArray(errors))))) : Rx.Observable.of(response);
});

module.exports = {
  reifyErrors: reifyErrors,
  collectResults: collectResults(true),
  collectAlignedResults: collectResults(false)
};