"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.compose = exports.mount = exports.make = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _toArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toArray"));

var _require$default = require('../underscore_ext')["default"],
    identity = _require$default.identity,
    updateIn = _require$default.updateIn,
    getIn = _require$default.getIn;

var make = function make(controls) {
  return {
    action: function action(state, _ref) {
      var _ref2 = (0, _toArray2["default"])(_ref),
          tag = _ref2[0],
          args = _ref2.slice(1);

      return (controls[tag] || identity).apply(void 0, [state].concat((0, _toConsumableArray2["default"])(args)));
    },
    postAction: function postAction(serverBus, state, newState, _ref3) {
      var _ref4 = (0, _toArray2["default"])(_ref3),
          tag = _ref4[0],
          args = _ref4.slice(1);

      return (controls[tag + '-post!'] || identity).apply(void 0, [serverBus, state, newState].concat((0, _toConsumableArray2["default"])(args)));
    }
  };
};

exports.make = make;

var mount = function mount(controller, path) {
  return {
    action: function action(state, ac) {
      return updateIn(state, path, function (subtree) {
        return controller.action(subtree, ac);
      });
    },
    postAction: function postAction(serverBus, state, newState, ac) {
      return controller.postAction(serverBus, getIn(state, path), getIn(newState, path), ac);
    }
  };
}; // might want to optimize this with for loops.


exports.mount = mount;

var compose = function compose() {
  for (var _len = arguments.length, controllers = new Array(_len), _key = 0; _key < _len; _key++) {
    controllers[_key] = arguments[_key];
  }

  var rcontrollers = controllers.slice(0).reverse();
  return {
    action: function action(state, ac) {
      return rcontrollers.reduce(function (state, c) {
        return c.action(state, ac);
      }, state);
    },
    postAction: function postAction(bus, state, nextState, action) {
      return rcontrollers.forEach(function (c) {
        return c.postAction(bus, state, nextState, action);
      });
    }
  };
};

exports.compose = compose;