"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.maxLane = exports.geneLableFont = exports.GeneLabelAnnotation = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _PureComponent3 = _interopRequireDefault(require("./PureComponent"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var geneLableFont = 12;
exports.geneLableFont = geneLableFont;
var maxLane = 5;
exports.maxLane = maxLane;

var GeneLabel = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(GeneLabel, _PureComponent);

  var _super = _createSuper(GeneLabel);

  function GeneLabel() {
    (0, _classCallCheck2["default"])(this, GeneLabel);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(GeneLabel, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          left = _this$props.left,
          bottom = _this$props.bottom,
          textWidth = _this$props.textWidth,
          textAlign = _this$props.textAlign,
          text = _this$props.text,
          color = _this$props.color,
          fontWeight = _this$props.fontWeight,
          wordWrap = _this$props.wordWrap;
      return /*#__PURE__*/React.createElement("div", {
        style: {
          left: left,
          bottom: bottom,
          position: 'absolute',
          width: textWidth,
          textAlign: textAlign,
          wordWrap: wordWrap,
          overflow: 'hidden',
          fontSize: geneLableFont
        }
      }, /*#__PURE__*/React.createElement("label", {
        style: {
          color: color,
          fontWeight: fontWeight
        }
      }, text));
    }
  }]);
  return GeneLabel;
}(_PureComponent3["default"]);

var GeneLabelAnnotation = /*#__PURE__*/function (_PureComponent2) {
  (0, _inherits2["default"])(GeneLabelAnnotation, _PureComponent2);

  var _super2 = _createSuper(GeneLabelAnnotation);

  function GeneLabelAnnotation() {
    (0, _classCallCheck2["default"])(this, GeneLabelAnnotation);
    return _super2.apply(this, arguments);
  }

  (0, _createClass2["default"])(GeneLabelAnnotation, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          width = _this$props2.width,
          height = _this$props2.height,
          list = _this$props2.list,
          subColumnIndex = _this$props2.subColumnIndex;
      var subColWidth = width / list.length,
          aveSize = subColumnIndex.aveSize,
          textAlign = list.length === 1 ? 'center' : 'left',
          wordWrap = list.length === 1 ? 'break-word' : 'normal',
          laneNum = list.length === 1 ? 1 : Math.ceil(list.length / (width / aveSize)),
          laneHeight = height / laneNum;
      var items = laneNum > maxLane ? null : list.map(function (text, index) {
        // display at most 5 lanes
        var left = subColWidth * index,
            bottom = laneHeight * (index % laneNum),
            textWidth = width - left,
            color = subColumnIndex && index === subColumnIndex.index && list.length !== 1 ? 'red' : 'black',
            fontWeight = subColumnIndex && index === subColumnIndex.index && list.length !== 1 ? 'bold' : 'normal';

        if (list.length === 1) {
          // for single probe/gene/signature column, shorten text so that it will not go over vertically due to line wrapping
          text = text.slice(0, subColWidth * maxLane / geneLableFont) + (subColWidth * maxLane / geneLableFont < text.length ? ' ...' : '');
        }

        return /*#__PURE__*/React.createElement(GeneLabel, {
          key: index,
          left: left,
          bottom: bottom,
          textWidth: textWidth,
          textAlign: textAlign,
          text: text,
          color: color,
          wordWrap: wordWrap,
          fontWeight: fontWeight
        });
      });
      return /*#__PURE__*/React.createElement("div", {
        style: {
          width: width,
          height: height
        }
      }, items);
    }
  }]);
  return GeneLabelAnnotation;
}(_PureComponent3["default"]);

exports.GeneLabelAnnotation = GeneLabelAnnotation;