"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _reactCssThemr = require("react-css-themr");

require("../css/index.css");

var _button = require("react-toolbox/lib/button");

var _card = require("react-toolbox/lib/card");

var _checkbox = require("react-toolbox/lib/checkbox");

var _nav = _interopRequireDefault(require("./nav"));

var _class, _temp;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

require('./base');

var React = require('react');

var Rx = require('./rx')["default"];

// Root styles file (reset, fonts, globals)
var appTheme = require('./appTheme');

var classNames = require('classnames');

var typStyles = require('../css/typography.module.css');

var _require = require('./xenaQuery'),
    testHost = _require.testHost;

var _ = require('./underscore_ext')["default"];

var _require2 = require('./defaultServers'),
    localHub = _require2.servers.localHub,
    serverNames = _require2.serverNames;

var styles = require('./hubPage.module.css');

var _require3 = require('./hubParams'),
    parseServer = _require3.parseServer,
    getHubParams = _require3.getHubParams;

var encodeObject = require('./util')["default"].encodeObject;

var RETURN = 13;

var getName = function getName(h) {
  return _.get(serverNames, h, h);
};

var getStatus = function getStatus(user, ping) {
  return user ? ping === true ? 'connected' : 'selected' : '';
};

var getStyle = function getStyle(statusStr) {
  return statusStr === 'connected' ? styles.connected : null;
};

var reqStatus = function reqStatus(ping) {
  return ping == null ? ' (connecting...)' : ping ? '' : ' (not running)';
};

var checkHost = function checkHost(host) {
  return testHost(host).take(1).map(function (v) {
    return (0, _defineProperty2["default"])({}, host, v);
  });
};

var Hub = (_temp = _class = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Hub, _React$Component);

  var _super = _createSuper(Hub);

  function Hub() {
    var _this;

    (0, _classCallCheck2["default"])(this, Hub);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      ping: {}
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onNavigate", function (page, params) {
      _this.props.callback(['navigate', page, params]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onStartup", function () {
      _this.ping.next();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "updatePing", function (h) {
      _this.setState({
        ping: _objectSpread(_objectSpread({}, _this.state.ping), h)
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onKeyDown", function (ev) {
      if (ev.keyCode === RETURN) {
        ev.preventDefault();

        _this.onAdd();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSelect", function (isOn, ev) {
      var checked = ev.target.checked,
          host = ev.target.getAttribute('data-host');

      _this.props.callback([checked ? 'enable-host' : 'disable-host', host, 'user']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onAdd", function () {
      var target = _this.refs.newHost,
          value = target.value.trim();

      if (value !== '') {
        _this.props.callback(['add-host', parseServer(value)]);

        target.value = '';
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onRemove", function (ev) {
      var host = ev.currentTarget.getAttribute('data-host');

      _this.props.callback(['remove-host', host]);
    });
    return _this;
  }

  (0, _createClass2["default"])(Hub, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // XXX Use a connector to get rid of selector, here.
      // Or use a sub-component.
      var _this$props = this.props,
          state = _this$props.state,
          selector = _this$props.selector,
          allHosts = _.keys(selector(state));

      (0, _nav["default"])({
        activeLink: 'hub',
        onNavigate: this.onNavigate
      });
      this.ping = new Rx.Subject();
      this.sub = this.ping.switchMapTo(Rx.Observable.from(allHosts.map(checkHost)).mergeAll()).subscribe(this.updatePing);
      this.ping.next();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.sub.unsubscribe();
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(newProps) {
      var _this2 = this;

      var ping = this.state.ping,
          state = newProps.state,
          selector = newProps.selector,
          servers = selector(state),
          old = _.omit(ping, _.keys(servers));

      this.setState({
        ping: _.omit(ping, old)
      });

      _.difference(_.keys(servers), _.keys(ping)).forEach(function (h) {
        return checkHost(h).subscribe(_this2.updatePing);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props2 = this.props,
          state = _this$props2.state,
          selector = _this$props2.selector,
          badge = _this$props2.badge,
          hubParams = getHubParams(state),
          ping = this.state.ping,
          servers = selector(state),
          hostList = _.mapObject(servers, function (s, h) {
        return {
          selected: s.user,
          host: h,
          name: getName(h),
          statusStr: getStatus(s.user, ping[h]),
          reqStatus: reqStatus(ping[h])
        };
      });

      return /*#__PURE__*/React.createElement("div", {
        className: styles.hubPage
      }, /*#__PURE__*/React.createElement("h1", {
        className: typStyles.mdHeadline
      }, "Data Hubs"), /*#__PURE__*/React.createElement(_card.Card, null, /*#__PURE__*/React.createElement("ul", {
        className: styles.hubList
      }, _.values(hostList).map(function (h) {
        return /*#__PURE__*/React.createElement("li", {
          key: h.host
        }, /*#__PURE__*/React.createElement(_checkbox.Checkbox, {
          className: styles.checkbox,
          onChange: _this3.onSelect,
          checked: h.selected,
          "data-host": h.host
        }), /*#__PURE__*/React.createElement("div", {
          className: styles.statusContainer
        }, /*#__PURE__*/React.createElement("span", {
          className: classNames(styles.status, getStyle(h.statusStr))
        }, h.statusStr)), /*#__PURE__*/React.createElement("div", {
          className: styles.hubNameContainer
        }, /*#__PURE__*/React.createElement("a", {
          href: "../datapages/?".concat(encodeObject({
            host: h.host,
            addHub: hubParams.addHub,
            removeHub: hubParams.removeHub.filter(function (hub) {
              return hub !== h.host;
            })
          }))
        }, h.name), h.host === localHub ? badge : h.reqStatus), /*#__PURE__*/React.createElement("i", {
          className: classNames('material-icons', styles.remove),
          "data-host": h.host,
          onClick: _this3.onRemove
        }, "close"));
      }), /*#__PURE__*/React.createElement("li", null, /*#__PURE__*/React.createElement("div", {
        className: styles.hostForm
      }, /*#__PURE__*/React.createElement("input", {
        className: styles.input,
        onKeyDown: this.onKeyDown,
        ref: "newHost",
        type: "text",
        placeholder: "Add Hub"
      }), /*#__PURE__*/React.createElement(_button.Button, {
        onClick: this.onAdd,
        accent: true
      }, "Add"))))));
    }
  }]);
  return Hub;
}(React.Component), (0, _defineProperty2["default"])(_class, "displayName", 'Hub'), _temp);

var selector = function selector(state) {
  return state.spreadsheet.servers;
};

var ThemedHub = /*#__PURE__*/function (_React$Component2) {
  (0, _inherits2["default"])(ThemedHub, _React$Component2);

  var _super2 = _createSuper(ThemedHub);

  function ThemedHub() {
    (0, _classCallCheck2["default"])(this, ThemedHub);
    return _super2.apply(this, arguments);
  }

  (0, _createClass2["default"])(ThemedHub, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(_reactCssThemr.ThemeProvider, {
        theme: appTheme
      }, /*#__PURE__*/React.createElement(Hub, (0, _extends2["default"])({}, this.props, {
        selector: selector
      })));
    }
  }]);
  return ThemedHub;
}(React.Component);

var _default = ThemedHub;
exports["default"] = _default;