"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _react = _interopRequireDefault(require("react"));

var _ImportPageModule = _interopRequireDefault(require("./ImportPage.module.css"));

var _nav = _interopRequireDefault(require("../nav"));

var _lib = require("react-toolbox/lib");

var DefaultServers = _interopRequireWildcard(require("../defaultServers"));

var _loader = _interopRequireDefault(require("./loader.gif"));

var _constants = require("./constants");

var _Stepper = require("../views/Stepper");

var _WizardSection = _interopRequireDefault(require("./WizardSection"));

var _staticComponents = require("./staticComponents");

var _CohortSuggest = require("../views/CohortSuggest");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var _ = require('../underscore_ext')["default"];

var localHub = DefaultServers.servers.localHub;

var pageStates = _.range(Object.keys(_constants.PAGES).length);

var pageRanges = [0].concat((0, _toConsumableArray2["default"])(Array(4).fill(1)), [2, 3]); // XXX need a better way to express this

var pageStateIndex = _.object(pageStates, pageRanges);

var getDropdownOptions = function getDropdownOptions(strArr) {
  return strArr.map(function (val) {
    return {
      label: val,
      value: val
    };
  });
};

var getProbemapOptions = function getProbemapOptions(probes) {
  return [].concat((0, _toConsumableArray2["default"])(probes.map(function (_ref) {
    var label = _ref.label,
        name = _ref.value.name;
    return {
      label: label,
      value: name
    };
  })), [{
    label: _constants.NONE_STR,
    value: _constants.NONE_STR
  }]);
};

var isPhenotypeData = function isPhenotypeData(dataType) {
  return dataType === _constants.DATA_TYPE.PHENOTYPE;
};

var isMutationOrSegmentedData = function isMutationOrSegmentedData(dataType) {
  return dataType === _constants.DATA_TYPE.MUTATION_BY_POS || dataType === _constants.DATA_TYPE.SEGMENTED_CN;
};

var isMutationSegmentedOrPhenotype = function isMutationSegmentedOrPhenotype(dataType) {
  return isPhenotypeData(dataType) || isMutationOrSegmentedData(dataType);
};

var getNextPageByDataType = _.Let(function () {
  var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _constants.PAGES,
      FILE = _ref2.FILE,
      DATA_TYPE_SELECT = _ref2.DATA_TYPE_SELECT,
      DENSE_ORIENTATION = _ref2.DENSE_ORIENTATION,
      STUDY = _ref2.STUDY,
      PROBE = _ref2.PROBE,
      ASSEMBLY = _ref2.ASSEMBLY,
      PROGRESS = _ref2.PROGRESS;

  return function (currIndex, dataType) {
    var pages = [];

    switch (dataType) {
      case _constants.DATA_TYPE.MUTATION_BY_POS:
      case _constants.DATA_TYPE.SEGMENTED_CN:
        pages = [FILE, DATA_TYPE_SELECT, STUDY, ASSEMBLY, PROGRESS];
        break;

      case _constants.DATA_TYPE.PHENOTYPE:
        pages = [FILE, DATA_TYPE_SELECT, DENSE_ORIENTATION, STUDY, PROGRESS];
        break;

      default:
        pages = [FILE, DATA_TYPE_SELECT, DENSE_ORIENTATION, STUDY, PROBE, PROGRESS];
    }

    return pages[pages.indexOf(currIndex) + 1];
  };
});

var hasErrorsOrLoading = function hasErrorsOrLoading(_ref3) {
  var errors = _ref3.errors,
      errorCheckInprogress = _ref3.errorCheckInprogress,
      serverError = _ref3.serverError,
      probemapError = _ref3.probemapError;
  return errorCheckInprogress === true || serverError || probemapError || errors && errors.length;
};

var hasWarnings = function hasWarnings(_ref4) {
  var warnings = _ref4.warnings;
  return warnings && warnings.length;
};

var isImportSuccessful = function isImportSuccessful(state) {
  return !hasErrorsOrLoading(state) && !hasWarnings(state);
};

var ImportForm = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(ImportForm, _React$Component);

  var _super = _createSuper(ImportForm);

  function ImportForm() {
    var _this;

    (0, _classCallCheck2["default"])(this, ImportForm);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      showMoreErrors: false,
      showMoreDataTypes: false
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setLocalCohortRef", function (ref) {
      if (ref && !_this.props.state.localCohort) {
        // XXX inputNode has gone away in rt 2.0.0-beta.13. Not sure
        // why. For now, pinning the version to beta.12.
        ref.inputNode.focus();
      }

      _this.localCohortRef = ref;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isCohortPageNextEnabled", function () {
      var cohortRadio = _this.props.state.cohortRadio;
      return !!(cohortRadio && _this.props.state[cohortRadio]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isProbesNextPageEnabled", function () {
      return true;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onWizardBack", function () {
      _this.props.callback(['wizard-page', _this.props.wizardHistory.pop()]);

      _this.props.callback(['wizard-page-history', _this.props.wizardHistory]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onWizardNext", function (currPageIndex) {
      return function () {
        _this.props.callback(['wizard-page-history', [].concat((0, _toConsumableArray2["default"])(_this.props.wizardHistory), [currPageIndex])]);

        var newPageIndex = getNextPageByDataType(currPageIndex, _.getIn(_this.props, ['state', 'dataType']));

        _this.props.callback(['wizard-page', newPageIndex]);
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onFileChange", function (fileProp) {
      return function (evt) {
        if (evt.target.files.length > 0) {
          _this.props.callback(['file-content', []]);

          var file = evt.target.files[0];

          _this.props.callback([fileProp, file]);

          _this.props.callback(['file-read-inprogress']);

          _this.props.callback(['read-file', file]);

          _this.props.callback(['set-status', 'Reading the file...']);
        }
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onCohortRadioChange", function (value) {
      _this.props.callback(['cohort-radio', value]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onProbemapChange", function (value) {
      var probemaps = _this.props.probemaps,
          pm = probemaps.find(function (_ref5) {
        var name = _ref5.value.name;
        return name === value;
      });

      _this.props.callback(['probemap', pm ? pm.value : undefined]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onFileFormatChange", function (format) {
      return _this.props.callback(['file-format', format]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onDataTypeChange", function (type) {
      _this.resetFieldsOnDataTypeChange(type);

      _this.setFileFormatForSparse(type);

      _this.props.callback(['data-type', type]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onPublicCohortChange", function (cohort) {
      return _this.props.callback(['import-publicCohort', cohort]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onLocalCohortChange", function (cohort) {
      return _this.props.callback(['import-localCohort', cohort]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onNewCohortChange", function (cohort) {
      return _this.props.callback(['import-newCohort', cohort]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onShowMoreToggle", function () {
      return _this.setState({
        showMoreErrors: !_this.state.showMoreErrors
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onShowMoreDataTypesToggle", function () {
      return _this.setState({
        showMoreDataTypes: !_this.state.showMoreDataTypes
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onAssemblyChange", function (assembly) {
      return _this.props.callback(['assembly', assembly]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onRetryMetadata", function () {
      _this.props.callback(['clear-metadata']);

      _this.props.callback(['wizard-page', _constants.PAGES.DATA_TYPE_SELECT]);

      _this.props.callback(['retry-meta-data']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onRetryFile", function () {
      _this.props.callback(['error-check-inprogress']);

      _this.props.callback(['retry-file', _this.props.file]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onCancelImport", function () {
      _this.props.callback(['navigate', 'datapages', {
        host: localHub
      }]);

      _this.props.callback(['reset-import-state']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onFinishClick", function () {
      _this.props.callback(['navigate', 'datapages', {
        dataset: _this.props.fileName,
        host: localHub
      }]);

      _this.props.callback(['reset-import-state']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onViewDataClick", function () {
      _this.props.onViz();

      _this.props.callback(['reset-import-state']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onImportMoreData", function () {
      _this.props.callback(['reset-import-state']);

      _this.props.callback(['get-local-cohorts']);

      _this.props.callback(['get-probemaps']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onImportClick", function () {
      _this.props.callback(['wizard-page-history', [].concat((0, _toConsumableArray2["default"])(_this.props.wizardHistory), [_this.props.wizardPage])]);

      _this.props.callback(['wizard-page', _constants.PAGES.PROGRESS]);

      _this.props.callback(['error-check-inprogress']);

      _this.props.callback(['import-file']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onLoadWithWarnings", function () {
      _this.props.callback(['error-check-inprogress']);

      _this.props.callback(['load-with-warnings']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setFileFormatForSparse", function (dataType) {
      if (isMutationOrSegmentedData(dataType)) {
        var fileFormat = dataType === _constants.DATA_TYPE.MUTATION_BY_POS ? _constants.FILE_FORMAT.MUTATION_VECTOR : _constants.FILE_FORMAT.GENOMIC_SEGMENT;

        _this.props.callback(['file-format', fileFormat]);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetFieldsOnDataTypeChange", function (dataType) {
      if (isMutationOrSegmentedData(dataType)) {
        _this.resetProbemap();
      } else if (isPhenotypeData(dataType)) {
        _this.resetProbemap();

        _this.props.callback(['assembly', '']);
      } else {
        _this.props.callback(['assembly', '']);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetProbemap", function () {
      _this.props.callback(['probemap', '']);
    });
    return _this;
  }

  (0, _createClass2["default"])(ImportForm, [{
    key: "render",
    value: function render() {
      var _ref6 = this.props.state || {},
          fileFormat = _ref6.fileFormat,
          dataType = _ref6.dataType,
          assembly = _ref6.assembly,
          errorCheckInprogress = _ref6.errorCheckInprogress,
          serverError = _ref6.serverError,
          _this$props = this.props,
          file = _this$props.file,
          wizardPage = _this$props.wizardPage,
          fileName = _this$props.fileName,
          fileReadInProgress = _this$props.fileReadInProgress,
          fileSelected = file && !!file.size && !serverError;

      var wizardProps = {},
          component = null;

      switch (wizardPage) {
        case _constants.PAGES.FILE:
          wizardProps = {
            nextEnabled: fileSelected
          };
          component = this.fileSelectionPage(fileSelected, file);
          break;

        case _constants.PAGES.DATA_TYPE_SELECT:
          wizardProps = {
            nextEnabled: !!dataType && !fileReadInProgress,
            fileName: fileName
          };
          component = this.dataTypePage(fileReadInProgress);
          break;

        case _constants.PAGES.DENSE_ORIENTATION:
          wizardProps = {
            fileName: fileName,
            nextEnabled: !!fileFormat
          };
          component = this.denseOrientationPage();
          break;

        case _constants.PAGES.STUDY:
          wizardProps = {
            fileName: fileName,
            onImport: !isMutationOrSegmentedData(dataType) ? this.onImportClick : null,
            showAdvancedNextLabel: !isMutationSegmentedOrPhenotype(dataType),
            nextEnabled: this.isCohortPageNextEnabled()
          };
          component = this.studySelectionPage();
          break;

        case _constants.PAGES.PROBE:
          wizardProps = {
            fileName: fileName,
            onImport: this.onImportClick,
            nextEnabled: this.isProbesNextPageEnabled()
          };
          component = this.probeSelectionPage();
          break;

        case _constants.PAGES.ASSEMBLY:
          wizardProps = {
            fileName: fileName,
            onImport: this.onImportClick,
            nextEnabled: !!assembly
          };
          component = this.assemblySelectionPage();
          break;

        case _constants.PAGES.PROGRESS:
          wizardProps = {
            fileName: fileName,
            showRetry: !errorCheckInprogress && !isImportSuccessful(this.props.state),
            showSuccess: isImportSuccessful(this.props.state),
            showLoadWithWarnings: hasWarnings(this.props.state) && !hasErrorsOrLoading(this.props.state),
            onRetryFile: this.onRetryFile,
            onRetryMetadata: this.onRetryMetadata,
            onImportMoreData: this.onImportMoreData,
            onLoadWithWarnings: this.onLoadWithWarnings,
            onFinish: this.onFinishClick,
            onViewData: this.onViewDataClick
          };
          component = this.importProgressPage();
          break;
      }

      ;
      return /*#__PURE__*/_react["default"].createElement(_WizardSection["default"], (0, _extends2["default"])({
        isFirst: wizardPage === 0,
        isLast: wizardPage === pageStates.length - 1,
        onNextPage: this.onWizardNext(wizardPage),
        onPreviousPage: this.onWizardBack,
        callback: this.props.callback,
        onCancelImport: this.onCancelImport,
        onFileReload: this.onFileChange('file')
      }, wizardProps), component);
    }
  }, {
    key: "fileSelectionPage",
    value: function fileSelectionPage(fileSelected) {
      var serverError = _.getIn(this.props, ['state', 'serverError']);

      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("input", {
        type: "file",
        id: "file-input",
        style: {
          display: 'none'
        },
        onChange: this.onFileChange('file')
      }), /*#__PURE__*/_react["default"].createElement("label", {
        htmlFor: "file-input",
        className: _ImportPageModule["default"].importFileLabel
      }, "Select Data File"), fileSelected && /*#__PURE__*/_react["default"].createElement("b", null, "Selected file: ", this.props.fileName, " "), serverError ? /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("p", null, "We were unable to read this file, due to the following error:"), /*#__PURE__*/_react["default"].createElement("pre", null, serverError)) : null, /*#__PURE__*/_react["default"].createElement("div", {
        style: {
          marginTop: '1em'
        }
      }, /*#__PURE__*/_react["default"].createElement(_lib.Button, {
        icon: "help_outline",
        target: "_blank",
        href: "https://ucsc-xena.gitbook.io/project/local-xena-hub/data-format-specifications",
        label: "Help on data file formatting",
        accent: true,
        flat: false
      })));
    }
  }, {
    key: "dataTypePage",
    value: function dataTypePage(fileReadInProgress) {
      var dataType = _.getIn(this.props, ['state', 'dataType']),
          showMoreDataTypes = this.state.showMoreDataTypes;

      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_lib.RadioGroup, {
        value: dataType,
        onChange: this.onDataTypeChange
      }, _constants.dataTypeOptions.slice(0, showMoreDataTypes ? 4 : 2).map(function (_ref7) {
        var label = _ref7.label,
            value = _ref7.value;
        return /*#__PURE__*/_react["default"].createElement(_lib.RadioButton, {
          disabled: !!fileReadInProgress,
          key: value,
          label: label,
          value: value
        });
      })), /*#__PURE__*/_react["default"].createElement("p", {
        className: _ImportPageModule["default"].showMore,
        onClick: this.onShowMoreDataTypesToggle
      }, showMoreDataTypes ? 'Less data types...' : 'More data types...'), /*#__PURE__*/_react["default"].createElement(_lib.Button, {
        href: "https://ucsc-xena.gitbook.io/project/local-xena-hub/data-format-specifications",
        target: "_blank",
        className: _ImportPageModule["default"].dataTypeHelp,
        label: "HELP",
        accent: true,
        flat: false
      }), /*#__PURE__*/_react["default"].createElement("h4", null, "File preview"), this.renderFilePreview());
    }
  }, {
    key: "denseOrientationPage",
    value: function denseOrientationPage() {
      var fileFormat = this.props.state.fileFormat;
      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_lib.RadioGroup, {
        value: fileFormat,
        onChange: this.onFileFormatChange
      }, /*#__PURE__*/_react["default"].createElement(_lib.RadioButton, {
        label: "The first column is sample IDs",
        value: _constants.FILE_FORMAT.CLINICAL_MATRIX
      }), /*#__PURE__*/_react["default"].createElement(_lib.RadioButton, {
        label: "The first row is sample IDs",
        value: _constants.FILE_FORMAT.GENOMIC_MATRIX
      })), this.renderFilePreview(true));
    }
  }, {
    key: "studySelectionPage",
    value: function studySelectionPage() {
      var _this$props$state = this.props.state,
          cohortRadio = _this$props$state.cohortRadio,
          newCohort = _this$props$state.newCohort,
          publicCohort = _this$props$state.publicCohort,
          localCohort = _this$props$state.localCohort,
          cohorts = _.getIn(this.props, ['recommended', 'cohorts']);

      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_lib.RadioGroup, {
        value: cohortRadio,
        onChange: this.onCohortRadioChange
      }, /*#__PURE__*/_react["default"].createElement(_lib.RadioButton, {
        label: "These are the first data on these samples.",
        value: "newCohort"
      }), cohortRadio === 'newCohort' && /*#__PURE__*/_react["default"].createElement(_lib.Input, {
        label: "Study name",
        type: "text",
        className: _ImportPageModule["default"].field,
        onChange: this.onNewCohortChange,
        value: newCohort
      }), /*#__PURE__*/_react["default"].createElement(_lib.RadioButton, {
        label: "I have loaded other data on these samples and want to connect to it.",
        value: "localCohort"
      }), cohortRadio === 'localCohort' && /*#__PURE__*/_react["default"].createElement(_lib.Dropdown, {
        innerRef: this.setLocalCohortRef,
        onChange: this.onLocalCohortChange,
        source: getDropdownOptions([""].concat((0, _toConsumableArray2["default"])(this.props.localCohorts))),
        value: localCohort,
        label: "Select a study",
        className: [_ImportPageModule["default"].field, _ImportPageModule["default"].inline].join(' ')
      }), /*#__PURE__*/_react["default"].createElement(_lib.RadioButton, {
        label: "There is other public data in Xena on these samples (e.g. TCGA) and want to connect to it.",
        value: "publicCohort"
      }), cohortRadio === 'publicCohort' && /*#__PURE__*/_react["default"].createElement("div", {
        className: _ImportPageModule["default"].field
      }, /*#__PURE__*/_react["default"].createElement(_CohortSuggest.CohortSuggest, {
        cohort: publicCohort,
        cohorts: _.pluck(cohorts, 'name'),
        onSelect: this.onPublicCohortChange
      }))), this.renderFilePreview(true));
    }
  }, {
    key: "probeSelectionPage",
    value: function probeSelectionPage() {
      var recommendedProbemaps = _.getIn(this.props, ['recommended', 'probemaps'], []);

      var existingProbemaps = _.getIn(this.props, ['probemaps']);

      var probemapsToShow = recommendedProbemaps.map(function (p) {
        return existingProbemaps.find(function (existing) {
          return existing.value.name === p.name;
        });
      }).filter(_.identity);
      var recommendationsExist = recommendedProbemaps.length;
      var _this$props$state$pro = this.props.state.probemap,
          probemap = _this$props$state$pro === void 0 ? {
        name: _constants.NONE_STR
      } : _this$props$state$pro;

      var seletedProbeMapLabel = _.getIn(probemapsToShow, [0, 'label'], '');

      var text = recommendationsExist ? /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("h4", null, "We predict your data uses ", /*#__PURE__*/_react["default"].createElement("b", null, seletedProbeMapLabel), " type file."), /*#__PURE__*/_react["default"].createElement("h4", null, "If this is not correct, choose the correct one from the drop down")) : /*#__PURE__*/_react["default"].createElement("h4", null, "We don't recognize the identifiers in your data. Sorry!");
      return /*#__PURE__*/_react["default"].createElement("div", null, text, !!recommendationsExist && /*#__PURE__*/_react["default"].createElement(_lib.Dropdown, {
        onChange: this.onProbemapChange,
        source: getProbemapOptions(probemapsToShow),
        value: _.get(probemap, 'name'),
        className: [_ImportPageModule["default"].probemap, _ImportPageModule["default"].inline].join(' ')
      }), this.renderMailto("Xena import missing identifiers", "identifiers", probemap === _constants.NONE_STR || !recommendationsExist), this.renderFilePreview(true));
    }
  }, {
    key: "assemblySelectionPage",
    value: function assemblySelectionPage() {
      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("h4", null, "Which reference genome was used to create this file?"), /*#__PURE__*/_react["default"].createElement(_lib.RadioGroup, {
        value: this.props.state.assembly,
        onChange: this.onAssemblyChange
      }, /*#__PURE__*/_react["default"].createElement(_lib.RadioButton, {
        label: "hg18/GRCh36",
        value: "hg18"
      }), /*#__PURE__*/_react["default"].createElement(_lib.RadioButton, {
        label: "hg19/GRCh37",
        value: "hg19"
      }), /*#__PURE__*/_react["default"].createElement(_lib.RadioButton, {
        label: "hg38/GRCh38",
        value: "hg38"
      })), this.renderFilePreview());
    }
  }, {
    key: "importProgressPage",
    value: function importProgressPage() {
      var _this$props$state2 = this.props.state,
          errors = _this$props$state2.errors,
          warnings = _this$props$state2.warnings,
          errorCheckInprogress = _this$props$state2.errorCheckInprogress,
          serverError = _this$props$state2.serverError,
          probemapError = _this$props$state2.probemapError,
          errorSnippets = _this$props$state2.errorSnippets,
          fileContent = this.props.fileContent,
          serverOrProbemapError = serverError || probemapError,
          hasErr = errors && !!errors.length;
      var errorText = null;

      if (hasErr) {
        errorText = /*#__PURE__*/_react["default"].createElement("p", null, "There were some errors found in the file:");
      } else if (hasWarnings(this.props.state)) {
        errorText = /*#__PURE__*/_react["default"].createElement("p", null, "There were some warnings found in the file:");
      }

      return /*#__PURE__*/_react["default"].createElement("div", null, errorCheckInprogress && /*#__PURE__*/_react["default"].createElement("p", null, "Loading file..."), errorText, /*#__PURE__*/_react["default"].createElement(ErrorArea, {
        errors: hasErr ? errors : warnings,
        showMore: this.state.showMoreErrors,
        onShowMoreToggle: this.onShowMoreToggle,
        errorCheckInProgress: errorCheckInprogress,
        textClass: !hasErr ? _ImportPageModule["default"].warningLine : _ImportPageModule["default"].errorLine
      }), serverOrProbemapError && /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("p", {
        style: {
          color: 'red'
        }
      }, "Unexpected server error occured: ", serverOrProbemapError), /*#__PURE__*/_react["default"].createElement("p", null, "Please ", /*#__PURE__*/_react["default"].createElement("a", {
        href: "mailto:genome-cancer@soe.ucsc.edu?subject=\"Xena import: java error\""
      }, "contact"), " the Xena team for help.")), /*#__PURE__*/_react["default"].createElement(_staticComponents.ErrorPreview, {
        errorSnippets: errorSnippets,
        errorLines: fileContent.slice(0, 2)
      }), isImportSuccessful(this.props.state) && /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("p", null, "Success!")));
    }
  }, {
    key: "renderFilePreview",
    value: function renderFilePreview() {
      var showHighlighting = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var _this$props2 = this.props,
          fileContent = _this$props2.fileContent,
          fileReadInProgress = _this$props2.fileReadInProgress;
      var fileFormat = this.props.state.fileFormat;
      return /*#__PURE__*/_react["default"].createElement(_staticComponents.FilePreview, {
        fileContent: fileContent,
        isLoading: fileReadInProgress,
        highlightRow: fileFormat === _constants.FILE_FORMAT.GENOMIC_MATRIX && showHighlighting,
        highlightColumn: fileFormat === _constants.FILE_FORMAT.CLINICAL_MATRIX && showHighlighting
      });
    }
  }, {
    key: "renderDropdown",
    value: function renderDropdown(onChange, source, value, label, display) {
      return display ? /*#__PURE__*/_react["default"].createElement(_lib.Dropdown, {
        onChange: onChange,
        source: source,
        value: value,
        label: label,
        className: [_ImportPageModule["default"].field, _ImportPageModule["default"].inline].join(' ')
      }) : null;
    }
  }, {
    key: "renderMailto",
    value: function renderMailto(subject, keyword, display) {
      return display ? /*#__PURE__*/_react["default"].createElement("p", {
        className: _ImportPageModule["default"].mailTo
      }, /*#__PURE__*/_react["default"].createElement("a", {
        href: "mailto:genome-cancer@soe.ucsc.edu?subject=".concat(subject)
      }, "Let us know which ", keyword, " you're using"), " so we can better support you in the future.") : null;
    }
  }]);
  return ImportForm;
}(_react["default"].Component);

var ImportPage = /*#__PURE__*/function (_React$Component2) {
  (0, _inherits2["default"])(ImportPage, _React$Component2);

  var _super2 = _createSuper(ImportPage);

  function ImportPage() {
    var _this2;

    (0, _classCallCheck2["default"])(this, ImportPage);
    _this2 = _super2.call(this);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onNavigate", function (page, params) {
      _this2.props.callback(['navigate', page, params]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onViz", function () {
      var form = _this2.props.state["import"].form,
          cohort = form[form.cohortRadio];

      _this2.props.callback(['cohort', cohort]);

      _this2.props.callback(['navigate', 'heatmap']);
    });
    return _this2;
  }

  (0, _createClass2["default"])(ImportPage, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.props.callback(['get-local-cohorts']);
      this.props.callback(['get-probemaps']);
      (0, _nav["default"])({
        activeLink: 'datapages',
        onNavigate: this.onNavigate
      });
    }
  }, {
    key: "render",
    value: function render() {
      var cohorts = this.props.state.wizard.cohorts || [];

      var _ref8 = this.props.state["import"] || {},
          probemaps = _ref8.probemaps,
          _ref8$wizardPage = _ref8.wizardPage,
          wizardPage = _ref8$wizardPage === void 0 ? 0 : _ref8$wizardPage,
          fileContent = _ref8.fileContent,
          fileReadInProgress = _ref8.fileReadInProgress,
          localCohorts = _ref8.localCohorts,
          file = _ref8.file,
          fileName = _ref8.fileName,
          form = _ref8.form,
          _ref8$wizardHistory = _ref8.wizardHistory,
          wizardHistory = _ref8$wizardHistory === void 0 ? [] : _ref8$wizardHistory,
          recommended = _ref8.recommended;

      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
        className: _ImportPageModule["default"].wizardTitle
      }, "Loading data...", /*#__PURE__*/_react["default"].createElement(_lib.Button, {
        label: "Help",
        target: "_blank",
        href: "https://ucsc-xena.gitbook.io/project/local-xena-hub",
        accent: true,
        style: {
          marginLeft: '30px',
          backgroundColor: '#f7f7f7'
        }
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: _ImportPageModule["default"].stepperBox
      }, /*#__PURE__*/_react["default"].createElement(_Stepper.Stepper, {
        mode: wizardPage,
        steps: _constants.steps,
        stateIndex: pageStateIndex,
        flat: true,
        wideStep: true
      }))), /*#__PURE__*/_react["default"].createElement("div", {
        className: _ImportPageModule["default"].container
      }, /*#__PURE__*/_react["default"].createElement(ImportForm, {
        cohorts: cohorts,
        callback: this.props.callback,
        recommended: recommended,
        wizardPage: wizardPage,
        wizardHistory: wizardHistory,
        fileContent: fileContent,
        fileReadInProgress: fileReadInProgress,
        localCohorts: localCohorts,
        probemaps: probemaps,
        file: file,
        fileName: fileName,
        onViz: this.onViz,
        state: form
      })));
    }
  }]);
  return ImportPage;
}(_react["default"].Component);

var ErrorArea = function ErrorArea(_ref9) {
  var errors = _ref9.errors,
      showMore = _ref9.showMore,
      errorCheckInProgress = _ref9.errorCheckInProgress,
      onShowMoreToggle = _ref9.onShowMoreToggle,
      textClass = _ref9.textClass;
  errors = errors || [];
  var items = errors.map(function (error, i) {
    return /*#__PURE__*/_react["default"].createElement("p", {
      key: i,
      className: textClass
    }, error);
  }),
      showMoreText = null;

  if (items.length > 3 && !showMore) {
    items = items.slice(0, 3);
    showMoreText = /*#__PURE__*/_react["default"].createElement("p", {
      className: _ImportPageModule["default"].showMore,
      onClick: onShowMoreToggle
    }, "Show more... (", errors.length, " in total)");
  } else if (showMore) {
    showMoreText = /*#__PURE__*/_react["default"].createElement("p", {
      className: _ImportPageModule["default"].showMore,
      onClick: onShowMoreToggle
    }, "Show less...");
  }

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _ImportPageModule["default"].errorContainer
  }, items, showMoreText, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      textAlign: 'center'
    }
  }, errorCheckInProgress && /*#__PURE__*/_react["default"].createElement("img", {
    src: _loader["default"]
  })));
};

var _default = ImportPage;
exports["default"] = _default;