"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = chunkFile;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

// iterable that returns slices of a file (or blob, I suppose), for working on
// large data in chunks.
// If we use a generator it can only be iterated once. So, manually creating
// an iterable, instead.
function chunkFile(file) {
  var n = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 100 * 1000;
  return (0, _defineProperty2["default"])({}, Symbol.iterator, function () {
    var size = file.size,
        i = 0;
    return {
      next: function next() {
        if (n * i < size) {
          i += 1;
          return {
            value: file.slice(n * (i - 1), Math.min(n * i, size))
          };
        }

        return {
          done: true
        };
      }
    };
  });
}