"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ErrorPreview = exports.FilePreview = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _react = _interopRequireDefault(require("react"));

var _ImportPageModule = _interopRequireDefault(require("./ImportPage.module.css"));

var _loader = _interopRequireDefault(require("./loader.gif"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var maxColumns = 6,
    numRows = 5,
    maxNumRows = 20,
    maxSymbolsInCell = 20;

var cropColumnContent = function cropColumnContent(cell) {
  return cell.length > maxSymbolsInCell ? cell.slice(0, maxSymbolsInCell) + '...' : cell;
};

var cropLines = function cropLines(lines) {
  return lines.map(function (line) {
    var cropped = line.length > maxColumns ? line.slice(0, maxColumns) : line;
    return cropped.map(cropColumnContent);
  });
}; // To keep proper table shape when some columns are missing


var padLines = function padLines(lines) {
  var maxLines = Math.min(Math.max.apply(Math, (0, _toConsumableArray2["default"])(lines.map(function (l) {
    return l.length;
  }))), maxColumns);
  lines = cropLines(lines);
  return lines.map(function (line) {
    var diff = maxLines - line.length;
    return diff > 0 ? [].concat((0, _toConsumableArray2["default"])(line), (0, _toConsumableArray2["default"])(Array(diff).fill(" "))) : line;
  });
};

var getSimpleTableRows = function getSimpleTableRows(lines) {
  return lines.map(function (line, i) {
    return /*#__PURE__*/_react["default"].createElement("tr", {
      key: i
    }, line.map(function (col, j) {
      return /*#__PURE__*/_react["default"].createElement("td", {
        key: j
      }, col);
    }));
  });
};

var FilePreview = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(FilePreview, _React$Component);

  var _super = _createSuper(FilePreview);

  function FilePreview() {
    var _this;

    (0, _classCallCheck2["default"])(this, FilePreview);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      showMore: false
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onShowMore", function () {
      return _this.setState({
        showMore: !_this.state.showMore
      });
    });
    return _this;
  }

  (0, _createClass2["default"])(FilePreview, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          fileContent = _this$props.fileContent,
          highlightRow = _this$props.highlightRow,
          highlightColumn = _this$props.highlightColumn,
          isLoading = _this$props.isLoading,
          takeLines = this.state.showMore ? maxNumRows : numRows,
          lineCount = fileContent.length,
          lines = padLines(fileContent.slice(0, takeLines));
      var tableRows = lines.map(function (r, i) {
        return /*#__PURE__*/_react["default"].createElement("tr", {
          key: i
        }, r.map(function (rr, j) {
          return /*#__PURE__*/_react["default"].createElement("td", {
            key: j,
            className: highlightRow && i === 0 || highlightColumn && j === 0 ? _ImportPageModule["default"].highlighted : null
          }, rr);
        }));
      });
      return isLoading ? /*#__PURE__*/_react["default"].createElement("div", {
        style: {
          textAlign: 'center'
        }
      }, /*#__PURE__*/_react["default"].createElement("img", {
        src: _loader["default"]
      })) : /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("table", {
        className: _ImportPageModule["default"].denseExample
      }, /*#__PURE__*/_react["default"].createElement("tbody", null, tableRows)), this.renderShowMore(lineCount > numRows));
    }
  }, {
    key: "renderShowMore",
    value: function renderShowMore(hasEnoughLines) {
      return !hasEnoughLines ? null : /*#__PURE__*/_react["default"].createElement("i", {
        className: _ImportPageModule["default"].showMore,
        onClick: this.onShowMore
      }, this.state.showMore ? "Show less..." : "Show more...");
    }
  }]);
  return FilePreview;
}(_react["default"].Component);

exports.FilePreview = FilePreview;
;

var ErrorPreview = function ErrorPreview(_ref) {
  var _ref$errorSnippets = _ref.errorSnippets,
      errorSnippets = _ref$errorSnippets === void 0 ? [] : _ref$errorSnippets,
      errorLines = _ref.errorLines;

  if (!errorSnippets.length) {
    return null;
  }

  var exampleLines = errorSnippets[0].exampleLines;
  var errLines = getSimpleTableRows(padLines(errorLines));
  var exampLines = getSimpleTableRows(padLines(exampleLines));
  return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("p", null, "Your file:"), /*#__PURE__*/_react["default"].createElement("table", {
    className: _ImportPageModule["default"].denseExample,
    style: {
      background: '#f69292'
    }
  }, errLines), /*#__PURE__*/_react["default"].createElement("p", null, "Example of correct file:"), /*#__PURE__*/_react["default"].createElement("table", {
    className: _ImportPageModule["default"].denseExample,
    style: {
      background: '#c7f2c7'
    }
  }, exampLines));
};

exports.ErrorPreview = ErrorPreview;