var _ = require('./underscore_ext')["default"];

var _require = require('reselect'),
    createSelectorCreator = _require.createSelectorCreator,
    defaultMemoize = _require.defaultMemoize;

var _require2 = require('./defaultServers'),
    publicServers = _require2.publicServers;

var createSelector = createSelectorCreator(defaultMemoize, _.isEqual);
module.exports = createSelector(function (state) {
  return _.pluck(state.columns, 'dsID');
}, function (state) {
  return state.hasPrivateSamples;
}, function (dsIDs, hasPrivateSamples) {
  return _.Let(function () {
    var pub = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new Set(publicServers);
    return !hasPrivateSamples && _.every(dsIDs, function (dsID) {
      return !dsID || pub.has(JSON.parse(dsID).host);
    });
  });
});