"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

require("./base");

require("./plotDenseMatrix");

require("./plotMutationVector");

require("./plotSegmented");

require("./plotSamples");

require("./ChromPosition");

require("./models/denseMatrix");

require("./models/mutationVector");

require("./models/segmented");

var _ui = _interopRequireDefault(require("./controllers/ui"));

var _server = _interopRequireDefault(require("./controllers/server"));

var _hub = _interopRequireDefault(require("./controllers/hub"));

var _wizard = _interopRequireDefault(require("./controllers/wizard"));

var _transcripts = _interopRequireDefault(require("./controllers/transcripts"));

var _import = _interopRequireDefault(require("./controllers/import"));

var _PageContainer = _interopRequireDefault(require("./containers/PageContainer"));

var _appSelector = _interopRequireDefault(require("./appSelector"));

var _utils = require("./controllers/utils");

var _connection = _interopRequireDefault(require("./controllers/connection"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _ = require('./underscore_ext')["default"];

var connector = require('./connector');

var createStore = require('./store'); // Hot load controllers. Note that hot loading won't work if one of the methods
// is captured in a closure or variable which we can't access.  References to
// the controller methods should only happen by dereferencing the module. That's
// currently true of the controllers/compose method, so we are able to hot
// load by overwritting the methods, here. However it's not true of devtools.
// If we had a single controller (i.e. no call to compose), passing a single
// controller to devtools would defeat the hot loading. Sol'n would be to
// update devtools to always dereference the controller, rather than keeping
// methods in closures.
// Rx streams in components are also a problem.


if (module.hot) {
  module.hot.accept('./controllers/ui', function () {
    var newModule = require('./controllers/ui')["default"];

    _.extend(_ui["default"], newModule);
  });
  module.hot.accept('./controllers/server', function () {
    var newModule = require('./controllers/server')["default"];

    _.extend(_server["default"], newModule);
  });
  module.hot.accept('./controllers/hub', function () {
    var newModule = require('./controllers/hub')["default"];

    _.extend(_hub["default"], newModule);
  });
  module.hot.accept('./controllers/wizard', function () {
    var newModule = require('./controllers/wizard')["default"];

    _.extend(_wizard["default"], newModule);
  });
  module.hot.accept('./controllers/transcripts', function () {
    var newModule = require('./controllers/transcripts')["default"];

    _.extend(_transcripts["default"], newModule);
  });
  module.hot.accept('./controllers/import', function () {
    var newModule = require('./controllers/import')["default"];

    _.extend(_import["default"], newModule);
  }); //	module.hot.accept('./controllers/ties', () => {
  //		let newModule = require('./controllers/ties');
  //		_.extend(tiesController, newModule);
  //	});
  // XXX Note that hot-loading these won't cause a re-render.

  module.hot.accept('./models/mutationVector', function () {});
  module.hot.accept('./models/denseMatrix', function () {});
  module.hot.accept('./models/segmented', function () {});
}

var store = createStore();
var main = window.document.getElementById('main'); // controllers run in the opposite order as listed in compose().

var controller = (0, _utils.compose)((0, _connection["default"])(store.uiBus), _hub["default"], _server["default"], _wizard["default"], _ui["default"], _transcripts["default"], _import["default"]
/*, tiesController*/
);
connector(_objectSpread(_objectSpread({}, store), {}, {
  controller: controller,
  main: main,
  selector: _appSelector["default"],
  Page: _PageContainer["default"],
  persist: true,
  history: false
}));