"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = parse;

var _require$default = require('./underscore_ext')["default"],
    isString = _require$default.isString,
    isArray = _require$default.isArray,
    isObject = _require$default.isObject;

var schemaCheck = function schemaCheck(data) {
  return isObject(data) && isString(data.cohort) && isArray(data.samples) && data.samples.every(isString) && data || undefined;
};

function parse(manifest) {
  var m = schemaCheck(JSON.parse(manifest));

  if (!m) {
    throw new Error('Unable to read manifest', manifest);
  } // XXX need to handle manifest-error action & report to user.


  return m;
}