"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _GeneSetViewDialog = require("./views/GeneSetViewDialog");

var _app_bar = _interopRequireDefault(require("react-toolbox/lib/app_bar"));

var _navigation = _interopRequireDefault(require("react-toolbox/lib/navigation"));

var _reactCssThemr = require("react-css-themr");

var _link = _interopRequireDefault(require("react-toolbox/lib/link"));

var _menu = require("react-toolbox/lib/menu");

var _button = require("react-toolbox/lib/button");

var _logoSantaCruz = _interopRequireDefault(require("../images/logoSantaCruz.png"));

var _logoSantaCruz2x = _interopRequireDefault(require("../images/logoSantaCruz@2x.png"));

var _logoSantaCruz3x = _interopRequireDefault(require("../images/logoSantaCruz@3x.png"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

// Core dependencies, components
var React = require('react');

var ReactDOM = require('react-dom');

var _ = require('./underscore_ext')["default"];

var navTheme = require('./navTheme');

var BookmarkMenu = require('./views/BookmarkMenu');

var _require = require('./defaultServers'),
    localHub = _require.servers.localHub; // Styles


var compStyles = require('./nav.module.css'); // Images


// Locals
var links = [{
  label: 'Data Sets',
  nav: 'datapages'
}, {
  label: 'Visualization',
  nav: 'heatmap'
}, {
  label: 'Transcripts',
  nav: 'transcripts'
}, {
  label: 'Data Hubs',
  nav: 'hub'
}, {
  label: 'View My Data',
  nav: 'datapages',
  params: {
    addHub: localHub,
    host: localHub
  }
}];
var helproot = 'https://ucsc-xena.gitbook.io/project/';
var helpLink = {
  href: helproot,
  label: 'Help',
  target: '_blank'
};
var geneSetsLink = {
  //eslint-disable-line no-unused-vars
  href: _GeneSetViewDialog.GENESETS_VIEWER_URL,
  label: 'Gene Sets',
  target: '_blank'
};
var pythonLink = {
  href: helproot + 'overview-of-features/accessing-data-through-python',
  label: 'Python',
  target: '_blank'
};

var active = function active(l, activeLink) {
  return l.nav === activeLink;
};

var MoreToolsMenu = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(MoreToolsMenu, _React$Component);

  var _super = _createSuper(MoreToolsMenu);

  function MoreToolsMenu() {
    var _this;

    (0, _classCallCheck2["default"])(this, MoreToolsMenu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      anchorEl: null
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onClick", function (event) {
      _this.setState({
        anchorEl: event.currentTarget
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClose", function () {
      _this.setState({
        anchorEl: null
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSelect", function (url) {
      window.open(url);
    });
    return _this;
  }

  (0, _createClass2["default"])(MoreToolsMenu, [{
    key: "render",
    value: function render() {
      var anchorEl = this.state.anchorEl;
      return /*#__PURE__*/React.createElement("div", {
        style: {
          display: "inline",
          position: 'relative'
        }
      }, /*#__PURE__*/React.createElement(_button.Button, {
        onClick: this.onClick
      }, "More Tools"), /*#__PURE__*/React.createElement(_menu.Menu, {
        position: "topLeft",
        active: Boolean(anchorEl),
        onHide: this.handleClose,
        className: compStyles.menu
      }, /*#__PURE__*/React.createElement(_menu.MenuItem, {
        onClick: this.handleSelect.bind(this, pythonLink.href),
        caption: pythonLink.label
      })));
    }
  }]);
  return MoreToolsMenu;
}(React.Component);

var XenaNav = /*#__PURE__*/function (_React$Component2) {
  (0, _inherits2["default"])(XenaNav, _React$Component2);

  var _super2 = _createSuper(XenaNav);

  function XenaNav() {
    (0, _classCallCheck2["default"])(this, XenaNav);
    return _super2.apply(this, arguments);
  }

  (0, _createClass2["default"])(XenaNav, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          isPublic = _this$props.isPublic,
          activeLink = _this$props.activeLink,
          getState = _this$props.getState,
          onImport = _this$props.onImport;

      var routes = _.map(links, function (l) {
        var nav = l.nav,
            params = l.params,
            others = (0, _objectWithoutProperties2["default"])(l, ["nav", "params"]),
            onClick = nav ? function () {
          return _this2.props.onNavigate(nav, params);
        } : undefined;
        return _objectSpread(_objectSpread({}, others), {}, {
          onClick: onClick,
          active: active(l, activeLink)
        });
      });

      var logoSrcSet = "".concat(_logoSantaCruz2x["default"], " 2x, ").concat(_logoSantaCruz3x["default"], " 3x");
      return /*#__PURE__*/React.createElement(_app_bar["default"], {
        className: compStyles.NavAppBar
      }, /*#__PURE__*/React.createElement("a", {
        href: "http://xena.ucsc.edu/",
        className: compStyles.logoXena
      }, /*#__PURE__*/React.createElement("img", {
        title: window.ga ? '' : 'no analytics',
        src: _logoSantaCruz["default"],
        srcSet: logoSrcSet
      })), /*#__PURE__*/React.createElement(_navigation["default"], {
        type: "horizontal",
        routes: routes
      }, getState ? /*#__PURE__*/React.createElement(BookmarkMenu, {
        isPublic: isPublic,
        getState: getState,
        onImport: onImport
      }) : null, /*#__PURE__*/React.createElement(_link["default"], helpLink), /*#__PURE__*/React.createElement(MoreToolsMenu, null)));
    }
  }]);
  return XenaNav;
}(React.Component);

var ThemedNav = /*#__PURE__*/function (_React$Component3) {
  (0, _inherits2["default"])(ThemedNav, _React$Component3);

  var _super3 = _createSuper(ThemedNav);

  function ThemedNav() {
    (0, _classCallCheck2["default"])(this, ThemedNav);
    return _super3.apply(this, arguments);
  }

  (0, _createClass2["default"])(ThemedNav, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(_reactCssThemr.ThemeProvider, {
        theme: navTheme
      }, /*#__PURE__*/React.createElement(XenaNav, this.props));
    }
  }]);
  return ThemedNav;
}(React.Component);

var nav = document.getElementById('navMenuMain');

var _default = function _default(props) {
  return ReactDOM.render( /*#__PURE__*/React.createElement(ThemedNav, props), nav);
};

exports["default"] = _default;