"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ = require('./underscore_ext')["default"];

var download = function download() {
  require.ensure(['pdfkit', 'svg-to-pdfkit', 'blob-stream'], function () {
    var PDFDocument = require('pdfkit');

    var blobStream = require('blob-stream');

    var SVGtoPDF = require('svg-to-pdfkit');

    var svg = document.getElementsByClassName('highcharts-root')[0],
        r = svg.getBoundingClientRect(),
        doc = new PDFDocument({
      compress: false,
      size: [r.width, r.height]
    }),
        buttons = document.getElementsByClassName('highcharts-button'),
        scrollBars = document.getElementsByClassName('highcharts-scrollbar'),
        btnDisplay = _.map(buttons, function (b) {
      return b.style.display;
    }),
        sBDisplay = _.map(scrollBars, function (b) {
      return b.style.display;
    }),
        stream = doc.pipe(blobStream());

    _.forEach(buttons, function (b) {
      return b.style.display = 'none';
    });

    _.forEach(scrollBars, function (b) {
      return b.style.display = 'none';
    });

    SVGtoPDF(doc, svg, 0, 0, {
      preserveAspectRatio: 'xMidYMid'
    });

    _.forEach(buttons, function (b, i) {
      return b.style.display = btnDisplay[i];
    });

    _.forEach(scrollBars, function (b, i) {
      return b.style.display = sBDisplay[i];
    });

    doc.end();
    stream.on('finish', function () {
      var url = stream.toBlobURL('application/pdf');
      var a = document.createElement('a');
      var filename = 'xenaDownload.pdf';
      Object.assign(a, {
        id: filename,
        download: filename,
        href: url
      });
      document.body.appendChild(a);
      a.click();
      document.body.removeChild(a);
    });
  });
};

var _default = download;
exports["default"] = _default;