"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _PureComponent2 = _interopRequireDefault(require("./PureComponent"));

var _reactHotLoader = require("react-hot-loader");

var _temp;

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _ = require('./underscore_ext')["default"];

var Rx = require('./rx')["default"];

var React = require('react');

var Legend = require('./views/Legend');

var _require = require('./react-utils'),
    rxEvents = _require.rxEvents;

var widgets = require('./columnWidgets');

var util = require('./util')["default"];

var CanvasDrawing = require('./CanvasDrawing');

var mv = require('./models/mutationVector');

var _require2 = require('./drawMutations'),
    drawSV = _require2.drawSV,
    drawMutations = _require2.drawMutations,
    radius = _require2.radius,
    toYPx = _require2.toYPx,
    toYPxSubRow = _require2.toYPxSubRow,
    minVariantHeight = _require2.minVariantHeight,
    splitRows = _require2.splitRows;

var _require3 = require('./exonLayout'),
    chromPositionFromScreen = _require3.chromPositionFromScreen; // Since there are multiple components in the file we have to use hot
// explicitly.


function hotOrNot(component) {
  return module.hot ? (0, _reactHotLoader.hot)(module)(component) : component;
}

function drawMutationLegend(_ref) {
  var column = _ref.column;

  if (!column.legend) {
    return null;
  }

  var _column$legend = column.legend,
      colors = _column$legend.colors,
      labels = _column$legend.labels,
      titles = _column$legend.titles,
      labelheader = "Variant Impact";
  return /*#__PURE__*/React.createElement(Legend, {
    colors: colors,
    labels: labels,
    titles: titles,
    addNullNotation: 1,
    labelheader: labelheader
  });
}

function drawSVLegend(_ref2) {
  var column = _ref2.column;

  if (!column.legend) {
    return null;
  }

  var _column$legend2 = column.legend,
      colors = _column$legend2.colors,
      labels = _column$legend2.labels,
      titles = _column$legend2.titles,
      labelheader = "Variant Impact";
  return /*#__PURE__*/React.createElement(Legend, {
    colors: colors,
    labels: labels,
    titles: titles,
    addBreakend: 1,
    addNullNotation: 1,
    labelheader: labelheader
  });
}

function closestNodeSNV(nodes, zoom, x, y) {
  var cutoffX = radius,
      index = zoom.index,
      height = zoom.height,
      count = zoom.count,
      cutoffY = minVariantHeight(height / count) / 2,
      end = index + count,
      nearBy = _.filter(nodes, function (n) {
    return n.y >= index && n.y < end && Math.abs(y - toYPx(zoom, n).y) < cutoffY && x > n.xStart - cutoffX && x < n.xEnd + cutoffX;
  });

  var closest = _.max(nearBy, function (n) {
    return mv.impact[mv.getSNVEffect(mv.impact, n.data.effect)] || 0;
  }),
      //multiple records of the same location same sample
  allClosest = _.filter(nearBy, function (n) {
    return n.data.start === closest.data.start && n.data.end === closest.data.end && n.data.sample === closest.data.sample;
  });

  return allClosest;
}

function closestNodeSV(nodes, zoom, x, y) {
  var index = zoom.index,
      height = zoom.height,
      count = zoom.count,
      end = index + count,
      toY = splitRows(count, height) ? toYPxSubRow : toYPx,
      underRow = function underRow(v) {
    var _toY = toY(zoom, v),
        svHeight = _toY.svHeight,
        suby = _toY.y;

    return Math.abs(y - suby) < svHeight / 2;
  },
      underMouse = _.filter(nodes, function (n) {
    return n.y >= index && n.y < end && x >= n.xStart && x <= n.xEnd && underRow(n);
  });

  return underMouse;
}

var closestNode = {
  SV: closestNodeSV,
  mutation: closestNodeSNV
};

function formatAf(af) {
  return af === 'NA' || af === '' || af == null ? null : Math.round(af * 100) + '%';
}

var fmtIf = function fmtIf(x, fmt) {
  var d = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  return _.isString(x) && x !== 'NaN' && x !== '' ? fmt(x) : d;
};

var dropNulls = function dropNulls(rows) {
  return rows.map(function (row) {
    return row.filter(function (col) {
      return col != null;
    });
  }) // drop empty cols
  .filter(function (row) {
    return row.length > 0;
  });
}; // drop empty rows
//gb position string of the segment with 15bp extra on each side, centered at segment


var posRegionString = function posRegionString(p) {
  return "".concat(p.chr, ":").concat(util.addCommas(p.start - 15), "-").concat(util.addCommas(p.end + 15));
}; //gb position string like chr3:178,936,070-178,936,070


var posDoubleString = function posDoubleString(p) {
  return "".concat(p.chr, ":").concat(util.addCommas(p.start), "-").concat(util.addCommas(p.end));
}; //gb position string like chr3:178,936,070


var posStartString = function posStartString(p) {
  return "".concat(p.chr, ":").concat(util.addCommas(p.start));
};

var gbURL = function gbURL(assembly, pos, highlightPos, GBoptions) {
  // assembly : e.g. hg18
  // pos: e.g. chr3:178,936,070-178,936,070
  // highlight: e.g. chr3:178,936,070-178,936,070
  // GBoptions.hubUrl: To build a URL that will load the hub directly
  // GBoptions.fullTracks: full display mode track list
  var assemblyString = encodeURIComponent(assembly),
      positionString = encodeURIComponent(pos),
      highlightString = encodeURIComponent(highlightPos),
      hubString = GBoptions && GBoptions.assembly === assembly && GBoptions.hubUrl ? "&hubUrl=" + encodeURIComponent(GBoptions.hubUrl) : '',
      trackString = GBoptions && GBoptions.fullTracks ? '&hideTracks=1' + GBoptions.fullTracks.map(function (track) {
    return "&".concat(track, "=full");
  }).join('') : '',
      GBurl = "http://genome.ucsc.edu/cgi-bin/hgTracks?db=".concat(assemblyString).concat(hubString).concat(trackString, "&highlight=").concat(assemblyString, ".").concat(highlightString, "&position=").concat(positionString);
  return GBurl;
};

var gbMultiColorURL = function gbMultiColorURL(assembly, pos, posColorList, GBoptions) {
  // assembly : e.g. hg18
  // pos: e.g. chr3:178,936,070-178,936,070
  // posColorList: [[chr3:178,936,070-178,936,070, AA0000], ...]
  // GBoptions.hubUrl: To build a URL that will load the hub directly
  // GBoptions.fullTracks: full display mode track list
  var assemblyString = encodeURIComponent(assembly),
      positionString = encodeURIComponent(pos),
      highlightString = posColorList.map(function (p) {
    return "".concat(assemblyString, ".").concat(p[0]).concat(p[1]);
  }).join('|'),
      hubString = GBoptions && GBoptions.hubUrl ? "&hubUrl=" + encodeURIComponent(GBoptions.hubUrl) : '',
      trackString = GBoptions && GBoptions.assembly === assembly && GBoptions.fullTracks ? '&hideTracks=1' + GBoptions.fullTracks.map(function (track) {
    return "&".concat(track, "=full");
  }).join('') : '',
      GBurl = "http://genome.ucsc.edu/cgi-bin/hgTracks?db=".concat(assemblyString).concat(hubString).concat(trackString, "&highlight=").concat(encodeURIComponent(highlightString), "&position=").concat(positionString);
  return GBurl;
};

var defaultSNVSVGBsetting = function defaultSNVSVGBsetting(assembly) {
  if (assembly === 'hg19' || assembly === 'GRCh37') {
    return {
      assembly: assembly,
      hubUrl: 'http://hgwdev.soe.ucsc.edu/~max/immuno/track/hub/hub.txt',
      // Max Haussler's cancer genomics hub
      fullTracks: ['knownGene', 'refGene', 'wgEncodeGencodeV24lift37', // gene annotation
      'ucscGenePfam', 'spUniprot', // protein annotation
      //'pubs', // publication
      'wgEncodeRegDnaseClustered', 'wgEncodeAwgSegmentation', // encode regulation
      'hub_29889_dienstmann', 'hub_29889_civic', 'hub_29889_oncokb' // cancer genomics knowledgebase
      ]
    };
  } else if (assembly === 'hg38' || assembly === 'GRCh38') {
    return {
      assembly: assembly,
      fullTracks: ['knownGene', 'refGene', // gene annotation
      'ucscGenePfam', 'spUniprot', // protein annotation
      //'pubs', // publication
      'wgEncodeRegDnaseClustered' // encode regulation
      ]
    };
  } else {
    return {};
  }
};

function sampleTooltip(sampleFormat, dataList, assembly, fields) {
  var perRowTip = function perRowTip(data) {
    var dnaVaf = data.dnaVaf == null ? null : ['labelValue', 'DNA variant allele freq', formatAf(data.dnaVaf)],
        rnaVaf = data.rnaVaf == null ? null : ['labelValue', 'RNA variant allele freq', formatAf(data.rnaVaf)],
        ref = data.reference && ['label', " ".concat(data.reference, " to ")],
        //alt
    altDirection = data.alt && mv.joinedVariantDirection(data.alt),
        altStart = altDirection && parseInt(mv.posFromAlt(data.alt)),
        altPos = altDirection && "chr".concat(mv.chromFromAlt(data.alt), ":").concat(altStart, "-").concat(altStart),
        altRegion = altDirection && altDirection === 'left' ? "chr".concat(mv.chromFromAlt(data.alt), ":").concat(altStart - 100, "-").concat(altStart - 1) : "chr".concat(mv.chromFromAlt(data.alt), ":").concat(altStart + 1, "-").concat(altStart + 100),
        altDisplayRegion = altDirection && "chr".concat(mv.chromFromAlt(data.alt), ":").concat(altStart - 150, "-").concat(altStart + 150),
        //variant
    variantDirection = data.alt && mv.structuralVariantClass(data.alt),
        start = data.start,
        dataRegion = variantDirection && variantDirection === 'left' ? "".concat(data.chr, ":").concat(start - 100, "-").concat(start - 1) : "".concat(data.chr, ":").concat(start + 1, "-").concat(start + 100),
        dataDisplayRegion = altDirection && "".concat(data.chr, ":").concat(start - 150, "-").concat(start + 150),
        //alt link
    alt = data.alt && (mv.structuralVariantClass(data.alt) ? ['url', "".concat(data.alt), gbMultiColorURL(assembly, altDisplayRegion, [[altPos, '#AA0000'], [altRegion, '#aec7e8']], defaultSNVSVGBsetting(assembly))] : ['label', "".concat(data.alt)]),
        //variant link
    posDisplay = data && data.start === data.end ? posStartString(data) : posDoubleString(data),
        posURL = ['url', "".concat(assembly, " ").concat(posDisplay), altDirection ? gbMultiColorURL(assembly, dataDisplayRegion, [[posDoubleString(data), '#AA0000'], [dataRegion, '#aec7e8']], defaultSNVSVGBsetting(assembly)) : gbURL(assembly, posRegionString(data), posDoubleString(data), defaultSNVSVGBsetting(assembly))],
        effect = ['value', fmtIf(data.effect, function (x) {
      return "".concat(x, ", ");
    }, "unannotated") + //eslint-disable-line comma-spacing
    fmtIf(data.gene, function (x) {
      return "".concat(x);
    }) + fmtIf(data.aminoAcid, function (x) {
      return " (".concat(x, ")");
    }) + fmtIf(data.altGene, function (x) {
      return "--".concat(x, " ");
    })];
    return dropNulls([[effect], [posURL, ref, alt], [dnaVaf], [rnaVaf]]);
  }; //sort dataList by fields[0], put variants annoated with fields[0] in dataset in front


  dataList = _.sortBy(dataList, function (obj) {
    return obj.gene === fields[0];
  }).reverse();

  var rows = _.reduce(_.map(dataList
  /*.slice(0, 3)*/
  , perRowTip), function (a, b) {
    return a.concat(b);
  }, []); //	if (dataList.length > 3) {
  //		var allRows = rows.concat(_.reduce(_.map(dataList.slice(3), perRowTip), function(a, b) { return b.concat(a); }, []));
  //		rows.push([["popOver", dataList.length - 3 + " more ...", allRows]]);
  //	}


  return {
    rows: rows,
    sampleID: sampleFormat(dataList[0].sample)
  };
}

function posTooltip(layout, samples, sampleFormat, pixPerRow, index, assembly, x, y) {
  var yIndex = Math.round((y - pixPerRow / 2) / pixPerRow + index),
      pos = Math.floor(chromPositionFromScreen(layout, x)),
      coordinate = {
    chr: layout.chromName,
    start: pos,
    end: pos
  };
  return {
    sampleID: sampleFormat(samples[yIndex]),
    rows: [[['url', "".concat(assembly, " ").concat(posStartString(coordinate)), gbURL(assembly, posRegionString(coordinate), posDoubleString(coordinate))]]]
  };
}

function tooltip(id, fieldType, fields, layout, nodes, samples, sampleFormat, zoom, assembly, ev) {
  var _util$eventOffset = util.eventOffset(ev),
      x = _util$eventOffset.x,
      y = _util$eventOffset.y,
      height = zoom.height,
      count = zoom.count,
      index = zoom.index,
      pixPerRow = height / count,
      lo = _.updateIn(layout, ['chromName'], function (c) {
    return c || _.getIn(nodes, [0, 'data', 'chr']);
  }),
      closestNodes = closestNode[fieldType](nodes, zoom, x, y);

  return _objectSpread({
    x: x,
    id: id
  }, closestNodes.length > 0 ? sampleTooltip(sampleFormat, _.pluck(closestNodes, 'data'), assembly, fields) : posTooltip(lo, samples, sampleFormat, pixPerRow, index, assembly, x, y));
}

var MutationColumn = hotOrNot((_temp = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(_temp, _PureComponent);

  var _super = _createSuper(_temp);

  function _temp() {
    var _this;

    (0, _classCallCheck2["default"])(this, _temp);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "tooltip", function (ev) {
      var _this$props = _this.props,
          _this$props$column = _this$props.column,
          fieldType = _this$props$column.fieldType,
          fields = _this$props$column.fields,
          layout = _this$props$column.layout,
          nodes = _this$props$column.nodes,
          assembly = _this$props$column.assembly,
          samples = _this$props.samples,
          sampleFormat = _this$props.sampleFormat,
          zoom = _this$props.zoom,
          id = _this$props.id;
      return tooltip(id, fieldType, fields, layout, nodes, samples, sampleFormat, zoom, assembly, ev);
    });
    return _this;
  }

  (0, _createClass2["default"])(_temp, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      var events = rxEvents(this, 'mouseout', 'mousemove', 'mouseover'); // Compute tooltip events from mouse events.

      this.ttevents = events.mouseover.filter(function (ev) {
        return util.hasClass(ev.currentTarget, 'Tooltip-target');
      }).flatMap(function () {
        return events.mousemove.takeUntil(events.mouseout).map(function (ev) {
          return {
            data: _this2.tooltip(ev),
            open: true
          };
        }) // look up current data
        .concat(Rx.Observable.of({
          open: false
        }));
      }).subscribe(this.props.tooltip);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.ttevents.unsubscribe();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          column = _this$props2.column,
          samples = _this$props2.samples,
          zoom = _this$props2.zoom,
          index = _this$props2.index,
          draw = _this$props2.draw;
      return /*#__PURE__*/React.createElement(CanvasDrawing, {
        ref: "plot",
        draw: draw,
        wrapperProps: {
          className: 'Tooltip-target',
          onMouseMove: this.on.mousemove,
          onMouseOut: this.on.mouseout,
          onMouseOver: this.on.mouseover,
          onClick: this.props.onClick
        },
        nodes: column.nodes,
        strand: column.strand,
        width: column.width,
        index: index,
        samples: samples,
        xzoom: column.zoom,
        zoom: zoom
      });
    }
  }]);
  return _temp;
}(_PureComponent2["default"]), _temp));
widgets.column.add('mutation', function (props) {
  return /*#__PURE__*/React.createElement(MutationColumn, (0, _extends2["default"])({
    draw: drawMutations
  }, props));
});
widgets.column.add('SV', function (props) {
  return /*#__PURE__*/React.createElement(MutationColumn, (0, _extends2["default"])({
    draw: drawSV
  }, props));
});
widgets.legend.add('mutation', drawMutationLegend);
widgets.legend.add('SV', drawSVLegend);