"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _PureComponent2 = _interopRequireDefault(require("./PureComponent"));

var _reactHotLoader = require("react-hot-loader");

var _temp;

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var _ = require('./underscore_ext')["default"];

var Rx = require('./rx')["default"];

var widgets = require('./columnWidgets');

var util = require('./util')["default"];

var React = require('react');

var CanvasDrawing = require('./CanvasDrawing');

var _require = require('./react-utils'),
    rxEvents = _require.rxEvents;

var _require2 = require('./drawSamples'),
    drawSamples = _require2.drawSamples; // Since there are multiple components in the file we have to use hot
// explicitly.


function hotOrNot(component) {
  return module.hot ? (0, _reactHotLoader.hot)(module)(component) : component;
} //
// Tooltip
//
// We're getting events with coords < 0. Not sure if this
// is a side-effect of the react event system. This will
// restrict values to the given range.


function bounded(min, max, x) {
  return x < min ? min : x > max ? max : x;
}

function tooltip(heatmap, sampleFormat, codes, width, zoom, samples, ev) {
  var coord = util.eventOffset(ev),
      sampleIndex = bounded(0, samples.length, Math.floor(coord.y * zoom.count / zoom.height + zoom.index)),
      sampleID = samples[sampleIndex];

  var val = _.getIn(heatmap, [0, sampleIndex]),
      code = _.get(codes, val, 'NA');

  return {
    sampleID: sampleFormat(sampleID),
    rows: [[['labelValue', 'sample', code]]]
  };
} //
// plot rendering
//


var SamplesColumn = hotOrNot(( //
// plot rendering
//
_temp = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(_temp, _PureComponent);

  var _super = _createSuper(_temp);

  function _temp() {
    var _this;

    (0, _classCallCheck2["default"])(this, _temp);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "tooltip", function (ev) {
      var _this$props = _this.props,
          samples = _this$props.samples,
          data = _this$props.data,
          column = _this$props.column,
          zoom = _this$props.zoom,
          sampleFormat = _this$props.sampleFormat,
          codes = _.get(data, 'codes'),
          heatmap = column.heatmap,
          width = column.width;

      return tooltip(heatmap, sampleFormat, codes, width, zoom, samples, ev);
    });
    return _this;
  }

  (0, _createClass2["default"])(_temp, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      var events = rxEvents(this, 'mouseout', 'mousemove', 'mouseover'); // Compute tooltip events from mouse events.

      this.ttevents = events.mouseover.filter(function (ev) {
        return util.hasClass(ev.currentTarget, 'Tooltip-target');
      }).flatMap(function () {
        return events.mousemove.takeUntil(events.mouseout).map(function (ev) {
          return {
            data: _this2.tooltip(ev),
            open: true
          };
        }) // look up current data
        .concat(Rx.Observable.of({
          open: false
        }));
      }).subscribe(this.props.tooltip);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.ttevents.unsubscribe();
    }
  }, {
    key: "render",
    // To reduce this set of properties, we could
    //    - Drop data & move codes into the 'display' obj, outside of data
    // Might also want to copy fields into 'display', so we can drop req probes
    value: function render() {
      var _this$props2 = this.props,
          data = _this$props2.data,
          column = _this$props2.column,
          zoom = _this$props2.zoom,
          heatmap = column.heatmap,
          codes = _.get(data, 'codes');

      return /*#__PURE__*/React.createElement(CanvasDrawing, {
        ref: "plot",
        draw: drawSamples,
        wrapperProps: {
          className: 'Tooltip-target',
          onMouseMove: this.on.mousemove,
          onMouseOut: this.on.mouseout,
          onMouseOver: this.on.mouseover,
          onClick: this.props.onClick
        },
        codes: codes,
        width: _.get(column, 'width'),
        zoom: zoom,
        heatmapData: heatmap
      });
    }
  }]);
  return _temp;
}(_PureComponent2["default"]), _temp));

var getColumn = function getColumn(props) {
  return /*#__PURE__*/React.createElement(SamplesColumn, props);
};

widgets.column.add("samples", getColumn);

var getLegend = function getLegend() {
  return null;
};

widgets.legend.add('samples', getLegend);