"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _PureComponent2 = _interopRequireDefault(require("./PureComponent"));

var _colorScales = require("./colorScales");

var _reactHotLoader = require("react-hot-loader");

var _temp;

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _ = require('./underscore_ext')["default"];

var Rx = require('./rx')["default"];

var React = require('react');

var BandLegend = require('./views/BandLegend');

var _require = require('./react-utils'),
    rxEvents = _require.rxEvents;

var widgets = require('./columnWidgets');

var util = require('./util')["default"];

var CanvasDrawing = require('./CanvasDrawing');

var _require2 = require('./drawSegmented'),
    drawSegmented = _require2.drawSegmented,
    toYPx = _require2.toYPx;

var _require3 = require('./exonLayout'),
    chromPositionFromScreen = _require3.chromPositionFromScreen;

function hotOrNot(component) {
  return module.hot ? (0, _reactHotLoader.hot)(module)(component) : component;
} // might want to use <wbr> here, instead, so cut & paste work better, but that
// will require a recursive split/flatmap to inject the <wbr> elements.


var addWordBreaks = function addWordBreaks(str) {
  return str.replace(/([_/])/g, "\u200B$1\u200B");
};

function renderFloatLegend(props) {
  var units = props.units,
      color = props.color;

  if (color[0] === 'no-data') {
    return null;
  }

  var unitText = (units || [''])[0] || '',
      footnotes = [/*#__PURE__*/React.createElement("span", {
    title: unitText
  }, addWordBreaks(unitText))];

  var _color$slice = color.slice(4),
      _color$slice2 = (0, _slicedToArray2["default"])(_color$slice, 3),
      origin = _color$slice2[0],
      max = _color$slice2[2],
      powerScale = (0, _colorScales.colorScale)(color).lookup,
      scale = function scale(v) {
    return v < origin ? powerScale(0, origin - v) : powerScale(1, v - origin);
  },
      min = origin - (max - origin);

  return /*#__PURE__*/React.createElement(BandLegend, {
    range: {
      min: min,
      max: max
    },
    colorScale: scale,
    footnotes: footnotes,
    width: 50,
    height: 20
  });
}

function drawLegend(props) {
  var column = props.column,
      units = column.units,
      color = column.color,
      vizSettings = column.vizSettings,
      defaultNormalization = column.defaultNormalization,
      legendProps = {
    units: units,
    color: color,
    vizSettings: vizSettings,
    defaultNormalization: defaultNormalization
  };
  return renderFloatLegend(legendProps);
}

function closestNode(nodes, zoom, x, y) {
  var index = zoom.index,
      count = zoom.count,
      end = index + count,
      underRow = function underRow(v) {
    var _toYPx = toYPx(zoom, v),
        svHeight = _toYPx.svHeight,
        suby = _toYPx.y;

    return Math.abs(y - suby) < svHeight / 2;
  },
      underMouse = _.filter(nodes, function (n) {
    return n.y >= index && n.y < end && x >= n.xStart && x <= n.xEnd && underRow(n);
  });

  return underMouse[0];
} //var fmtIf = (x, fmt, d = '' ) => x ? fmt(x) : d;


var dropNulls = function dropNulls(rows) {
  return rows.map(function (row) {
    return row.filter(function (col) {
      return col != null;
    });
  }) // drop empty cols
  .filter(function (row) {
    return row.length > 0;
  });
}; // drop empty rows
//gb position string for 1.5 x segment, centered at segment


var posRegionString = function posRegionString(chrom, p) {
  return "".concat(chrom, ":").concat(util.addCommas(p.start - Math.round((p.end - p.start) / 4)), "-").concat(util.addCommas(p.end + Math.round((p.end - p.start) / 4)));
}; //gb position string like chr3:178,936,070-178,936,070


var posDoubleString = function posDoubleString(chrom, p) {
  return "".concat(chrom, ":").concat(util.addCommas(p.start), "-").concat(util.addCommas(p.end));
}; //gb position string like chr3:178,936,070


var posStartString = function posStartString(chrom, p) {
  return "".concat(chrom, ":").concat(util.addCommas(p.start));
}; // gb url link with highlight


var gbURL = function gbURL(assembly, pos, highlightPos) {
  // assembly : e.g. hg18
  // pos: e.g. chr3:178,936,070-178,936,070
  // highlight: e.g. chr3:178,936,070-178,936,070
  var assemblyString = encodeURIComponent(assembly),
      positionString = encodeURIComponent(pos),
      highlightString = encodeURIComponent(highlightPos);
  return "http://genome.ucsc.edu/cgi-bin/hgTracks?db=".concat(assemblyString, "&highlight=").concat(assemblyString, ".").concat(highlightString, "&position=").concat(positionString);
};

function sampleTooltip(chrom, sampleFormat, data, gene, assembly) {
  var posDisplay = data && data.start === data.end ? posStartString(chrom, data) : posDoubleString(chrom, data),
      posURL = ['url', "".concat(assembly, " ").concat(posDisplay), gbURL(assembly, posRegionString(chrom, data), posDoubleString(chrom, data))],
      value = ['labelValue', 'value', "".concat(data.value)];
  return {
    rows: dropNulls([[value], [posURL]]),
    sampleID: sampleFormat(data.sample)
  };
}

function posTooltip(layout, samples, sampleFormat, pixPerRow, index, assembly, x, y) {
  var chrom = layout.chromName,
      yIndex = Math.round((y - pixPerRow / 2) / pixPerRow + index),
      pos = Math.floor(chromPositionFromScreen(layout, x)),
      coordinate = {
    chr: chrom,
    start: pos,
    end: pos
  };
  return {
    sampleID: sampleFormat(samples[yIndex]),
    rows: [[['url', "".concat(assembly, " ").concat(posStartString(chrom, coordinate)), gbURL(assembly, posRegionString(chrom, coordinate), posDoubleString(chrom, coordinate))]]]
  };
}

function tooltip(id, fieldType, layout, nodes, samples, sampleFormat, zoom, gene, assembly, ev) {
  var _util$eventOffset = util.eventOffset(ev),
      x = _util$eventOffset.x,
      y = _util$eventOffset.y,
      height = zoom.height,
      count = zoom.count,
      index = zoom.index,
      pixPerRow = height / count,
      lo = _.updateIn(layout, ['chromName'], function (c) {
    return c || _.getIn(nodes, [0, 'data', 'chr']);
  }),
      node = closestNode(nodes, zoom, x, y);

  return _objectSpread({
    x: x,
    id: id
  }, node ? sampleTooltip(lo.chromName, sampleFormat, node.data, gene, assembly) : posTooltip(lo, samples, sampleFormat, pixPerRow, index, assembly, x, y));
}

var SegmentedColumn = hotOrNot((_temp = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(_temp, _PureComponent);

  var _super = _createSuper(_temp);

  function _temp() {
    var _this;

    (0, _classCallCheck2["default"])(this, _temp);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "tooltip", function (ev) {
      var _this$props = _this.props,
          _this$props$column = _this$props.column,
          fieldType = _this$props$column.fieldType,
          layout = _this$props$column.layout,
          nodes = _this$props$column.nodes,
          fields = _this$props$column.fields,
          assembly = _this$props$column.assembly,
          samples = _this$props.samples,
          sampleFormat = _this$props.sampleFormat,
          zoom = _this$props.zoom,
          id = _this$props.id;
      return tooltip(id, fieldType, layout, nodes, samples, sampleFormat, zoom, fields[0], assembly, ev);
    });
    return _this;
  }

  (0, _createClass2["default"])(_temp, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      var events = rxEvents(this, 'mouseout', 'mousemove', 'mouseover'); // Compute tooltip events from mouse events.

      this.ttevents = events.mouseover.filter(function (ev) {
        return util.hasClass(ev.currentTarget, 'Tooltip-target');
      }).flatMap(function () {
        return events.mousemove.takeUntil(events.mouseout).map(function (ev) {
          return {
            data: _this2.tooltip(ev),
            open: true
          };
        }) // look up current data
        .concat(Rx.Observable.of({
          open: false
        }));
      }).subscribe(this.props.tooltip);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.ttevents.unsubscribe();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          column = _this$props2.column,
          samples = _this$props2.samples,
          zoom = _this$props2.zoom,
          index = _this$props2.index;
      return /*#__PURE__*/React.createElement(CanvasDrawing, {
        ref: "plot",
        draw: drawSegmented,
        wrapperProps: {
          className: 'Tooltip-target',
          onMouseMove: this.on.mousemove,
          onMouseOut: this.on.mouseout,
          onMouseOver: this.on.mouseover,
          onClick: this.props.onClick
        },
        color: column.color,
        nodes: column.nodes,
        strand: column.strand,
        width: column.width,
        index: index,
        samples: samples,
        xzoom: column.zoom,
        zoom: zoom
      });
    }
  }]);
  return _temp;
}(_PureComponent2["default"]), _temp));
widgets.column.add('segmented', function (props) {
  return /*#__PURE__*/React.createElement(SegmentedColumn, props);
});
widgets.legend.add('segmented', drawLegend);