"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _minhash = require("minhash");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

// Utility script to build minhash for probemaps on the
// reference hub.
var request = require('request');

var Rx = require('rxjs');

var post = Rx.Observable.bindNodeCallback(request.post);

var fs = require('fs');

var refHub = 'https://reference.xenahubs.net';

function minHashFromList(list) {
  var mh = new _minhash.Minhash();
  list.forEach(function (p) {
    return mh.update(p);
  });
  return mh;
}

function probemapList() {
  var probemaps = "\n\t\t(query {:select [:dataset.name :hash]\n\t\t\t\t:from [:dataset]\n\t\t\t\t:join [:dataset-source [:= :dataset.id :dataset_id]\n\t\t\t\t\t   :source [:= :source.id :source_id]]\n\t\t\t\t:where [:= :type \"probeMap\"]}))";
  return post({
    url: refHub + '/data/',
    body: probemaps
  }).map(function (_ref) {
    var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
        resp = _ref2[1];

    return JSON.parse(resp);
  });
}

function probeList(probemap) {
  var probes = "(xena-query {:select [\"name\"] :from [\"".concat(probemap.name, "\"]})");
  return post({
    url: refHub + '/data/',
    body: probes
  }).retry(3).map(function (_ref3) {
    var _ref4 = (0, _slicedToArray2["default"])(_ref3, 2),
        resp = _ref4[1];

    try {
      return _objectSpread(_objectSpread({}, probemap), {}, {
        probes: JSON.parse(resp).name
      });
    } catch (e) {
      console.log('parsing error ', resp.slice(0, 1000));
      process.exit();
    }
  });
}

function buildFilters() {
  var out = fs.openSync('probemapMinHashes', 'w');
  var first = true;
  probemapList().flatMap(function (probemaps) {
    var _Rx$Observable;

    return (_Rx$Observable = Rx.Observable).merge.apply(_Rx$Observable, (0, _toConsumableArray2["default"])(probemaps.map(probeList)));
  }).subscribe(function (_ref5) {
    var name = _ref5.name,
        probes = _ref5.probes;
    console.log(name);
    fs.writeSync(out, first ? '[' : ',');
    var mh = minHashFromList(probes);
    fs.writeSync(out, JSON.stringify({
      name: name,
      hash: mh.hashvalues
    }));
    first = false;
  }, function (err) {
    console.log('error', err);
  }, function () {
    fs.writeSync(out, ']');
    fs.closeSync(out);
  });
}

buildFilters();