var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

var _toConsumableArray = require("@babel/runtime/helpers/toConsumableArray");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var _ = require('../underscore_ext')["default"];

var styles = require('./DensityPlot.module.css');

var sc = require('science');

var plotHeight = 35;
var plotWidth = 200;
var zoomFactor = 3;
var topColor = "#BAA0CF";
var bottomColor = "#79C6C5";

function calculateHeights(data, max, min, plotWidth) {
  var pxWidth = (max - min) / plotWidth;
  var aHeights = data.studyA.map(function (exp) {
    return exp.expA.length ? sc.stats.kde().sample(exp.expA)(_.range(min, max + pxWidth, pxWidth)).map(function (kdep) {
      return kdep[1];
    }) : [];
  });
  var bHeights = data.studyB.map(function (exp) {
    return exp.expB.length ? sc.stats.kde().sample(exp.expB)(_.range(min, max + pxWidth, pxWidth)).map(function (kdep) {
      return kdep[1];
    }) : [];
  });
  return {
    aHeights: aHeights,
    bHeights: bHeights
  };
}

function densitySvg(yHeights, height, totalWidth, vscale, A) {
  var binWidth = plotWidth / yHeights.length,
      polylinePoints = ["20,".concat(height)].concat(_toConsumableArray(yHeights.map(function (y, i) {
    return "".concat(i * binWidth + 20, ",").concat((1 - y / vscale) * height);
  })), ["".concat(plotWidth + 20, ",").concat(height)]).join(' ');
  return /*#__PURE__*/React.createElement("svg", {
    width: totalWidth,
    height: height
  }, /*#__PURE__*/React.createElement("polyline", {
    points: polylinePoints,
    fill: A ? topColor : bottomColor
  }));
}

var drawDensityPlot = function drawDensityPlot(min, max, totalWidth, getNameZoom) {
  return function (aHeight, bHeight, nameAndZoom) {
    var height = nameAndZoom.zoom ? plotHeight * zoomFactor : plotHeight,
        rowClass = nameAndZoom.zoom ? "densityPlot--row--zoom" : "densityPlot--row",
        vscale = Math.max.apply(Math, _toConsumableArray(aHeight.filter(function (x) {
      return !isNaN(x);
    })).concat(_toConsumableArray(bHeight.filter(function (x) {
      return !isNaN(x);
    }))));
    return /*#__PURE__*/React.createElement("div", {
      key: nameAndZoom.name,
      className: styles[rowClass],
      style: {
        width: "".concat(totalWidth, "px")
      },
      onClick: function onClick() {
        return getNameZoom(nameAndZoom.name);
      }
    }, /*#__PURE__*/React.createElement("div", {
      className: styles["densityPlot--scale--Axis"],
      style: {
        height: 2 * height - 2,
        left: "18px"
      }
    }), /*#__PURE__*/React.createElement("div", {
      className: styles["densityPlot--row--xAxis"],
      style: {
        width: "".concat(plotWidth * 100 / totalWidth, "%"),
        left: "20px"
      }
    }), isFinite(vscale) ? /*#__PURE__*/React.createElement("div", {
      className: styles["densityPlot--vscal--label"],
      style: {
        left: "15px"
      }
    }, vscale.toFixed(2)) : null, isFinite(vscale) ? /*#__PURE__*/React.createElement("div", {
      className: styles["densityPlot--vscal--tick"],
      style: {
        left: "15px",
        top: '1px'
      }
    }) : null, isFinite(vscale) ? /*#__PURE__*/React.createElement("div", {
      className: styles["densityPlot--vscal--tick"],
      style: {
        left: "15px",
        top: "".concat(2 * height - 2, "px")
      }
    }) : null, /*#__PURE__*/React.createElement("div", {
      className: styles["densityPlot--row--studyA"],
      style: {
        width: totalWidth
      }
    }, densitySvg(aHeight, height, totalWidth, vscale, true)), /*#__PURE__*/React.createElement("div", {
      className: styles["densityPlot--row--studyB"],
      style: {
        width: totalWidth
      }
    }, densitySvg(bHeight, height, totalWidth, vscale, false)));
  };
};

var DensityPlot = /*#__PURE__*/function (_React$PureComponent) {
  "use strict";

  _inherits(DensityPlot, _React$PureComponent);

  var _super = _createSuper(DensityPlot);

  function DensityPlot() {
    _classCallCheck(this, DensityPlot);

    return _super.apply(this, arguments);
  }

  _createClass(DensityPlot, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          getNameZoom = _this$props.getNameZoom,
          min = _this$props.min,
          max = _this$props.max,
          totalWidth = plotWidth + 20,
          data = this.props.data ? this.props.data : null,
          _calculateHeights = calculateHeights(data, max, min, plotWidth),
          aHeights = _calculateHeights.aHeights,
          bHeights = _calculateHeights.bHeights,
          drawPlot = drawDensityPlot(min, max, totalWidth, getNameZoom),
          rows = _.mmap(aHeights, bHeights, data.nameAndZoom, drawPlot);

      return /*#__PURE__*/React.createElement("div", {
        className: styles.densityPlot
      }, rows);
    }
  }]);

  return DensityPlot;
}(React.PureComponent);

module.exports = {
  DensityPlot: DensityPlot,
  bottomColor: bottomColor,
  topColor: topColor,
  plotWidth: plotWidth
};