var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _assertThisInitialized = require("@babel/runtime/helpers/assertThisInitialized");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

var _defineProperty = require("@babel/runtime/helpers/defineProperty");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var _ = require('../underscore_ext')["default"];

var styles = require('./Exons.module.css');

var width = 700;

function box(type, startsAt, width, multiplyingFactor, strand) {
  var pad = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 0;
  var zoom = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : false;
  var label = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : "";
  var exon = {
    type: type,
    label: label,
    width: width * multiplyingFactor + "px",
    origin: strand === '-' ? "right" : "left",
    position: startsAt * multiplyingFactor + pad + "px",
    zoom: zoom
  };
  return exon;
}

function renderExon(exon, key) {
  var style = _defineProperty({
    width: exon.width
  }, exon.origin, exon.position);

  if (exon.type === 'small') {
    var boxClass = exon.zoom ? "exons--row--item-small--zoom" : "exons--row--item-small";
    return /*#__PURE__*/React.createElement("div", {
      key: key,
      className: styles[boxClass],
      style: style
    }, /*#__PURE__*/React.createElement("span", null, exon.label));
  } else if (exon.type === 'big') {
    var _boxClass = exon.zoom ? "exons--row--item-big--zoom" : "exons--row--item-big";

    return /*#__PURE__*/React.createElement("div", {
      key: key,
      className: styles[_boxClass],
      style: style
    }, /*#__PURE__*/React.createElement("span", null, exon.label));
  }
}

function exonShape(data, exonStarts, exonEnds, cdsStart, cdsEnd, multiplyingFactor, strand, origin) {
  var exonWidth = exonEnds - exonStarts;
  var startsAt = exonStarts - origin;

  if (cdsStart === cdsEnd) {
    return [box('small', startsAt, exonWidth, multiplyingFactor, strand)];
  } else if (cdsStart > exonEnds) {
    return [box('small', startsAt, exonWidth, multiplyingFactor, strand)];
  } else if (exonStarts < cdsStart && cdsStart < exonEnds) {
    var exonWidth1 = cdsStart - exonStarts;
    var exonWidth2 = exonEnds - cdsStart;
    return [box('small', startsAt, exonWidth1, multiplyingFactor, strand), box('big', cdsStart - origin, exonWidth2, multiplyingFactor, strand)];
  } else if (exonStarts < cdsEnd && cdsEnd < exonEnds) {
    var _exonWidth = cdsEnd - exonStarts;

    var _exonWidth2 = exonEnds - cdsEnd;

    return [box('big', startsAt, _exonWidth, multiplyingFactor, strand), box('small', cdsEnd - origin, _exonWidth2, multiplyingFactor, strand)];
  } else if (cdsEnd < exonStarts) {
    return [box('small', startsAt, exonWidth, multiplyingFactor, strand)];
  } else {
    return [box('big', startsAt, exonWidth, multiplyingFactor, strand)];
  }
}

var Exons = /*#__PURE__*/function (_React$PureComponent) {
  "use strict";

  _inherits(Exons, _React$PureComponent);

  var _super = _createSuper(Exons);

  function Exons() {
    var _this;

    _classCallCheck(this, Exons);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "row", function (data, multiplyingFactor, origin) {
      return data.map(function (d, index) {
        var style = _defineProperty({
          width: (d.txEnd - d.txStart) * multiplyingFactor + "px"
        }, d.strand === '-' ? 'right' : 'left', (d.txStart - origin) * multiplyingFactor + "px");

        return /*#__PURE__*/React.createElement("div", {
          className: styles["exons--row"],
          id: index
        }, /*#__PURE__*/React.createElement("div", {
          className: styles["exons--row--axis"],
          style: style
        }), _.flatten(_.mmap(d.exonStarts, d.exonEnds, function (exonStarts, exonEnds) {
          return _.map(exonShape(data, exonStarts, exonEnds, d.cdsStart, d.cdsEnd, multiplyingFactor, d.strand, origin), renderExon);
        })));
      });
    });

    return _this;
  }

  _createClass(Exons, [{
    key: "render",
    value: function render() {
      var data = this.props.data ? this.props.data : null;
      var origin = Math.min.apply(Math, _.pluck(data, 'txStart')); //multiplying factor used to calculate position and width

      var multiplyingFactor = width / (Math.max.apply(Math, _.pluck(data, 'txEnd')) - origin);
      var rows = this.row(data, multiplyingFactor, origin);
      return /*#__PURE__*/React.createElement("div", {
        className: styles.exons
      }, rows);
    }
  }]);

  return Exons;
}(React.PureComponent);

module.exports = {
  Exons: Exons,
  box: box,
  renderExon: renderExon
};