"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _nav = _interopRequireDefault(require("../nav"));

var _ajaxLoader = _interopRequireDefault(require("../ajax-loader.gif"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var _ = require('../underscore_ext')["default"];

var React = require('react');

var NameColumn = require('./NameColumn'); // const {Exons} = require('./Exons');


var ExonsOnly = require('./ExonsOnly');

var _require = require('./DensityPlot'),
    DensityPlot = _require.DensityPlot,
    bottomColor = _require.bottomColor,
    topColor = _require.topColor,
    plotWidth = _require.plotWidth;

var GeneSuggest = require('../views/GeneSuggest');

var _require2 = require('../scale'),
    linearTicks = _require2.linearTicks;

var styles = require('./TranscriptPage.module.css');

var _require3 = require('../StateError'),
    StateError = _require3.StateError;

var _require4 = require('../schemaCheck'),
    schemaCheckThrow = _require4.schemaCheckThrow;

function getStatusView(status, onReload) {
  if (status === 'loading') {
    return /*#__PURE__*/React.createElement("div", {
      "data-xena": "loading",
      className: styles.status
    }, /*#__PURE__*/React.createElement("img", {
      style: {
        textAlign: 'center'
      },
      src: _ajaxLoader["default"]
    }));
  }

  if (status === 'error') {
    return /*#__PURE__*/React.createElement("div", {
      className: styles.status
    }, /*#__PURE__*/React.createElement("i", {
      onClick: onReload,
      title: "Error loading data. Click to reload.",
      "aria-hidden": "true",
      className: "material-icons ".concat(styles.errorIcon)
    }, "warning"));
  }

  return null;
}

var Transcripts = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Transcripts, _React$Component);

  var _super = _createSuper(Transcripts);

  function Transcripts() {
    var _this;

    (0, _classCallCheck2["default"])(this, Transcripts);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      input: _.getIn(_this.props.state, ['transcripts', 'gene']),
      // XXX this is outside the selector
      scaleZoom: false,
      updateButton: false
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onLoadData", function () {
      var subtypeA = _this.refs.A.value;
      var subtypeB = _this.refs.B.value;
      var unit = _this.refs.unit.value;
      var gene = _this.state.input;

      _this.setState({
        scaleZoom: false,
        updateButton: false
      }); // Invoke action 'loadGene', which will load transcripts and
      // expression data.


      _this.props.callback(['loadGene', gene, subtypeA, subtypeB, unit]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onZoom", function (name) {
      _this.props.callback(['transcriptZoom', name]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "scaleZoom", function () {
      _this.setState({
        scaleZoom: !_this.state.scaleZoom
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onNavigate", function (page, params) {
      _this.props.callback(['navigate', page, params]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onImport", function (content) {
      try {
        _this.props.callback(['import', schemaCheckThrow(JSON.parse(content))]);
      } catch (err) {
        _this.props.callback(['import-error']);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onHideError", function () {
      _this.props.callback(['stateError', undefined]);
    });
    return _this;
  }

  (0, _createClass2["default"])(Transcripts, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(props) {
      var newGene = _.getIn(props.state, ['transcripts', 'gene']);

      if (newGene) {
        this.setState({
          input: newGene
        });
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var onImport = this.onImport,
          getState = this.props.getState; // nested render to different DOM tree

      (0, _nav["default"])({
        isPublic: true,
        getState: getState,
        onImport: onImport,
        onNavigate: this.onNavigate,
        activeLink: 'transcripts'
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var state = this.props.state,
          loadPending = state.loadPending,
          stateError = state.stateError,
          _ref = state.transcripts || {},
          status = _ref.status,
          subtypes = _ref.subtypes,
          subtypeA = _ref.subtypeA,
          subtypeB = _ref.subtypeB,
          unit = _ref.unit,
          _ref$zoom = _ref.zoom,
          zoom = _ref$zoom === void 0 ? {} : _ref$zoom;

      if (loadPending) {
        return /*#__PURE__*/React.createElement("p", {
          style: {
            margin: 10
          }
        }, "Loading your view...");
      }

      if (!subtypes) {
        return /*#__PURE__*/React.createElement("h4", null, "Loading available subtypes...");
      }

      var valueA = subtypeA ? subtypeA : subtypes[0],
          valueB = subtypeB ? subtypeB : subtypes[subtypes.length - 1],
          options = subtypes.map(function (name) {
        return /*#__PURE__*/React.createElement("option", {
          key: name,
          value: name
        }, name);
      }),
          unitLabels = {
        tpm: {
          dropdown: "TPM",
          axis: "log2 (TPM)"
        },
        isoformPercentage: {
          dropdown: "Isoform Percentage",
          axis: "Isoform Percentage"
        }
      };

      var _ref2 = state.transcripts || [],
          genetranscripts = _ref2.genetranscripts;

      var genetranscriptsSorted = _.sortBy(genetranscripts, function (gtranscript) {
        // sort by start of transcript in transcript direction left to right
        // known issue: tie break
        return gtranscript.strand === '+' ? gtranscript.exonStarts[0] : -gtranscript.exonEnds[gtranscript.exonCount - 1];
        /*return _.sum(_.mmap(gtranscript.exonStarts, gtranscript.exonEnds, (exonStarts, exonEnds) => {
        	return exonStarts - exonEnds;
        }));*/
        // sort by transcript size large to small
      }).map(function (t) {
        return _.assoc(t, 'zoom', zoom[t.name]);
      }); //for the name column


      var transcriptNameData = _.map(genetranscriptsSorted, function (t) {
        return _.pick(t, 'name', 'exonCount', 'zoom');
      }); //for the exon-intron visualization


      var transcriptExonData = _.map(genetranscriptsSorted, function (t) {
        return _.omit(t, ['chrom', 'expA', 'expB']);
      }); // for the density plot


      var transcriptDensityData = {
        studyA: _.map(genetranscriptsSorted, function (t) {
          return {
            'expA': t.expA.filter(function (x) {
              return !isNaN(x);
            })
          };
        }),
        studyB: _.map(genetranscriptsSorted, function (t) {
          return {
            'expB': t.expB.filter(function (x) {
              return !isNaN(x);
            })
          };
        }),
        nameAndZoom: _.map(genetranscriptsSorted, function (t) {
          return _.pick(t, 'name', 'zoom');
        })
      }; //calculation of max and min same as in DensityPlot.js and passing max, min as parameters to linearTicks

      var allData = _.flatten(_.pluck(transcriptDensityData.studyA, "expA").concat(_.pluck(transcriptDensityData.studyB, "expB")));

      var max = Math.max.apply(Math, (0, _toConsumableArray2["default"])(allData));
      var min = Math.min.apply(Math, (0, _toConsumableArray2["default"])(allData));
      var densityplotAxisLabel = isFinite(max) && isFinite(min) ? linearTicks(min, max) : [];
      var range = max - min;
      var hasPlots = genetranscripts && !_.isEmpty(genetranscripts);
      var dropdownBackgroundColorTop = hasPlots ? topColor : "white";
      var dropdownBackgroundColorBottom = hasPlots ? bottomColor : "white";
      var dropdownColor = hasPlots ? "white" : "black";
      return /*#__PURE__*/React.createElement("div", {
        className: styles.main
      }, stateError ? /*#__PURE__*/React.createElement(StateError, {
        onHide: this.onHideError,
        error: stateError
      }) : null, /*#__PURE__*/React.createElement("a", {
        className: styles.selectorsLink,
        style: {
          fontSize: "0.85em"
        },
        href: "https://ucsc-xena.gitbook.io/project/overview-of-features/transcript-view/"
      }, "Help with transcripts"), /*#__PURE__*/React.createElement("div", {
        className: styles.selectors,
        style: {
          width: "1200px",
          height: "80px"
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: styles.geneBox,
        style: {
          "float": "left",
          width: "300px"
        }
      }, /*#__PURE__*/React.createElement(GeneSuggest, {
        assembly: "hg38",
        label: "Add Gene (e.g. KRAS)",
        value: this.state.input,
        onChange: function onChange(value) {
          _this2.setState({
            input: value.trim(),
            updateButton: true
          });
        }
      })), this.state.updateButton ? /*#__PURE__*/React.createElement("button", {
        className: styles.horizontalSegmentButton,
        onClick: this.onLoadData
      }, "Update Gene") : null), /*#__PURE__*/React.createElement("div", {
        style: {
          width: "1200px",
          marginBottom: "40px"
        }
      }, /*#__PURE__*/React.createElement("div", {
        style: {
          marginBottom: "10px"
        }
      }, /*#__PURE__*/React.createElement("span", {
        className: styles.selectors
      }, "Study A"), /*#__PURE__*/React.createElement("select", {
        ref: "A",
        onChange: this.onLoadData,
        value: valueA,
        style: {
          color: dropdownColor,
          backgroundColor: dropdownBackgroundColorTop
        }
      }, options), /*#__PURE__*/React.createElement("span", {
        className: styles.selectors
      }, "Study B"), /*#__PURE__*/React.createElement("select", {
        ref: "B",
        onChange: this.onLoadData,
        value: valueB,
        style: {
          color: dropdownColor,
          backgroundColor: dropdownBackgroundColorBottom
        }
      }, options)), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("span", {
        className: styles.selectors
      }, "Expression Unit"), /*#__PURE__*/React.createElement("select", {
        ref: "unit",
        onChange: this.onLoadData,
        value: unit
      }, /*#__PURE__*/React.createElement("option", {
        value: "tpm"
      }, unitLabels.tpm.dropdown), /*#__PURE__*/React.createElement("option", {
        value: "isoformPercentage"
      }, unitLabels.isoformPercentage.dropdown)))), hasPlots ? /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
        className: styles["densityplot--label-div--zoom"],
        onClick: this.scaleZoom
      }, /*#__PURE__*/React.createElement("label", {
        style: {
          fontSize: "0.85em",
          width: plotWidth
        }
      }, unitLabels[unit].axis), /*#__PURE__*/React.createElement("div", null, densityplotAxisLabel.map(function (label, i) {
        return /*#__PURE__*/React.createElement("div", {
          key: i
        }, /*#__PURE__*/React.createElement("label", {
          className: styles["densityplot--label-x"],
          style: {
            left: "".concat((label - min) * plotWidth / range, "px")
          }
        }, label, unit === "isoformPercentage" && i === densityplotAxisLabel.length - 1 ? "%" : ""), /*#__PURE__*/React.createElement("div", {
          className: styles["densityplot--label-vertical-tick"],
          style: {
            left: "".concat((label - min) * plotWidth / range, "px")
          }
        }));
      })), /*#__PURE__*/React.createElement("div", {
        className: styles["densityplot--label--axis-x"]
      })), /*#__PURE__*/React.createElement("div", {
        style: {
          width: "100%",
          height: "35px"
        }
      })) : null, /*#__PURE__*/React.createElement("div", {
        style: {
          position: 'relative'
        }
      }, getStatusView(status, this.onLoadData), /*#__PURE__*/React.createElement("div", {
        className: "".concat(styles[status || 'loaded'], " ").concat(styles.loadStatus)
      }, /*#__PURE__*/React.createElement(NameColumn, {
        data: transcriptNameData,
        gene: state.transcripts.gene
      }), genetranscripts && !_.isEmpty(genetranscripts) ? /*#__PURE__*/React.createElement("label", {
        className: styles["densityplot--label-y"]
      }, "density") : null, /*#__PURE__*/React.createElement(DensityPlot, {
        data: transcriptDensityData,
        getNameZoom: this.onZoom,
        max: max,
        min: min
      }), /*#__PURE__*/React.createElement(ExonsOnly, {
        data: transcriptExonData,
        getNameZoom: this.onZoom
      }))), /*#__PURE__*/React.createElement("div", {
        style: {
          clear: 'both'
        }
      }));
    }
  }]);
  return Transcripts;
}(React.Component);

var TranscriptsContainer = /*#__PURE__*/function (_React$Component2) {
  (0, _inherits2["default"])(TranscriptsContainer, _React$Component2);

  var _super2 = _createSuper(TranscriptsContainer);

  function TranscriptsContainer() {
    var _this3;

    (0, _classCallCheck2["default"])(this, TranscriptsContainer);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this3 = _super2.call.apply(_super2, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "getState", function () {
      return _.pick(_this3.props.state, 'version', 'page', 'transcripts');
    });
    return _this3;
  }

  (0, _createClass2["default"])(TranscriptsContainer, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          state = _this$props.state,
          selector = _this$props.selector,
          props = (0, _objectWithoutProperties2["default"])(_this$props, ["state", "selector"]);
      return /*#__PURE__*/React.createElement(Transcripts, (0, _extends2["default"])({}, _objectSpread(_objectSpread({}, props), {}, {
        state: selector(state)
      }), {
        getState: this.getState
      }));
    }
  }]);
  return TranscriptsContainer;
}(React.Component);

var _default = TranscriptsContainer;
exports["default"] = _default;