"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.defaultHost = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _columnsParam = require("./columnsParam");

var _heatmapParam = require("./heatmapParam");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _require$default = require('./underscore_ext')["default"],
    get = _require$default.get,
    getIn = _require$default.getIn,
    Let = _require$default.Let,
    merge = _require$default.merge,
    mapObject = _require$default.mapObject,
    pick = _require$default.pick,
    pluck = _require$default.pluck,
    uniq = _require$default.uniq,
    updateIn = _require$default.updateIn;

var _require = require('./bookmark'),
    hasBookmark = _require.hasBookmark,
    resetBookmarkLocation = _require.resetBookmarkLocation,
    getBookmark = _require.getBookmark;

var _require2 = require('./inlineState'),
    hasInlineState = _require2.hasInlineState,
    resetInlineStateLocation = _require2.resetInlineStateLocation;

var _require3 = require('./hubParams'),
    getHubParams = _require3.hubParams;

var allParameters = require('./util')["default"].allParameters;

// This is all really wonky & needs refactor.
function bookmarkParam() {
  var ret = {};

  if (hasBookmark()) {
    ret = {
      'bookmark': getBookmark()
    };
    resetBookmarkLocation();
  }

  return ret;
}

function inlineStateParam() {
  var ret = {};

  if (hasInlineState()) {
    ret = {
      'inlineState': true
    };
    resetInlineStateLocation();
  }

  return ret;
} // XXX Deprecating these, in favor of hubParams2.


function hubParams() {
  var hubs = getHubParams();
  return hubs.length ? {
    hubs: hubs
  } : {};
}

var hubParams2 = pick(allParameters(), 'addHub', 'removeHub');

function fixLocalhost(obj) {
  return get(obj, 'host') ? updateIn(obj, ['host'], function (host) {
    return host === 'https://local.xena.ucsc.edu:7223' ? 'http://127.0.0.1:7222' : host;
  }) : obj;
}

function datasetParams() {
  // only take the first of these
  return mapObject(pick(allParameters(), 'cohort', 'dataset', 'host', 'allIdentifiers', 'markdown'), function (l) {
    return l[0];
  });
}

function manifest() {
  // only take the first of these
  return mapObject(pick(allParameters(), 'manifest'), function (l) {
    return l[0];
  });
}

function getParams() {
  var columns = (0, _columnsParam.columnsParam)(),
      hasCols = getIn(columns, ['columns', 'length'], 0) > 0,
      // ignore heatmap param w/o column param.
  heatmap = hasCols ? (0, _heatmapParam.heatmapParam)() : {},
      hub2 = hasCols ? updateIn(hubParams2, ['addHub'], function () {
    var hubs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    return uniq(hubs.concat(pluck(columns.columns, 'host')));
  }) : hubParams2;
  return merge(hub2, bookmarkParam(), inlineStateParam(), hubParams(), fixLocalhost(datasetParams()), manifest(), columns, heatmap);
} // Our handling of parameters 'hub' and 'host', is somewhat confusing. 'host'
// means "show the hub page for this url". 'hub' means "add this url to the
// active hub list, and, if in /datapages/ show the hub page for this url".
// The 'hub' parameter can be repeated, which adds each hub to the active hub
// list. Only the first one will be displayed when linking to /datapages/.
// Needs refactor.


var defaultHost = function defaultHost(params) {
  return Let(function () {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : params,
        host = _ref.host,
        hubs = _ref.hubs;

    return !host && hubs ? _objectSpread(_objectSpread({}, params), {}, {
      host: hubs[0]
    }) : params;
  });
};

exports.defaultHost = defaultHost;
var _default = getParams;
exports["default"] = _default;