"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireDefault(require("react"));

var _CanvasDrawing = _interopRequireDefault(require("../CanvasDrawing2"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var rgb = require('../color_helper')["default"].rgb; //// Styles


var compStyles = require('./BandLegend.module.css');

function draw(vg, opts) {
  var _opts$range = opts.range,
      min = _opts$range.min,
      max = _opts$range.max,
      colorScale = opts.colorScale,
      width = opts.width,
      height = opts.zoom.height,
      ctx = vg.context(),
      img = ctx.createImageData(width, height);

  for (var i = 0; i < width; ++i) {
    var color = rgb(colorScale((max - min) * i / width + min));

    for (var j = 0; j < height + 4; ++j) {
      var k = 4 * (j * width + i);
      img.data[k] = color[0];
      img.data[k + 1] = color[1];
      img.data[k + 2] = color[2];
      img.data[k + 3] = 255;
    }
  }

  ctx.putImageData(img, 0, 0);
}

var addClass = function addClass(className) {
  return function (el, i) {
    return /*#__PURE__*/_react["default"].cloneElement(el, {
      className: className,
      key: i
    });
  };
};

var BandLegend = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(BandLegend, _React$Component);

  var _super = _createSuper(BandLegend);

  function BandLegend() {
    (0, _classCallCheck2["default"])(this, BandLegend);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(BandLegend, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          range = _this$props.range,
          multiScaled = _this$props.multiScaled,
          width = _this$props.width,
          height = _this$props.height,
          footnotes = _this$props.footnotes,
          colorScale = _this$props.colorScale,
          labels = multiScaled ? {
        min: 'low',
        max: 'high'
      } : {
        min: range.min.toPrecision(2),
        max: range.max.toPrecision(2)
      },
          drawing = /*#__PURE__*/_react["default"].createElement(_CanvasDrawing["default"], {
        style: {
          width: '100%',
          height: height
        },
        draw: draw,
        range: range,
        width: width,
        colorScale: colorScale,
        zoom: {
          height: height
        }
      });

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: compStyles.Legend
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: compStyles.container
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: compStyles.right
      }, labels.max), /*#__PURE__*/_react["default"].createElement("div", {
        className: compStyles.center
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: compStyles.left
      }, labels.min), /*#__PURE__*/_react["default"].createElement("div", {
        className: compStyles.center
      }, drawing))), footnotes ? footnotes.map(addClass(compStyles.footnotes)) : null);
    }
  }]);
  return BandLegend;
}(_react["default"].Component);

module.exports = BandLegend;