"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _menu = require("react-toolbox/lib/menu");

var _button = require("react-toolbox/lib/button");

var _link = _interopRequireDefault(require("react-toolbox/lib/link"));

var _tooltip = _interopRequireDefault(require("react-toolbox/lib/tooltip"));

var _columnsParam = require("../columnsParam");

var _heatmapParam = require("../heatmapParam");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var konami = require('../konami');

var React = require('react');

var _ = require('../underscore_ext')["default"];

var Rx = require('../rx')["default"];

var _require = require('../bookmark'),
    createBookmark = _require.createBookmark,
    getRecent = _require.getRecent,
    setRecent = _require.setRecent;

var compStyles = require('./BookmarkMenu.module.css');

var gaEvents = require('../gaEvents'); // XXX This is a horrible work-around for react-toolbox menu limitations.
// We want the Bookmark MenuItem to not close the menu. Menu closes when
// a MenuItem is clicked by intercepting the onClick handler. However, it
// only intercepts onClick handlers of MenuItem children. By simply wrapping
// MenuItem, we avoid this.


var NoCloseMenuItem = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(NoCloseMenuItem, _React$Component);

  var _super = _createSuper(NoCloseMenuItem);

  function NoCloseMenuItem() {
    (0, _classCallCheck2["default"])(this, NoCloseMenuItem);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(NoCloseMenuItem, [{
    key: "render",
    value: function render() {
      var otherProps = _.omit(this.props, 'tooltip');

      return /*#__PURE__*/React.createElement(_menu.MenuItem, otherProps);
    }
  }]);
  return NoCloseMenuItem;
}(React.Component);

var TooltipNoCloseMenuItem = (0, _tooltip["default"])(NoCloseMenuItem);
var privateWarning = 'Unable to create bookmark link due to private data in view. Use export instead';
var linking = false;

var BookmarkMenu = /*#__PURE__*/function (_React$Component2) {
  (0, _inherits2["default"])(BookmarkMenu, _React$Component2);

  var _super2 = _createSuper(BookmarkMenu);

  function BookmarkMenu() {
    var _this;

    (0, _classCallCheck2["default"])(this, BookmarkMenu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super2.call.apply(_super2, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      loading: false,
      open: false,
      recent: false
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onRef", function (ref) {
      _this.menuRef = ref;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onBookmark", function () {
      gaEvents('bookmark', 'create');
      var getState = _this.props.getState;

      _this.setState({
        loading: true
      });

      Rx.Observable.ajax({
        method: 'POST',
        url: '/api/bookmarks/bookmark',
        responseType: 'text',
        headers: {
          'X-CSRFToken': document.cookie.replace(/.*csrftoken=([0-9a-z]+)/, '$1'),
          'Content-Type': 'application/x-www-form-urlencoded'
        },
        body: "content=".concat(encodeURIComponent(createBookmark(getState())))
      }).subscribe(_this.onSetBookmark, function () {
        return _this.setState({
          loading: false
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSetBookmark", function (resp) {
      var _JSON$parse = JSON.parse(resp.response),
          id = _JSON$parse.id;

      setRecent(id);

      _this.setState({
        bookmark: "".concat(location.href, "?bookmark=").concat(id),
        loading: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onResetBookmark", function () {
      _this.setState({
        bookmark: null
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onCopyBookmarkToClipboard", function () {
      _this.bookmarkEl.select();

      document.execCommand('copy');
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onExport", function () {
      gaEvents('bookmark', 'export');
      var getState = _this.props.getState;
      var url = URL.createObjectURL(new Blob([JSON.stringify(getState())], {
        type: 'application/json'
      }));
      var a = document.createElement('a');
      var filename = 'xenaState.json';

      _.extend(a, {
        id: filename,
        download: filename,
        href: url
      });

      document.body.appendChild(a);
      a.click();
      document.body.removeChild(a);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onImport", function () {
      _this.refs["import"].click();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onImportSelected", function (ev) {
      gaEvents('bookmark', 'import');
      var file = ev.target.files[0],
          reader = new FileReader(),
          onImport = _this.props.onImport;

      reader.onload = function () {
        return onImport(reader.result);
      };

      reader.readAsText(file);
      ev.target.value = null;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetBookmark", function () {
      _this.setState({
        bookmark: null
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onClick", function () {
      _this.setState({
        open: !(_this.state.open || _this.state.recent),
        recent: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onRecent", function () {
      _this.setState({
        recent: !_this.state.recent,
        open: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onRecentHide", function () {
      _this.setState({
        recent: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMenuHide", function () {
      _this.setState({
        open: false
      });

      if (_this.props.onHide) {
        _this.props.onHide();
      }
    });
    return _this;
  }

  (0, _createClass2["default"])(BookmarkMenu, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var asciiC = 67;
      this.ksub = konami(asciiC).subscribe(function () {
        linking = true;
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.ksub.unsubscribe();
    } // RTB positions and clips the menu content according
    // to the initial menu render size, which causes problems
    // for dynamic content. This is a work-around which causes
    // the Menu component to re-calculate its size every time
    // we update.

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.state.open && this.menuRef) {
        this.menuRef.show();
      }
    }
  }, {
    key: "onViewBookmark",
    value: function onViewBookmark(id) {
      window.location = window.location.href + "?bookmark=".concat(id);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state = this.state,
          bookmark = _this$state.bookmark,
          loading = _this$state.loading,
          open = _this$state.open,
          recent = _this$state.recent,
          _this$props = this.props,
          isPublic = _this$props.isPublic,
          getState = _this$props.getState,
          recentBookmarks = getRecent(),
          BookmarkElement = isPublic ? NoCloseMenuItem : TooltipNoCloseMenuItem;
      return /*#__PURE__*/React.createElement("div", {
        style: {
          display: 'inline',
          position: 'relative'
        }
      }, /*#__PURE__*/React.createElement(_button.Button, {
        onClick: this.onClick
      }, "Bookmark"), /*#__PURE__*/React.createElement(_menu.Menu, {
        innerRef: this.onRef,
        position: "topLeft",
        active: open,
        onHide: this.handleMenuHide,
        className: compStyles.iconBookmark,
        iconRipple: false,
        onShow: this.resetBookmark
      }, /*#__PURE__*/React.createElement(BookmarkElement, {
        tooltip: privateWarning,
        style: {
          pointerEvents: 'all'
          /* override MenuItem 'disabled' class */

        },
        disabled: !isPublic,
        onClick: this.onBookmark,
        caption: "Bookmark"
      }), recentBookmarks.length > (bookmark ? 1 : 0) ? /*#__PURE__*/React.createElement(_menu.MenuItem, {
        onClick: this.onRecent,
        title: null,
        caption: "Recent bookmarks"
      }) : null, /*#__PURE__*/React.createElement(_menu.MenuItem, {
        onClick: this.onExport,
        title: null,
        caption: "Export"
      }), /*#__PURE__*/React.createElement(_menu.MenuItem, {
        onClick: this.onImport,
        title: null,
        caption: "Import"
      }), linking ? /*#__PURE__*/React.createElement(_link["default"], {
        target: "_blank",
        href: "".concat(location.href.replace(/heatmap.*/, 'heatmap'), "heatmap/?columns=").concat((0, _columnsParam.getColumns)(getState()), "&heatmap=").concat((0, _heatmapParam.getHeatmap)(getState())),
        label: "Link"
      }) : null, /*#__PURE__*/React.createElement(_link["default"], {
        className: compStyles.help,
        target: "_blank",
        href: "https://ucsc-xena.gitbook.io/project/overview-of-features/bookmarks",
        label: "Help"
      }), bookmark || loading ? /*#__PURE__*/React.createElement(_menu.MenuDivider, null) : null, bookmark || loading ? /*#__PURE__*/React.createElement(_menu.MenuItem, {
        onClick: bookmark ? this.onCopyBookmarkToClipboard : undefined,
        caption: bookmark ? 'Copy Bookmark' : 'Your Bookmark is Loading',
        disabled: !bookmark
      }) : null, bookmark ? /*#__PURE__*/React.createElement("p", {
        className: compStyles.warning
      }, "Note: bookmarks are only guaranteed for 3 months after creation") : null, /*#__PURE__*/React.createElement("input", {
        className: compStyles.bookmarkInput,
        ref: function ref(input) {
          return _this2.bookmarkEl = input;
        },
        value: bookmark || ''
      }), /*#__PURE__*/React.createElement("input", {
        className: compStyles.importInput,
        ref: "import",
        id: "import",
        onChange: this.onImportSelected,
        type: "file"
      })), /*#__PURE__*/React.createElement(_menu.Menu, {
        onSelect: this.onViewBookmark,
        position: "auto",
        active: recent && recentBookmarks.length > 0,
        className: compStyles.iconBookmark,
        iconRipple: false,
        onHide: this.onRecentHide
      }, recentBookmarks.map(function (_ref) {
        var id = _ref.id,
            time = _ref.time;
        return /*#__PURE__*/React.createElement(_menu.MenuItem, {
          key: id,
          value: id,
          title: null,
          caption: "".concat(time.replace(/ GMT.*/, ''), " (").concat(id.slice(0, 4), ")")
        });
      })));
    }
  }]);
  return BookmarkMenu;
}(React.Component);

module.exports = BookmarkMenu;