"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CohortSuggest = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

var _input = _interopRequireDefault(require("react-toolbox/lib/input"));

require("./GeneSuggest.css");

var _XAutosuggest = _interopRequireDefault(require("./XAutosuggest"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var _ = require('../underscore_ext')["default"];

var renderInputComponent = function renderInputComponent(_ref) {
  var ref = _ref.ref,
      _onChange = _ref.onChange,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["ref", "onChange"]);
  return /*#__PURE__*/_react["default"].createElement(_input["default"], (0, _extends2["default"])({
    spellCheck: false,
    innerRef: function innerRef(el) {
      return ref(el && el.inputNode);
    },
    onChange: function onChange(value, ev) {
      return _onChange(ev);
    },
    label: "Search for a study"
  }, props));
};

var getSuggestions = function getSuggestions(value, cohorts) {
  var wordValues = value.toLowerCase().trim().split(/\s+/);
  return cohorts.filter(function (c) {
    return _.every(wordValues, function (value) {
      return c.toLowerCase().indexOf(value) > -1;
    });
  }).sort();
};

var CohortSuggest = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(CohortSuggest, _PureComponent);

  var _super = _createSuper(CohortSuggest);

  function CohortSuggest() {
    var _this;

    (0, _classCallCheck2["default"])(this, CohortSuggest);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      suggestions: [],
      value: _this.props.cohort || ""
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSuggestionsFetchRequested", function (_ref2) {
      var value = _ref2.value;

      _this.setState({
        suggestions: getSuggestions(value, _this.props.cohorts)
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSuggestionsClearRequested", function () {
      _this.setState({
        suggestions: []
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onClear", function () {
      _this.setState({
        value: ''
      });

      _.defer(function () {
        return _this.props.onSelect(null);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onChange", function (ev, _ref3) {
      var newValue = _ref3.newValue;

      _this.setState({
        value: newValue
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSelect", function (ev, _ref4) {
      var suggestionValue = _ref4.suggestionValue;

      // When props arrive we need to prefer user input, however that
      // prevents us setting state (setState here will be overwritten
      // by setState in componentWillReceiveProps, which will use the
      // old value of state). A horrible work-around is to defer
      // the call to onSelect. Similarly, with onClear, above.
      _this.setState({
        value: ''
      });

      _.defer(function () {
        return _this.props.onSelect(suggestionValue);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onBlur", function () {
      _this.setState({
        value: _this.props.cohort || _this.state.value
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "shouldRenderSuggestions", function () {
      return true;
    });
    return _this;
  }

  (0, _createClass2["default"])(CohortSuggest, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(props) {
      var value = this.state.value || props.cohort || "";
      this.setState({
        value: value,
        suggestions: value.trim().length > 0 ? getSuggestions(value, props.cohorts) : []
      });
    }
  }, {
    key: "render",
    value: function render() {
      var onChange = this.onChange,
          onBlur = this.onBlur,
          _this$state = this.state,
          suggestions = _this$state.suggestions,
          value = _this$state.value;
      return /*#__PURE__*/_react["default"].createElement(_XAutosuggest["default"], {
        suggestions: suggestions,
        onSuggestionsFetchRequested: this.onSuggestionsFetchRequested,
        onSuggestionsClearRequested: this.onSuggestionsClearRequested,
        onSuggestionSelected: this.onSelect,
        getSuggestionValue: function getSuggestionValue(x) {
          return x;
        },
        shouldRenderSuggestions: this.shouldRenderSuggestions,
        renderSuggestion: function renderSuggestion(v) {
          return /*#__PURE__*/_react["default"].createElement("span", null, v);
        },
        renderInputComponent: renderInputComponent,
        inputProps: {
          value: value,
          onChange: onChange,
          onBlur: onBlur
        },
        onClear: this.onClear,
        value: value
      });
    }
  }]);
  return CohortSuggest;
}(_PureComponent2["default"]);

exports.CohortSuggest = CohortSuggest;