"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _card = require("react-toolbox/lib/card");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Card displayed after (wizard-based) setup is complete, contains column visualization.
 *
 * State
 * -----
 * colId - ID of column (eg 'A', 'B').
 * controls - Icons and/or menu displayed at right of card title.
 * title - Text or element displayed as title.
 * subtitle - Text or element displayed as subtitle.
 * wizardMode - True if currently in wizard mode.
 */
// Core dependencies, components
var React = require('react');

var classNames = require('classnames'); // App dependencies


var CardAvatar = require('./CardAvatar'); // Styles


var compStyles = require('./ColCard.module.css');

var ColCard = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(ColCard, _React$Component);

  var _super = _createSuper(ColCard);

  function ColCard() {
    (0, _classCallCheck2["default"])(this, ColCard);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(ColCard, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          sortable = _this$props.sortable,
          controls = _this$props.controls,
          colId = _this$props.colId,
          onClick = _this$props.onClick,
          subtitle = _this$props.subtitle,
          title = _this$props.title,
          wizardMode = _this$props.wizardMode,
          geneZoomed = _this$props.geneZoomed,
          geneZoomPct = _this$props.geneZoomPct,
          zoomCard = _this$props.zoomCard,
          geneZoomText = geneZoomed ? "Zoomed to ".concat(geneZoomPct < 1 ? "< 1" : geneZoomPct, "%") : '';
      return /*#__PURE__*/React.createElement(_card.Card, {
        className: classNames('Column', (0, _defineProperty2["default"])({}, compStyles.zoomCard, zoomCard))
      }, /*#__PURE__*/React.createElement("div", {
        className: classNames(compStyles.headerContainer, sortable && 'Sortable-handle')
      }, /*#__PURE__*/React.createElement(CardAvatar, {
        colId: colId,
        zoomCard: zoomCard
      }), /*#__PURE__*/React.createElement("div", {
        className: compStyles.controls
      }, controls, /*#__PURE__*/React.createElement("div", {
        className: classNames(compStyles.cover, (0, _defineProperty2["default"])({}, compStyles.showOnHover, !wizardMode))
      }))), /*#__PURE__*/React.createElement("div", {
        className: compStyles.titleContainer
      }, /*#__PURE__*/React.createElement(_card.CardTitle, {
        className: compStyles.title,
        title: title,
        subtitle: subtitle
      }), geneZoomed ? /*#__PURE__*/React.createElement("div", {
        className: compStyles.zoomControl,
        onClick: onClick,
        title: geneZoomText
      }, /*#__PURE__*/React.createElement("span", null, geneZoomText), /*#__PURE__*/React.createElement("i", {
        className: "material-icons"
      }, "cancel")) : null), children);
    }
  }]);
  return ColCard;
}(React.Component);

module.exports = ColCard;