var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _assertThisInitialized = require("@babel/runtime/helpers/assertThisInitialized");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

var _defineProperty = require("@babel/runtime/helpers/defineProperty");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Column add component, displayed between column cards and after last column card. Used as click handler for inserting
 * or adding new card.
 *
 * State
 * -----
 * actionKey - Index of add column.
 * height - Height of add column component.
 * last - True if add column is after the last visualization column.
 *
 * Actions
 * -------
 * onClick - called on click of component.
 * onHover - called on mouse over and mouse out on component.
 */
// Core dependencies, components
var React = require('react');

var classNames = require('classnames'); // Styles


var compStyles = require('./ColumnAdd.module.css');

var ColumnAdd = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(ColumnAdd, _React$Component);

  var _super = _createSuper(ColumnAdd);

  function ColumnAdd() {
    var _this;

    _classCallCheck(this, ColumnAdd);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "onClick", function () {
      _this.props.onClick(_this.props.actionKey);
    });

    _defineProperty(_assertThisInitialized(_this), "onMouseOut", function () {
      var _this$props = _this.props,
          last = _this$props.last,
          onHover = _this$props.onHover,
          actionKey = _this$props.actionKey;

      if (!last) {
        onHover(actionKey, false);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onMouseOver", function () {
      var _this$props2 = _this.props,
          last = _this$props2.last,
          onHover = _this$props2.onHover,
          actionKey = _this$props2.actionKey;

      if (!last) {
        onHover(actionKey, true);
      }
    });

    return _this;
  }

  _createClass(ColumnAdd, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          show = _this$props3.show,
          last = _this$props3.last;
      return /*#__PURE__*/React.createElement("div", {
        className: classNames(compStyles.ColumnAdd, _defineProperty({}, compStyles.last, last && show)),
        style: {
          visibility: show ? 'visible' : 'hidden'
        },
        onClick: this.onClick,
        onMouseOut: this.onMouseOut,
        onMouseOver: this.onMouseOver
      }, /*#__PURE__*/React.createElement("div", {
        className: compStyles.text
      }, "Click to ", last ? 'Add' : 'Insert', " Column"));
    }
  }]);

  return ColumnAdd;
}(React.Component);

module.exports = ColumnAdd;