"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

var _react = _interopRequireDefault(require("react"));

var _XAutosuggest = _interopRequireDefault(require("./XAutosuggest"));

var _input = _interopRequireDefault(require("react-toolbox/lib/input"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var RETURN = 13;

var returnPressed = function returnPressed(ev) {
  return ev.keyCode === RETURN;
};

var renderInputComponent = function renderInputComponent(_ref) {
  var ref = _ref.ref,
      _onChange = _ref.onChange,
      label = _ref.label,
      error = _ref.error,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["ref", "onChange", "label", "error"]);
  return /*#__PURE__*/_react["default"].createElement(_input["default"], (0, _extends2["default"])({
    spellCheck: false,
    innerRef: function innerRef(el) {
      return ref(el && el.inputNode);
    },
    onChange: function onChange(value, ev) {
      return _onChange(ev);
    },
    label: label || 'Enter concept or text'
  }, props), /*#__PURE__*/_react["default"].createElement("i", {
    style: {
      color: 'red',
      opacity: error ? 1 : 0
    },
    className: "material-icons"
  }, "error"));
};

var ConceptSuggest = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(ConceptSuggest, _PureComponent);

  var _super = _createSuper(ConceptSuggest);

  function ConceptSuggest() {
    var _this;

    (0, _classCallCheck2["default"])(this, ConceptSuggest);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      suggestions: [],
      value: ''
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSuggestionsFetchRequested", function (_ref2) {
      var value = _ref2.value;
      // need to trim value?
      var concepts = _this.props.concepts,
          lcv = value.toLowerCase();

      _this.setState({
        suggestions: concepts.filter(function (c) {
          return c.toLowerCase().indexOf(lcv) !== -1;
        })
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSuggestionsClearRequested", function () {
      _this.setState({
        suggestions: []
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onChange", function (ev, _ref3) {
      var newValue = _ref3.newValue,
          method = _ref3.method;

      // Don't update the value for 'up' and 'down' keys. If we do update
      // the value, it gives us an in-place view of the suggestion (pasting
      // the value into the input field), but the drawback is that it moves
      // the cursor to the end of the line. This messes up multi-word input.
      // We could try to preserve the cursor position, perhaps by passing a
      // custom input renderer. But for now, just don't update the value for
      // these events.
      if (method !== 'up' && method !== 'down') {
        _this.setState({
          value: newValue
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onKeyDown", function (ev) {
      var value = ev.target.value.trim();

      if (returnPressed(ev) && value.length > 0) {
        _this.props.onAddTerm(value);

        _this.setState({
          value: ''
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getSuggestionValue", function (suggestion) {
      return suggestion;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "shouldRenderSuggestions", function (value) {
      return value.trim().length > 2;
    });
    return _this;
  }

  (0, _createClass2["default"])(ConceptSuggest, [{
    key: "render",
    value: function render() {
      var onChange = this.onChange,
          onKeyDown = this.onKeyDown,
          _this$props = this.props,
          label = _this$props.label,
          error = _this$props.error,
          _this$state = this.state,
          suggestions = _this$state.suggestions,
          value = _this$state.value;
      return /*#__PURE__*/_react["default"].createElement(_XAutosuggest["default"], {
        inputRef: this.setInput,
        suggestions: suggestions,
        renderSuggestion: function renderSuggestion(v) {
          return /*#__PURE__*/_react["default"].createElement("span", null, v);
        },
        onSuggestionsFetchRequested: this.onSuggestionsFetchRequested,
        onSuggestionsClearRequested: this.onSuggestionsClearRequested,
        getSuggestionValue: this.getSuggestionValue,
        shouldRenderSuggestions: this.shouldRenderSuggestions,
        renderInputComponent: renderInputComponent,
        inputProps: {
          value: value,
          label: label,
          error: error,
          onKeyDown: onKeyDown,
          onChange: onChange
        }
      });
    }
  }]);
  return ConceptSuggest;
}(_PureComponent2["default"]);

var _default = ConceptSuggest;
exports["default"] = _default;