"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var _require = require('react-overlays'),
    Portal = _require.Portal; // Styles


var compStyles = require('./Crosshair.module.css');

var classNames = require('classnames');

var Crosshair = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(Crosshair, _PureComponent);

  var _super = _createSuper(Crosshair);

  function Crosshair() {
    var _this;

    (0, _classCallCheck2["default"])(this, Crosshair);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      mousing: false,
      x: -1,
      y: -1
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onMouseMove", function (ev) {
      var x = ev.clientX - ev.currentTarget.getBoundingClientRect().left;

      if (!_this.props.frozen) {
        _this.setState({
          mousing: true,
          x: x,
          y: ev.clientY
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onMouseOut", function () {
      if (!_this.props.frozen) {
        _this.setState({
          mousing: false
        });
      }
    });
    return _this;
  }

  (0, _createClass2["default"])(Crosshair, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (!nextProps.frozen && !nextProps.mousing) {
        this.setState({
          mousing: false,
          x: -1,
          y: -1
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          mousing = _this$state.mousing,
          x = _this$state.x,
          y = _this$state.y,
          onMouseMove = this.onMouseMove,
          onMouseOut = this.onMouseOut,
          _this$props = this.props,
          frozen = _this$props.frozen,
          geneHeight = _this$props.geneHeight,
          height = _this$props.height,
          selection = _this$props.selection,
          children = _this$props.children,
          zoomMode = selection ? true : false,
          cursor = zoomMode ? 'none' : frozen ? 'default' : 'none';

      if (selection) {
        var crosshair = selection.crosshair,
            offset = selection.offset,
            zone = selection.zone,
            xZoomTarget = crosshair.x - 6,
            yZoomTarget = crosshair.y - 6,
            crosshairVHeight = geneHeight + 8 + height,
            crosshairVTop = zone === 'a' ? offset.y - 8 : offset.y - geneHeight - 8;
      }

      var getCrosshairVClassName = function getCrosshairVClassName(zoomMode) {
        var _classNames;

        return classNames((_classNames = {}, (0, _defineProperty2["default"])(_classNames, compStyles.crosshairV, !zoomMode), (0, _defineProperty2["default"])(_classNames, compStyles.inspectCrosshair, !zoomMode), (0, _defineProperty2["default"])(_classNames, compStyles.zoomCrosshairV, zoomMode), _classNames));
      };

      var getCrosshairHClassName = function getCrosshairHClassName(zoomMode) {
        var _classNames2;

        return classNames((_classNames2 = {}, (0, _defineProperty2["default"])(_classNames2, compStyles.crosshairH, !zoomMode), (0, _defineProperty2["default"])(_classNames2, compStyles.inspectCrosshair, !zoomMode), (0, _defineProperty2["default"])(_classNames2, compStyles.zoomCrosshairH, zoomMode), _classNames2));
      };

      return /*#__PURE__*/React.createElement("div", {
        style: {
          cursor: cursor
        },
        onMouseMove: onMouseMove,
        onMouseOut: onMouseOut
      }, children, zoomMode || mousing ? /*#__PURE__*/React.createElement("div", {
        className: classNames(compStyles.crosshair, getCrosshairVClassName(zoomMode)),
        style: {
          bottom: zoomMode ? 'unset' : 0,
          left: zoomMode ? crosshair.x : x,
          height: zoomMode ? crosshairVHeight : height,
          top: zoomMode ? crosshairVTop : 'unset'
        }
      }) : null, zoomMode ? /*#__PURE__*/React.createElement("div", {
        className: classNames(compStyles.crosshair, compStyles.crosshairTarget),
        style: {
          left: xZoomTarget,
          top: yZoomTarget
        }
      }) : null, zoomMode || mousing ? /*#__PURE__*/React.createElement(Portal, {
        container: document.body
      }, /*#__PURE__*/React.createElement("div", {
        className: classNames(compStyles.crosshairs)
      }, /*#__PURE__*/React.createElement("span", {
        className: classNames(compStyles.crosshair, getCrosshairHClassName(zoomMode)),
        style: {
          top: zoomMode ? crosshair.y : y
        }
      }))) : null);
    }
  }]);
  return Crosshair;
}(_PureComponent2["default"]);

module.exports = Crosshair;