"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var _require = require('../react-utils'),
    rxEvents = _require.rxEvents; // Comp styles


var compStyles = require('./DefaultTextInput.module.css');

var DefaultTextInput = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(DefaultTextInput, _PureComponent);

  var _super = _createSuper(DefaultTextInput);

  function DefaultTextInput() {
    var _this;

    (0, _classCallCheck2["default"])(this, DefaultTextInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      value: _this.props.value.user,
      focused: false
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetIfNull", function () {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          defaultValue = _this$props.value['default'],
          val = _this.refs.input.value;

      if (val === "") {
        _this.setState({
          value: defaultValue
        });

        onChange(defaultValue);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onBlur", function () {
      _this.setState({
        focused: false
      });

      _this.resetIfNull();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onFocus", function () {
      _this.setState({
        focused: true
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "update", function () {
      var onChange = _this.props.onChange,
          value = _this.state.value;
      onChange(value);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onKeyUp", function (ev) {
      if (ev.key === 'Enter' && (0, _assertThisInitialized2["default"])(_this)) {
        _this.resetIfNull();

        _this.refs.input.blur();
      }
    });
    return _this;
  }

  (0, _createClass2["default"])(DefaultTextInput, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      var events = rxEvents(this, 'change');
      this.change = events.change["do"](function () {
        return _this2.setState({
          value: _this2.refs.input.value
        });
      }).debounceTime(100).subscribe(this.update);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.change.unsubscribe();
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(newProps) {
      this.setState({
        value: newProps.value.user
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          value = _this$state.value,
          focused = _this$state.focused,
          _this$props$disabled = this.props.disabled,
          disabled = _this$props$disabled === void 0 ? false : _this$props$disabled;
      return /*#__PURE__*/React.createElement("span", {
        style: {
          position: 'relative'
        }
      }, /*#__PURE__*/React.createElement("label", {
        className: focused ? compStyles.labelFocused : compStyles.label
      }, "Customize label"), /*#__PURE__*/React.createElement("input", {
        className: focused ? compStyles.inputFocused : compStyles.input,
        spellCheck: false,
        ref: "input",
        disabled: disabled,
        onChange: this.on.change,
        onKeyUp: this.onKeyUp,
        onBlur: this.onBlur,
        onFocus: this.onFocus,
        type: "text",
        title: value,
        value: value
      }));
    }
  }]);
  return DefaultTextInput;
}(_PureComponent2["default"]);

module.exports = DefaultTextInput;