"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

var _input = _interopRequireDefault(require("react-toolbox/lib/input"));

var _XAutosuggest = _interopRequireDefault(require("./XAutosuggest"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var _ = require('../underscore_ext')["default"];

require('./GeneSuggest.css'); // XXX rename file


var lcs = require('../lcs');

var XRadioGroup = require('./XRadioGroup');

function toLCWords(str) {
  return str.toLowerCase().split(/[ \t]/);
}

function applyBias(bias, x) {
  return x > 0 ? (x - 1) * bias + 1 : 0;
} // tag and input are ordered lists of words, from strings that have
// been normalized to lower case, and split on whitespace.
//
// We count each word match. We count multiple word matches more
// strongly than a sum of the word matches. We count ordered
// word matches more strongly than multiple word matches


var multiWordBias = 1.5,
    orderBias = 1.7;

function scoreTag(tag, input) {
  var matches = _.intersection(tag, input),
      wordBiased = applyBias(multiWordBias, matches.length),
      ordered = matches.length > 0 ? lcs(tag, input) : 0;

  return wordBiased * applyBias(orderBias, ordered);
}

function scoreCohorts(cohortMeta, tags, weights) {
  return tags.reduce(function (cohorts, tag, i) {
    var w = weights[i];

    if (w > 0) {
      cohortMeta[tag].forEach(function (cohort) {
        return cohorts[cohort] = (cohorts[cohort] || 0) + w;
      });
    }

    return cohorts;
  }, {});
} // Return list of cohorts ordered by strength of match to input.


function match(cohortMeta, input) {
  //eslint-disable-line no-unused-vars
  var tags = Object.keys(cohortMeta),
      normInput = toLCWords(input),
      normTags = tags.map(toLCWords),
      weights = normTags.map(function (t) {
    return scoreTag(t, normInput);
  }),
      cohortScores = scoreCohorts(cohortMeta, tags, weights);
  return Object.keys(cohortScores).sort(function (c, d) {
    return cohortScores[d] - cohortScores[c];
  });
}

function scoreTag2(tag, input) {
  var matches = _.intersection(tag, input),
      wordBiased = applyBias(multiWordBias, matches.length),
      ordered = matches.length > 0 ? lcs(tag, input) : 0;

  return {
    matches: matches.sort(),
    tag: tag,
    weight: wordBiased * applyBias(orderBias, ordered)
  };
} // For each set of matched input words, pick the highest-scoring match


function scoreCohorts2(cohortMeta, tags, weights) {
  //eslint-disable-line no-unused-vars
  var byCohort = _.groupBy(_.flatmap(cohortMeta, function (cohorts, tag) {
    return cohorts.map(function (cohort) {
      return {
        cohort: cohort,
        tag: tag
      };
    });
  }), 'cohort'),
      tagWeights = _.object(tags, weights),
      cohortWeights = _.map(byCohort, function (cohortTags, cohort) {
    var cohortTagWeights = _.pick(tagWeights, _.pluck(cohortTags, 'tag')),
        groups = _.map(_.groupBy(cohortTagWeights, 'matches'), function (weights) {
      return _.maxWith(weights, function (x, y) {
        return x.weight - y.weight;
      });
    }).filter(function (_ref) {
      var weight = _ref.weight;
      return weight > 0;
    });

    return {
      cohort: cohort,
      weight: _.sum(_.pluck(groups, 'weight')),
      groups: groups
    };
  });

  return _.sortBy(cohortWeights.filter(function (_ref2) {
    var weight = _ref2.weight;
    return weight > 0;
  }), function (_ref3) {
    var weight = _ref3.weight;
    return -weight;
  });
} // For each set of matched input words, pick the highest-scoring match,
// scale by number of matches for the set / total tag count for the cohort


function scoreCohorts3(cohortMeta, tags, weights) {
  //eslint-disable-line no-unused-vars
  var byCohort = _.groupBy(_.flatmap(cohortMeta, function (cohorts, tag) {
    return cohorts.map(function (cohort) {
      return {
        cohort: cohort,
        tag: tag
      };
    });
  }), 'cohort'),
      tagWeights = _.object(tags, weights),
      cohortWeights = _.map(byCohort, function (cohortTags, cohort) {
    var cohortTagWeights = _.pick(tagWeights, _.pluck(cohortTags, 'tag')),
        groups = _.map(_.groupBy(cohortTagWeights, 'matches'), function (weights) {
      return _.updateIn(_.maxWith(weights, function (x, y) {
        return x.weight - y.weight;
      }), ['weight'], function (w) {
        return w * weights.length / Math.sqrt(cohortTags.length);
      });
    }).filter(function (_ref4) {
      var weight = _ref4.weight;
      return weight > 0;
    });

    return {
      cohort: cohort,
      weight: _.sum(_.pluck(groups, 'weight')),
      groups: groups
    };
  });

  return _.sortBy(cohortWeights.filter(function (_ref5) {
    var weight = _ref5.weight;
    return weight > 0;
  }), function (_ref6) {
    var weight = _ref6.weight;
    return -weight;
  });
} // XXX


var DEBUG = false; //var scoreFn = scoreCohorts2;

var scoreFn = scoreCohorts3; // XXX

function matchSimplified(cohortMeta, input) {
  var tags = Object.keys(cohortMeta),
      normInput = toLCWords(input),
      normTags = tags.map(toLCWords),
      weights = normTags.map(function (t) {
    return scoreTag2(t, normInput);
  }); //return scoreFn(cohortMeta, tags, weights);
  // cohort's matching weight is linearly normalized (multiplication) by the number of normalized input found divided by the length of the inputs

  var ma = scoreFn(cohortMeta, tags, weights);
  ma.map(function (maObj) {
    var matchedPerCohort = _.flatten(maObj.groups.map(function (g) {
      return g.matches;
    }));

    var foundLength = normInput.filter(function (i) {
      return matchedPerCohort.indexOf(i) !== -1;
    }).length;
    maObj.weight = maObj.weight * foundLength / normInput.length;
  });
  ma = _.sortBy(ma, function (maObj) {
    return maObj.weight;
  }).reverse();
  return ma;
} // match by logical AND, instead of a scoring system


function matchExact(cohortMeta, input) {
  //eslint-disable-line no-unused-vars
  var tags = Object.keys(cohortMeta),
      normInput = toLCWords(input),
      matches = tags.filter(function (tag) {
    return _.contains(normInput, tag.toLowerCase());
  });
  return _.intersection.apply(_, (0, _toConsumableArray2["default"])(matches.map(function (t) {
    return cohortMeta[t];
  })));
} // Return the start and end indices of the word in 'value'
// under the cursor position.


function currentWordPosition(value, position) {
  var li = value.slice(0, position).lastIndexOf(' '),
      i = li === -1 ? 0 : li + 1,
      lj = value.slice(position).indexOf(' '),
      j = lj === -1 ? value.length : position + lj;
  return [i, j];
} // Return the word in 'value' under the cursor position


function currentWord(value, position) {
  var _currentWordPosition = currentWordPosition(value, position),
      _currentWordPosition2 = (0, _slicedToArray2["default"])(_currentWordPosition, 2),
      i = _currentWordPosition2[0],
      j = _currentWordPosition2[1];

  return value.slice(i, j);
}

var renderInputComponent = function renderInputComponent(_ref7) {
  var ref = _ref7.ref,
      _onChange = _ref7.onChange,
      props = (0, _objectWithoutProperties2["default"])(_ref7, ["ref", "onChange"]);
  return /*#__PURE__*/React.createElement(_input["default"], (0, _extends2["default"])({
    spellCheck: false,
    innerRef: function innerRef(el) {
      return ref(el && el.inputNode);
    },
    onChange: function onChange(value, ev) {
      return _onChange(ev);
    },
    label: "Primary Disease or Tissue of Origin"
  }, props));
};

var DiseaseSuggest = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(DiseaseSuggest, _PureComponent);

  var _super = _createSuper(DiseaseSuggest);

  function DiseaseSuggest() {
    var _this;

    (0, _classCallCheck2["default"])(this, DiseaseSuggest);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      suggestions: [],
      value: ""
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSuggestionsFetchRequested", function (_ref8) {
      var value = _ref8.value;
      var position = _this.input.selectionStart,
          word = currentWord(value, position),
          lcValue = word.toLowerCase(),
          cohortMeta = _this.props.cohortMeta,
          tags = Object.keys(cohortMeta);

      _this.setState({
        suggestions: _.filter(tags, function (t) {
          return t.toLowerCase().indexOf(lcValue) === 0;
        })
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSuggestionsClearRequested", function () {
      _this.setState({
        suggestions: []
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onChange", function (ev, _ref9) {
      var newValue = _ref9.newValue,
          method = _ref9.method;

      // Don't update the value for 'up' and 'down' keys. If we do update
      // the value, it gives us an in-place view of the suggestion (pasting
      // the value into the input field), but the drawback is that it moves
      // the cursor to the end of the line. This messes up multi-word input.
      // We could try to preserve the cursor position, perhaps by passing a
      // custom input renderer. But for now, just don't update the value for
      // these events.
      if (method !== 'up' && method !== 'down') {
        _this.setState({
          value: newValue
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSelect", function (ev, _ref10) {
      var suggestionValue = _ref10.suggestionValue;

      _this.setState({
        value: suggestionValue
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onClear", function () {
      _this.setState({
        value: ""
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onCohort", function (value) {
      _this.props.onSelect(value);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "shouldRenderSuggestions", function () {
      return true;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getSuggestionValue", function (suggestion) {
      var position = _this.input.selectionStart,
          value = _this.input.value,
          _currentWordPosition3 = currentWordPosition(value, position),
          _currentWordPosition4 = (0, _slicedToArray2["default"])(_currentWordPosition3, 2),
          i = _currentWordPosition4[0],
          j = _currentWordPosition4[1]; // splice the suggestion into the current word


      return value.slice(0, i) + suggestion + value.slice(j);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setInput", function (input) {
      _this.input = input;
    });
    return _this;
  }

  (0, _createClass2["default"])(DiseaseSuggest, [{
    key: "render",
    value: function render() {
      var onChange = this.onChange,
          _this$state = this.state,
          suggestions = _this$state.suggestions,
          value = _this$state.value,
          _this$props = this.props,
          cohortMeta = _this$props.cohortMeta,
          cohort = _this$props.cohort,
          results = matchSimplified(cohortMeta, value);

      var buildStudyDebugLabel = function buildStudyDebugLabel(c, weight, groups) {
        var groupsText = groups.map(function (_ref11) {
          var tag = _ref11.tag,
              weight = _ref11.weight;
          return "".concat(tag.join(' '), " ").concat(weight.toPrecision(2));
        });
        return "".concat(c, " [").concat(weight.toPrecision(2), " ").concat(groupsText, "]");
      };

      var studyProps = {
        label: 'Study',
        value: cohort,
        onChange: this.onCohort,
        options: results.map(function (_ref12) {
          var c = _ref12.cohort,
              weight = _ref12.weight,
              groups = _ref12.groups;
          return {
            label: DEBUG ? buildStudyDebugLabel(c, weight, groups) : c,
            value: c
          };
        })
      };
      return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(_XAutosuggest["default"], {
        inputRef: this.setInput,
        suggestions: suggestions,
        onSuggestionsFetchRequested: this.onSuggestionsFetchRequested,
        onSuggestionsClearRequested: this.onSuggestionsClearRequested,
        onSuggestionSelected: this.onSelect,
        getSuggestionValue: this.getSuggestionValue,
        shouldRenderSuggestions: this.shouldRenderSuggestions,
        renderSuggestion: function renderSuggestion(v) {
          return /*#__PURE__*/React.createElement("span", null, v);
        },
        renderInputComponent: renderInputComponent,
        inputProps: {
          value: value,
          onChange: onChange
        },
        value: value,
        onClear: this.onClear
      }), results.length > 0 ? /*#__PURE__*/React.createElement(XRadioGroup, studyProps) : null);
    }
  }]);
  return DiseaseSuggest;
}(_PureComponent2["default"]);

module.exports = DiseaseSuggest;