var _extends = require("@babel/runtime/helpers/extends");

var _objectWithoutProperties = require("@babel/runtime/helpers/objectWithoutProperties");

var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

var _defineProperty = require("@babel/runtime/helpers/defineProperty");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react'); //var ReactDOM = require('react-dom');


var Rx = require('../rx')["default"];

var _ = require('../underscore_ext')["default"];

var styles = {
  wrapper: {
    position: 'relative'
  }
};

var clip = function clip(min, max, x) {
  return x < min ? min : x > max ? max : x;
};

function crosshairXPos(target, ev, width) {
  var bb = target.getBoundingClientRect();
  return clip(bb.left, bb.left + width - 1, ev.clientX);
}

function crosshairYPos(target, ev, height) {
  var bb = target.getBoundingClientRect();
  return clip(bb.top, bb.top + height - 1, ev.clientY);
}

function targetXPos(target, ev, width) {
  var bb = target.getBoundingClientRect();
  return clip(0, width - 1, ev.clientX - bb.left);
}

function targetYPos(target, ev, height) {
  var bb = target.getBoundingClientRect();
  return clip(0, height - 1, ev.clientY - bb.top);
} // Browsers give us coordinates that aren't always within the element. We
// would expect coords [0, width - 1] to indicate which pixel the mouse is over,
// but sometimes get coords outside that range.
//
// We clip start and end to [0, width - 1].


var DragSelect = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(DragSelect, _React$Component);

  var _super = _createSuper(DragSelect);

  function DragSelect() {
    _classCallCheck(this, DragSelect);

    return _super.apply(this, arguments);
  }

  _createClass(DragSelect, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this = this;

      var mousedown = new Rx.Subject();
      var mousedrag = mousedown.flatMap(function (down) {
        var target = down.currentTarget,
            bb = target.getBoundingClientRect(),
            startX = targetXPos(target, down, bb.width),
            startY = targetYPos(target, down, bb.height),
            selection;
        return Rx.Observable.fromEvent(window, 'mousemove').map(function (mm) {
          var width = bb.width,
              height = bb.height,
              endX = targetXPos(target, mm, width),
              endY = targetYPos(target, mm, height),
              crosshairX = crosshairXPos(target, mm, width),
              crosshairY = crosshairYPos(target, mm, height);
          selection = {
            start: {
              x: startX,
              y: startY
            },
            end: {
              x: endX,
              y: endY
            },
            offset: {
              x: bb.left,
              y: bb.top
            },
            crosshair: {
              x: crosshairX,
              y: crosshairY
            }
          };
          return _objectSpread({
            dragging: true
          }, selection);
        }).takeUntil(Rx.Observable.fromEvent(window, 'mouseup')).concat(Rx.Observable.defer(function () {
          return Rx.Observable.of({
            selection: selection
          });
        }));
      });
      this.subscription = mousedrag.subscribe(function (ev) {
        var dragging = ev.dragging,
            selection = _objectWithoutProperties(ev, ["dragging"]);

        if (dragging) {
          _this.props.onDrag && _this.props.onDrag(selection);
        }

        if (ev.selection) {
          _this.props.onSelect && _this.props.onSelect(ev.selection);
        }
      });

      this.dragStart = function (ev) {
        return _this.props.enabled && mousedown.next(ev);
      };
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.subscription.unsubscribe();
    }
  }, {
    key: "render",
    value: function render() {
      var containerProps = _.omit(this.props, 'onSelect', 'enabled');

      return /*#__PURE__*/React.createElement("div", _extends({}, containerProps, {
        style: styles.wrapper,
        onMouseDown: this.dragStart
      }), this.props.children);
    }
  }]);

  return DragSelect;
}(React.Component);

_defineProperty(DragSelect, "defaultProps", {
  enabled: true
});

module.exports = DragSelect;