"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GeneSetViewDialog = exports.GENESETS_VIEWER_URL = exports.AVAILABLE_GENESET_COHORTS = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _dialog = _interopRequireDefault(require("react-toolbox/lib/dialog"));

var _reactIframe = _interopRequireDefault(require("react-iframe"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

var _genesetviewerModule = _interopRequireDefault(require("./genesetviewer.module.css"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var AVAILABLE_GENESET_COHORTS = ["TCGA Liver Cancer (LIHC)", "TCGA Cervical Cancer (CESC)", "TCGA Sarcoma (SARC)", "TCGA Thymoma (THYM)", "TCGA Mesothelioma (MESO)", "TCGA Pancreatic Cancer (PAAD)", "TCGA Ocular melanomas (UVM)", "TCGA Rectal Cancer (READ)", "TCGA Lung Squamous Cell Carcinoma (LUSC)", "TCGA Stomach Cancer (STAD)", "TCGA Colon Cancer (COAD)", "TCGA Lower Grade Glioma (LGG)", "TCGA Thyroid Cancer (THCA)", "TCGA Kidney Chromophobe (KICH)", "TCGA Kidney Papillary Cell Carcinoma (KIRP)", "TCGA Bile Duct Cancer (CHOL)", "TCGA Glioblastoma (GBM)", "TCGA Lung Adenocarcinoma (LUAD)", "TCGA Ovarian Cancer (OV)", "TCGA Kidney Clear Cell Carcinoma (KIRC)", "TCGA Endometrioid Cancer (UCEC)", "TCGA Head and Neck Cancer (HNSC)", "TCGA Adrenocortical Cancer (ACC)", "TCGA Prostate Cancer (PRAD)", "TCGA Uterine Carcinosarcoma (UCS)", "TCGA Melanoma (SKCM)", "TCGA Pheochromocytoma & Paraganglioma (PCPG)", "TCGA Breast Cancer (BRCA)", "TCGA Testicular Cancer (TGCT)", "TCGA Acute Myeloid Leukemia (LAML)", "TCGA Large B-cell Lymphoma (DLBC)", "TCGA Bladder Cancer (BLCA)", "TCGA Esophageal Cancer (ESCA)", "Cancer Cell Line Encyclopedia (Breast)"];
exports.AVAILABLE_GENESET_COHORTS = AVAILABLE_GENESET_COHORTS;
var GENESETS_VIEWER_URL = 'https://xenageneset.berkeleybop.io/xena/#'; // export const GENESETS_VIEWER_URL = 'http://localhost:3000/#';

exports.GENESETS_VIEWER_URL = GENESETS_VIEWER_URL;

var GeneSetViewDialog = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(GeneSetViewDialog, _PureComponent);

  var _super = _createSuper(GeneSetViewDialog);

  function GeneSetViewDialog() {
    (0, _classCallCheck2["default"])(this, GeneSetViewDialog);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(GeneSetViewDialog, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          showGeneSetWizard = _this$props.showGeneSetWizard,
          onHide = _this$props.onHide,
          geneSetUrl = _this$props.geneSetUrl;
      var actions = [{
        children: [/*#__PURE__*/React.createElement("i", {
          className: "material-icons"
        }, "close")],
        className: _genesetviewerModule["default"].mainDialogClose,
        onClick: this.props.onHide
      }];
      return /*#__PURE__*/React.createElement(_dialog["default"], {
        actions: actions,
        active: showGeneSetWizard,
        className: _genesetviewerModule["default"].mainDialog,
        onEscKeyDown: onHide,
        onOverlayClick: onHide,
        title: "Differential Geneset Visualization",
        theme: {
          dialog: _genesetviewerModule["default"].dialogBase,
          wrapper: _genesetviewerModule["default"].dialogWrapper
        }
      }, /*#__PURE__*/React.createElement(_reactIframe["default"], {
        url: geneSetUrl,
        src: geneSetUrl,
        width: "100%",
        className: _genesetviewerModule["default"].genesetiframe,
        height: "350px",
        id: "myId",
        display: "block",
        loading: "Loading wizard",
        position: "relative"
      }));
    }
  }]);
  return GeneSetViewDialog;
}(_PureComponent2["default"]);

exports.GeneSetViewDialog = GeneSetViewDialog;