"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

var _XAutosuggest = _interopRequireDefault(require("./XAutosuggest"));

var _input = _interopRequireDefault(require("react-toolbox/lib/input"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var _require$default = require('../rx')["default"],
    Observable = _require$default.Observable,
    Scheduler = _require$default.Scheduler;

var _require = require('../xenaQuery'),
    matchPartialField = _require.matchPartialField,
    sparseDataMatchPartialField = _require.sparseDataMatchPartialField,
    refGene = _require.refGene;

var _ = require('../underscore_ext')["default"];

var _require2 = require('../react-utils'),
    rxEvents = _require2.rxEvents;

require('./GeneSuggest.css'); // react-autosuggest, global styles


var styles = require('./GeneSuggest.module.css'); // react-toolbox, module styles


var limit = 8; // Return the start and end indices of the word in 'value'
// under the cursor position.

function currentWordPosition(value, position) {
  var li = value.slice(0, position).lastIndexOf(' '),
      i = li === -1 ? 0 : li + 1,
      lj = value.slice(position).indexOf(' '),
      j = lj === -1 ? value.length : position + lj;
  return [i, j];
} // Return the word in 'value' under the cursor position


function currentWord(value, position) {
  var _currentWordPosition = currentWordPosition(value, position),
      _currentWordPosition2 = (0, _slicedToArray2["default"])(_currentWordPosition, 2),
      i = _currentWordPosition2[0],
      j = _currentWordPosition2[1];

  return value.slice(i, j);
}

var renderInputComponent = function renderInputComponent(_ref) {
  var ref = _ref.ref,
      _onChange = _ref.onChange,
      label = _ref.label,
      error = _ref.error,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["ref", "onChange", "label", "error"]);
  return /*#__PURE__*/React.createElement(_input["default"], (0, _extends2["default"])({
    theme: styles,
    error: _.isString(error) ? error : null,
    spellCheck: false,
    innerRef: function innerRef(el) {
      return ref(el && el.inputNode);
    },
    onChange: function onChange(value, ev) {
      return _onChange(ev);
    },
    label: label || 'Add Gene or Position'
  }, props), /*#__PURE__*/React.createElement("i", {
    style: {
      color: 'red',
      opacity: error ? 1 : 0
    },
    className: "material-icons"
  }, "error"));
};

var empty = Observable.of([], Scheduler.asap); // host and name are for gene lookup.
// dataset is for probe lookup

var fetchSuggestions = function fetchSuggestions(assembly, dataset, value) {
  return Observable.zip(assembly ? sparseDataMatchPartialField(assembly.host, 'name2', assembly.name, value, limit)["catch"](function () {
    return empty;
  }) : empty, dataset ? matchPartialField(dataset, value, limit)["catch"](function () {
    return empty;
  }) : empty, function (genes, probes) {
    return genes.sort().concat(_.difference(probes, genes).sort());
  });
}; // Currently we only match against refGene hg38 genes. We could, instead, match
// on specific datasets (probemap, mutation, segmented, refGene), but that will
// require some more work to dispatch the query for each type.


var GeneSuggest = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(GeneSuggest, _PureComponent);

  var _super = _createSuper(GeneSuggest);

  function GeneSuggest() {
    var _this;

    (0, _classCallCheck2["default"])(this, GeneSuggest);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      suggestions: []
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSuggestionsFetchRequested", function (_ref2) {
      var value = _ref2.value;
      var position = _this.input.selectionStart,
          word = currentWord(value, position);

      _this.on.change(word);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "shouldRenderSuggestions", function () {
      return true;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSuggestionsClearRequested", function () {
      _this.on.change(undefined);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onChange", function (ev, _ref3) {
      var newValue = _ref3.newValue,
          method = _ref3.method;

      // Don't update the value for 'up' and 'down' keys. If we do update
      // the value, it gives us an in-place view of the suggestion (pasting
      // the value into the input field), but the drawback is that it moves
      // the cursor to the end of the line. This messes up multi-word input.
      // We could try to preserve the cursor position, perhaps by passing a
      // custom input renderer. But for now, just don't update the value for
      // these events.
      if (method !== 'up' && method !== 'down') {
        _this.props.onChange(newValue);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getSuggestionValue", function (suggestion) {
      var position = _this.input.selectionStart,
          value = _this.input.value,
          _currentWordPosition3 = currentWordPosition(value, position),
          _currentWordPosition4 = (0, _slicedToArray2["default"])(_currentWordPosition3, 2),
          i = _currentWordPosition4[0],
          j = _currentWordPosition4[1],
          withSuggestion = value.slice(0, i) + suggestion + value.slice(j); // splice the suggestion into the current word


      return withSuggestion;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setInput", function (input) {
      var inputRef = _this.props.inputRef;
      _this.input = input;

      if (inputRef) {
        inputRef(_this.input);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setAutosuggest", function (v) {
      _this.autosuggest = v;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onKeyDown", function (ev) {
      // We'd like <return> to select a suggestion when suggestions are shown,
      // but invoke "Done" when suggestions are not shown. react-autosuggest
      // won't tell us when it's open. So, we have to inspect the child state
      // to infer when it's open.
      if (_this.props.onKeyDown && (!_.getIn((0, _assertThisInitialized2["default"])(_this), ['autosuggest', 'state', 'isFocused']) || _.getIn((0, _assertThisInitialized2["default"])(_this), ['autosuggest', 'state', 'isCollapsed']))) {
        _this.props.onKeyDown(ev);
      }
    });
    return _this;
  }

  (0, _createClass2["default"])(GeneSuggest, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      var events = rxEvents(this, 'change');
      this.change = events.change.debounceTime(200).switchMap(function (value) {
        return value === undefined ? empty : fetchSuggestions(refGene[_this2.props.assembly], _this2.props.dataset, value);
      }).subscribe(function (matches) {
        return _this2.setState({
          suggestions: matches
        });
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.change.unsubscribe();
    }
  }, {
    key: "render",
    value: function render() {
      var onChange = this.onChange,
          onKeyDown = this.onKeyDown,
          _this$props = this.props,
          _this$props$value = _this$props.value,
          value = _this$props$value === void 0 ? '' : _this$props$value,
          label = _this$props.label,
          error = _this$props.error,
          suggestions = this.state.suggestions;
      return /*#__PURE__*/React.createElement(_XAutosuggest["default"], {
        inputRef: this.setInput,
        autosuggestRef: this.setAutosuggest,
        suggestions: suggestions,
        onSuggestionsFetchRequested: this.onSuggestionsFetchRequested,
        onSuggestionsClearRequested: this.onSuggestionsClearRequested,
        getSuggestionValue: this.getSuggestionValue,
        shouldRenderSuggestions: this.shouldRenderSuggestions,
        renderSuggestion: function renderSuggestion(v) {
          return /*#__PURE__*/React.createElement("span", null, v);
        },
        renderInputComponent: renderInputComponent,
        inputProps: {
          value: value,
          label: label,
          error: error,
          onKeyDown: onKeyDown,
          onChange: onChange
        }
      });
    }
  }]);
  return GeneSuggest;
}(_PureComponent2["default"]);

module.exports = GeneSuggest;