"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _button = require("react-toolbox/lib/button");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Standard Xena help box, hand-rolled outside of RTB as we may require more than one help box (ie dialog) open
 * at a time, and we want to be able to control the overlay or lack thereof. RTB currently does not allow multiple
 * dialogs open at the same time, or theming to control overlay styles.
 *
 * There are two possible formats of help boxes.
 * 1. A help box positioned to the right of the item being highlighted. The help box is drawn with a triangle on the
 *   left-hand side of the help box dialog, and a dotted line is drawn from the left-hand side of the viewport to the
 *   triangle.
 * 2. A help box positioned below the item being highlighted. The help box is drawn with a triangle on the top side of
 *    dialog help box.
 *
 * State
 * -----
 * - x: Position of left hand side of help box.
 * - y: Position of top of help box.
 * - w: Width of help box.
 * - o: Orientation of help box (to determine where to place/point help box triangle), 'Right' or 'Below'.
 *
 * Actions
 * -------
 * - onClose: Called when "GOT IT" button clicked to hide help box.
 *
 * Children should be in the format:
 * <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>
 *
 * For example,
 * <HelpBox x={882} y={271} w={280} o={'Right'}><p>Each row contains data from a single sample.</p><p>Row order is determined by sorting the rows by their column values.</p></HelpBox>
 */
// Core dependencies, components
var React = require('react');

var classNames = require('classnames');

// Styles
var compStyles = require('./HelpBox.module.css'); // Setup for help box displayed to right of item being highlighted (with row marker). 27.5 used in width calculations
// of marker comes from 16px margin (standard MD width) plus 11.5px for triangle. This smaller width creates the
// necessary break between the marker and the right triangle.


var HelpBoxR = function HelpBoxR(props) {
  var w = props.w,
      children = props.children;
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(compStyles.HelpBox, compStyles.withMarker, compStyles.helpRight)
  }, /*#__PURE__*/React.createElement("div", {
    className: compStyles.rowMarker
  }), /*#__PURE__*/React.createElement("div", {
    style: {
      width: w
    },
    className: compStyles.helpBoxBounds
  }, children));
}; // Setup for help box displayed below item being highlighted.


var HelpBoxB = function HelpBoxB(props) {
  var w = props.w,
      children = props.children;
  return /*#__PURE__*/React.createElement("div", {
    style: {
      width: w
    },
    className: classNames(compStyles.HelpBox, compStyles.helpBoxBounds, compStyles.helpBelow)
  }, children);
};

var HelpBox = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(HelpBox, _React$Component);

  var _super = _createSuper(HelpBox);

  function HelpBox() {
    var _this;

    (0, _classCallCheck2["default"])(this, HelpBox);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onClose", function () {
      _this.props.onClose();
    });
    return _this;
  }

  (0, _createClass2["default"])(HelpBox, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          o = _this$props.o,
          boxProps = (0, _objectWithoutProperties2["default"])(_this$props, ["children", "o"]);
      var Box = o === 'Right' ? HelpBoxR : HelpBoxB;
      return /*#__PURE__*/React.createElement(Box, boxProps, /*#__PURE__*/React.createElement("div", {
        className: compStyles.helpBoxContent
      }, children), /*#__PURE__*/React.createElement("div", {
        className: compStyles.buttonContainer
      }, /*#__PURE__*/React.createElement(_button.Button, {
        accent: true,
        onClick: this.onClose
      }, "GOT IT")));
    }
  }]);
  return HelpBox;
}(React.Component);

module.exports = HelpBox;