"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _input = _interopRequireDefault(require("react-toolbox/lib/input"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var _ = require('../underscore_ext')["default"];

var _require = require('../react-utils'),
    rxEvents = _require.rxEvents;

var isValid = _.curry(function (min, max, value) {
  var v = value.trim(),
      i = parseInt(v);
  return v === '' || !(isNaN(i) || i < min || i > max);
});

function parseValue(value, dflt) {
  var v = value.trim();
  return v === '' ? dflt : parseInt(v);
} // initialValue is int or null.
// dflt, min, max are int.


var NumberForm = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(NumberForm, _React$Component);

  var _super = _createSuper(NumberForm);

  function NumberForm(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, NumberForm);
    _this = _super.call(this, props);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onBlur", function () {
      _this.setState({
        focused: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onFocus", function () {
      _this.setState({
        focused: true
      });
    });
    var initialValue = props.initialValue;
    _this.state = {
      value: initialValue == null ? '' : '' + initialValue,
      focused: false
    };
    return _this;
  }

  (0, _createClass2["default"])(NumberForm, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      var _this$props = this.props,
          dflt = _this$props.dflt,
          min = _this$props.min,
          max = _this$props.max;
      var events = rxEvents(this, 'change');
      this.change = events.change["do"](function (value) {
        return _this2.setState({
          value: value
        });
      }).debounceTime(200).filter(isValid(min, max)).subscribe(function (value) {
        return _this2.props.onChange(parseValue(value, dflt));
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.change.unsubscribe();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          min = _this$props2.min,
          max = _this$props2.max,
          other = _.omit(this.props, 'min', 'max', 'dflt', 'initialValue'),
          _this$state = this.state,
          value = _this$state.value,
          focused = _this$state.focused;

      return /*#__PURE__*/React.createElement("form", {
        className: "form-horizontal"
      }, /*#__PURE__*/React.createElement(_input["default"], (0, _extends2["default"])({}, other, {
        onBlur: this.onBlur,
        onFocus: this.onFocus,
        type: "text",
        value: '' + value,
        label: "Custom survival time cutoff",
        placeholder: focused ? "Enter a number between ".concat(min, " and ").concat(max) : undefined,
        onChange: this.on.change
      })));
    }
  }]);
  return NumberForm;
}(React.Component);

module.exports = NumberForm;