"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

var _XAutosuggest = _interopRequireDefault(require("./XAutosuggest"));

var _input = _interopRequireDefault(require("react-toolbox/lib/input"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

require('./GeneSuggest.css'); // XXX rename file


var renderInputComponent = function renderInputComponent(_ref) {
  var ref = _ref.ref,
      _onChange = _ref.onChange,
      error = _ref.error,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["ref", "onChange", "error"]);
  return /*#__PURE__*/React.createElement(_input["default"], (0, _extends2["default"])({
    spellCheck: false,
    innerRef: function innerRef(el) {
      return ref(el && el.inputNode);
    },
    onChange: function onChange(value, ev) {
      return _onChange(ev);
    },
    label: "Search Phenotype"
  }, props), /*#__PURE__*/React.createElement("i", {
    style: {
      color: 'red',
      opacity: error ? 1 : 0
    },
    className: "material-icons"
  }, "error"));
};

var filterFeatures = function filterFeatures(lcValue, features) {
  return features.filter(function (f) {
    return f.label.toLowerCase().indexOf(lcValue) !== -1;
  });
};

var PhenotypeSuggest = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(PhenotypeSuggest, _PureComponent);

  var _super = _createSuper(PhenotypeSuggest);

  function PhenotypeSuggest() {
    var _this;

    (0, _classCallCheck2["default"])(this, PhenotypeSuggest);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      suggestions: []
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSuggestionsFetchRequested", function (_ref2) {
      var value = _ref2.value;
      var lcValue = value.toLowerCase(),
          features = _this.props.features;

      _this.setState({
        suggestions: filterFeatures(lcValue, features)
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSuggestionsClearRequested", function () {
      _this.setState({
        suggestions: []
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onChange", function (ev, _ref3) {
      var newValue = _ref3.newValue;

      _this.props.onChange(newValue);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setInput", function (input) {
      var inputRef = _this.props.inputRef;
      _this.input = input;

      if (inputRef) {
        inputRef(_this.input);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "shouldRenderSuggestions", function () {
      return true;
    });
    return _this;
  }

  (0, _createClass2["default"])(PhenotypeSuggest, [{
    key: "render",
    value: function render() {
      var onChange = this.onChange,
          _this$props = this.props,
          onKeyDown = _this$props.onKeyDown,
          _this$props$value = _this$props.value,
          value = _this$props$value === void 0 ? '' : _this$props$value,
          error = _this$props.error,
          suggestions = this.state.suggestions;
      return /*#__PURE__*/React.createElement(_XAutosuggest["default"], {
        inputRef: this.setInput,
        suggestions: suggestions,
        onSuggestionSelected: this.props.onSuggestionSelected,
        onSuggestionsFetchRequested: this.onSuggestionsFetchRequested,
        onSuggestionsClearRequested: this.onSuggestionsClearRequested,
        getSuggestionValue: function getSuggestionValue(x) {
          return x.label;
        },
        shouldRenderSuggestions: this.shouldRenderSuggestions,
        renderSuggestion: function renderSuggestion(v) {
          return /*#__PURE__*/React.createElement("span", null, v.label);
        },
        renderInputComponent: renderInputComponent,
        inputProps: {
          value: value,
          error: error,
          onKeyDown: onKeyDown,
          onChange: onChange
        }
      });
    }
  }]);
  return PhenotypeSuggest;
}(_PureComponent2["default"]);

module.exports = PhenotypeSuggest;