"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

var _ZoomCarriage = _interopRequireDefault(require("./ZoomCarriage"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react'); // App dependencies


var _ = require('../underscore_ext')["default"];

var CanvasDrawing = require('../CanvasDrawing');

var ColCard = require('./ColCard');

var _require = require('../drawSamples'),
    drawSamples = _require.drawSamples;

// Styles
var compStyles = require('./SampleZoomIndicator.module.css');

function noZoom(samples, zoom) {
  return _.merge(zoom, {
    count: samples,
    index: 0
  });
}

var SampleZoomIndicator = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(SampleZoomIndicator, _PureComponent);

  var _super = _createSuper(SampleZoomIndicator);

  function SampleZoomIndicator() {
    (0, _classCallCheck2["default"])(this, SampleZoomIndicator);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(SampleZoomIndicator, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          data = _this$props.data,
          column = _this$props.column,
          addColumnAddHover = _this$props.addColumnAddHover,
          enableTransition = _this$props.enableTransition,
          samples = _this$props.samples,
          zoom = _this$props.zoom,
          heatmap = column.heatmap,
          codes = _.get(data, 'codes'),
          width = 10;

      return /*#__PURE__*/React.createElement("div", {
        className: compStyles.sampleZoomIndicator,
        style: {
          width: width
        }
      }, /*#__PURE__*/React.createElement(ColCard, {
        zoomCard: true
      }, /*#__PURE__*/React.createElement("div", {
        style: {
          height: 63
        }
      }), /*#__PURE__*/React.createElement("div", {
        style: {
          position: 'relative'
        }
      }, /*#__PURE__*/React.createElement(CanvasDrawing, {
        ref: "plot",
        draw: drawSamples,
        codes: codes,
        width: width,
        zoom: noZoom(samples.length, zoom),
        heatmapData: heatmap
      }), /*#__PURE__*/React.createElement(_ZoomCarriage["default"], {
        addColumnAddHover: addColumnAddHover,
        enableTransition: enableTransition,
        samplesCount: samples.length,
        width: width,
        zoom: zoom
      }))));
    }
  }]);
  return SampleZoomIndicator;
}(_PureComponent2["default"]);

;
var _default = SampleZoomIndicator;
exports["default"] = _default;