var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _assertThisInitialized = require("@babel/runtime/helpers/assertThisInitialized");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

var _defineProperty = require("@babel/runtime/helpers/defineProperty");

var _slicedToArray = require("@babel/runtime/helpers/slicedToArray");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var _require$default = require('../underscore_ext')["default"],
    times = _require$default.times,
    maxnull = _require$default.maxnull,
    minnull = _require$default.minnull;

var CanvasDrawing = require('../CanvasDrawing');

var React = require('react');

function drawScatterPlot(vg, opts) {
  var data = opts.data,
      width = opts.width,
      height = opts.zoom.height,
      inc = opts.inc,
      _data = _slicedToArray(data, 2),
      x = _data[0],
      y = _data[1];

  vg.box(0, 0, width, height, "white");

  if (inc % 2) {
    return;
  }

  var ctx = vg.context(),
      //		img = ctx.createImageData(width, height),
  img = ctx.getImageData(0, 0, width, height),
      xmax = maxnull(x),
      xmin = minnull(x),
      ymax = maxnull(y),
      ymin = minnull(y),
      scalex = function scalex(x) {
    return Math.round((x - xmin) * (width - 1) / (xmax - xmin));
  },
      scaley = function scaley(y) {
    return Math.round((y - ymin) * (height - 1) / (ymax - ymin));
  };

  var white = [255, 255, 255, 255],
      black = [0, 0, 0, 255],
      mark = [[white, black, white], [black, black, black], [white, black, white]];
  x.forEach(function (xi, i) {
    var yi = y[i],
        xc = scalex(xi),
        yc = scaley(yi),
        istart = xc <= 0 ? 1 : 0,
        iend = xc >= width - 1 ? 2 : 3,
        jstart = yc <= 0 ? 1 : 0,
        jend = yc >= height - 1 ? 2 : 3;

    for (var j = jstart; j < jend; ++j) {
      var pxRow = (yc - 1 + j) * width,
          buffStart = pxRow * 4;

      for (var _i = istart; _i < iend; _i++) {
        if (mark[j][_i] === black) {
          img.data[buffStart + 4 * (xc + _i - 1) + 0] = mark[j][_i][0];
          img.data[buffStart + 4 * (xc + _i - 1) + 1] = mark[j][_i][1];
          img.data[buffStart + 4 * (xc + _i - 1) + 2] = mark[j][_i][2];
          img.data[buffStart + 4 * (xc + _i - 1) + 3] = mark[j][_i][3];
        }
      }
    }
  });
  ctx.putImageData(img, 0, 0);
}

var count = 1000 * 1000;
var rndx = times(count, function () {
  return 1 + 10 * Math.sin(Math.random());
}),
    rndy = rndx.map(function (x) {
  return 1 + 10 * Math.sin(x + Math.random());
}); //	rndy = times(count, () => 1 + 10 * Math.sin(Math.random()));
//var data = [[...rndx, ...rndx.map(x => -x)], [...rndy, ...rndy.map(x => -x)]];

var data = [rndx, rndy];

var ScatterPlot = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(ScatterPlot, _React$Component);

  var _super = _createSuper(ScatterPlot);

  function ScatterPlot() {
    var _this;

    _classCallCheck(this, ScatterPlot);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      x: 0
    });

    return _this;
  }

  _createClass(ScatterPlot, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return /*#__PURE__*/React.createElement("div", {
        style: {
          margin: 40
        }
      }, /*#__PURE__*/React.createElement("button", {
        onClick: function onClick() {
          return _this2.setState({
            x: _this2.state.x + 1
          });
        }
      }, "inc"), /*#__PURE__*/React.createElement(CanvasDrawing, {
        inc: this.state.x,
        draw: drawScatterPlot,
        width: 800,
        zoom: {
          height: 400
        },
        data: data
      }));
    }
  }]);

  return ScatterPlot;
}(React.Component);

module.exports = ScatterPlot;