"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Stepper = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _app_bar = require("react-toolbox/lib/app_bar");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Stepper component, displayed initially when user is in "set up" mode. Component displays label and completed
 * indicator for the three core steps required for Xena setup.
 *
 * View-only component, that is, there are no outputs or callbacks invoked from this component.
 *
 * Takes a single input, mode, which is used to highlight the step that is currently in progress. mode
 * can be one of "COHORT", "FIRST_COLUMN", "SECOND_COLUMN" or "DONE".
 *
 * Steps to the left of the active step are considered complete. Steps to the right of the active step are considered
 * to do.
 *
 * Displayed initially when user is in "set up" mode.
 */
// Core dependencies, components
var classNames = require('classnames');

var React = require('react');

var _ = require('../underscore_ext')["default"]; // Styles


var compStyles = require('./Stepper.module.css');

var Stepper = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Stepper, _React$Component);

  var _super = _createSuper(Stepper);

  function Stepper() {
    (0, _classCallCheck2["default"])(this, Stepper);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(Stepper, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          steps = _this$props.steps,
          stateIndex = _this$props.stateIndex,
          mode = _this$props.mode,
          flat = _this$props.flat,
          wideStep = _this$props.wideStep;

      var getStepClassName = function getStepClassName(index) {
        var _classNames;

        return classNames((_classNames = {}, (0, _defineProperty2["default"])(_classNames, compStyles.step, true), (0, _defineProperty2["default"])(_classNames, compStyles.wideStep, wideStep), (0, _defineProperty2["default"])(_classNames, compStyles.completed, index < stateIndex[mode]), (0, _defineProperty2["default"])(_classNames, compStyles.active, index === stateIndex[mode]), _classNames));
      };

      return /*#__PURE__*/React.createElement(_app_bar.AppBar, {
        flat: flat
      }, /*#__PURE__*/React.createElement("ul", {
        className: compStyles.Stepper
      }, _.map(steps, function (step, index) {
        return /*#__PURE__*/React.createElement("li", {
          className: getStepClassName(index),
          key: index
        }, /*#__PURE__*/React.createElement("div", {
          className: compStyles.stepperCircle
        }, index + 1), /*#__PURE__*/React.createElement("div", {
          className: compStyles.stepperText
        }, step.label));
      })));
    }
  }]);
  return Stepper;
}(React.Component);

exports.Stepper = Stepper;