"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _toArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toArray"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var _ = require('../underscore_ext')["default"];

var meta = require('../meta');

var classNames = require('classnames'); // Styles


var compStyles = require('./Tooltip.module.css');

var element = {
  value: function value(i, v) {
    return /*#__PURE__*/React.createElement("span", {
      key: i
    }, v);
  },
  label: function label(i, l) {
    return /*#__PURE__*/React.createElement("span", {
      key: i
    }, l);
  },
  labelValue: function labelValue(i, l, v) {
    return /*#__PURE__*/React.createElement("span", {
      key: i
    }, l, ": ", v);
  },
  sig: function sig(i, lHover, lFrozen, val, frozen) {
    return /*#__PURE__*/React.createElement("span", {
      key: i
    }, frozen ? lFrozen : lHover, ": ", val);
  },
  url: function url(i, text, _url) {
    return /*#__PURE__*/React.createElement("span", {
      key: i
    }, /*#__PURE__*/React.createElement("a", {
      href: _url,
      target: "_blank"
    }, text));
  },
  urls: function urls(i, _urls, frozen) {
    var visibleCount = frozen ? _urls.length : 3,
        visible = _urls.slice(0, visibleCount),
        moreCount = _urls.length - visibleCount;

    return /*#__PURE__*/React.createElement("span", {
      key: i
    }, visible.map(function (_ref, j) {
      var _ref2 = (0, _toArray2["default"])(_ref),
          type = _ref2[0],
          args = _ref2.slice(1);

      return element[type].apply(element, [j].concat((0, _toConsumableArray2["default"])(args)));
    }), moreCount > 0 ? /*#__PURE__*/React.createElement("span", {
      className: compStyles.moreGene
    }, "+ ", moreCount, " more") : null);
  } //	popOver: (i, text, dataList) => (
  //		<span key={i}><a><PopOverVariants label={text} body={dataList}/></a></span>
  //	),

};

function overlay() {
  return /*#__PURE__*/React.createElement("div", {
    className: compStyles.overlay
  });
} //var PopOverVariants = React.createClass({
//  getInitialState() {
//    return { showModal: false };
//  },
//
//  close() {
//    this.setState({ showModal: false });
//  },
//
//  open() {
//    this.setState({ showModal: true });
//  },
//
//  render() {
//	var label = this.props.label,
//		dataList = this.props.body;
//
//	var rowsOut = _.map(dataList, (row, i) => (
//		<tr key={i}>
//			{row.map(([type, ...args], i) => element[type](i, ...args))}
//		</tr>
//	));
//
//
//    return (
//      <div>
//        <span
//          onClick={this.open}
//        >
//        {label}
//        </span>
//
//        <Modal show={this.state.showModal} onHide={this.close}>
//          <Modal.Header closeButton>
//            <Modal.Title>Variants</Modal.Title>
//          </Modal.Header>
//          <Modal.Body>
//			<div>
//				<table> {rowsOut} </table>
//			</div>
//          </Modal.Body>
//          <Modal.Footer>
//            <Button onClick={this.close}>Close</Button>
//          </Modal.Footer>
//        </Modal>
//      </div>
//    );
//  }
//});


var Tooltip = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(Tooltip, _PureComponent);

  var _super = _createSuper(Tooltip);

  function Tooltip() {
    (0, _classCallCheck2["default"])(this, Tooltip);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(Tooltip, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          data = _this$props.data,
          onClick = _this$props.onClick,
          onClose = _this$props.onClose,
          frozen = _this$props.frozen,
          rows = _.getIn(data, ['rows']),
          sampleID = _.getIn(data, ['sampleID']); // no tooltip, helper links


      if (!rows && !sampleID) {
        return /*#__PURE__*/React.createElement("div", {
          className: compStyles.Tooltip
        }, /*#__PURE__*/React.createElement("ul", {
          className: compStyles.content
        }, /*#__PURE__*/React.createElement("li", {
          className: compStyles.tooltipHint
        }, /*#__PURE__*/React.createElement("a", {
          href: "https://ucsc-xena.gitbook.io/project/",
          target: "_blank",
          rel: "noopener noreferrer"
        }, "User Guide")), /*#__PURE__*/React.createElement("li", {
          className: compStyles.tooltipHint
        }, /*#__PURE__*/React.createElement("a", {
          href: "https://ucsc-xena.gitbook.io/project/overview-of-features/visual-spreadsheet#zooming",
          target: "_blank",
          rel: "noopener noreferrer"
        }, "Zoom Help")), /*#__PURE__*/React.createElement("li", {
          className: compStyles.tooltipHint
        }, /*#__PURE__*/React.createElement("a", {
          href: "https://ucsc-xena.gitbook.io/project/how-do-i/freeze-and-un-freeze-tooltip",
          target: "_blank",
          rel: "noopener noreferrer"
        }, "Tooltip Help"))));
      }

      var rowsOut = _.map(rows, function (row, i) {
        return /*#__PURE__*/React.createElement("li", {
          key: i
        }, row.map(function (_ref3, k) {
          var _ref4 = (0, _toArray2["default"])(_ref3),
              type = _ref4[0],
              args = _ref4.slice(1);

          return type === 'urls' ? element[type](k, args, frozen) : type === 'sig' ? element[type].apply(element, [k].concat((0, _toConsumableArray2["default"])(args), [frozen])) : element[type].apply(element, [k].concat((0, _toConsumableArray2["default"])(args)));
        }));
      });

      var closeIcon = frozen ? /*#__PURE__*/React.createElement("i", {
        className: "material-icons",
        onClick: onClose
      }, "close") : null;
      var sample = sampleID ? /*#__PURE__*/React.createElement("span", null, sampleID) : null;
      return /*#__PURE__*/React.createElement("div", {
        onClick: onClick
      }, frozen ? overlay(onClick) : null, /*#__PURE__*/React.createElement("div", {
        key: sampleID,
        className: classNames(compStyles.Tooltip, (0, _defineProperty2["default"])({}, compStyles.frozen, frozen))
      }, /*#__PURE__*/React.createElement("ul", {
        className: compStyles.content
      }, sampleID ? "sample: " : null, sampleID ? /*#__PURE__*/React.createElement("li", {
        className: compStyles.title
      }, sample) : null, /*#__PURE__*/React.createElement("li", {
        className: compStyles.tooltipHint
      }, "".concat(meta.name, "-click to ").concat(frozen ? 'unfreeze' : 'freeze', " tooltip")), rowsOut), closeIcon));
    }
  }]);
  return Tooltip;
}(_PureComponent2["default"]);

module.exports = Tooltip;