"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

var _columns = require("../models/columns");

var _columnsParam = require("../columnsParam");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var React = require('react');

var _ = require('../underscore_ext')["default"];

var XCheckboxGroup = require('./XCheckboxGroup');

var XRadioGroup = require('./XRadioGroup');

var WizardCard = require('./WizardCard');

var GeneSuggest = require('./GeneSuggest');

var PhenotypeSuggest = require('./PhenotypeSuggest');

var _require = require('../react-utils'),
    rxEvents = _require.rxEvents;

var parsePos = require('../parsePos');

var _require2 = require('../models/dataType'),
    ignoredType = _require2.ignoredType;

var _require$default = require('../rx')["default"],
    Observable = _require$default.Observable,
    Scheduler = _require$default.Scheduler;

var _require3 = require('../defaultServers'),
    servers = _require3.servers;

var LOCAL_DOMAIN = servers.localHub;
var LOCAL_DOMAIN_LABEL = 'My Computer Hub';

var ignoredClinical = function ignoredClinical(type, subtype) {
  return type === 'clinicalMatrix' && (!subtype || subtype.match(/^phenotype/i));
}; // match ../controllers/wizard.js definition of phenotype data


var notIgnored = function notIgnored(_ref) {
  var type = _ref.type,
      dataSubType = _ref.dataSubType;
  return !_.contains(ignoredType, type) && !ignoredClinical(type, dataSubType);
};

var category = function category(_ref2) {
  var dsID = _ref2.dsID,
      dataSubType = _ref2.dataSubType;
  return dsID.includes(LOCAL_DOMAIN) ? LOCAL_DOMAIN_LABEL : dataSubType ? dataSubType : 'others';
};

function createLabels(datasets) {
  var sorted = _.sortBy(datasets, function (ds) {
    return ds.label.toLowerCase();
  }),
      labels = _.uniquify(_.pluck(sorted, 'label'));

  return _.mmap(sorted, labels, function (_ref3, label) {
    var dsID = _ref3.dsID;
    return {
      value: dsID,
      label: label
    };
  });
} // Create dataset list. Sorts by category and label, and enforces unique labels by
// appending a suffix.


function datasetList(datasets) {
  var groups = _.fmap(_.groupBy(_.values(datasets).filter(notIgnored), category), createLabels);

  return _.sortBy(_.keys(groups), function (g) {
    return g.toLowerCase();
  }).map(function (group) {
    return {
      label: group,
      options: groups[group]
    };
  });
}

var preferredList = function preferredList(preferred) {
  return [{
    options: preferred.map(function (_ref4) {
      var dsID = _ref4.dsID,
          label = _ref4.label;
      return {
        value: dsID,
        label: label
      };
    })
  }];
};

var RETURN = 13;

var returnPressed = function returnPressed(cb) {
  return cb ? function (ev) {
    return ev.keyCode === RETURN && cb();
  } : undefined;
};

function selectedOptions(selected, options) {
  var smap = new Set(selected);
  return options.map(function (group) {
    return _.updateIn(group, ['options'], function (options) {
      return options.map(function (opt) {
        return smap.has(opt.value) ? _.assoc(opt, 'checked', true) : opt;
      });
    });
  });
}

var assemblyColors = {
  hg18: '#527DA4',
  hg19: '#ff5722',
  hg38: '#77ADA7',
  "default": '#999999'
};

var assemblyColor = function assemblyColor(assembly) {
  return _.get(assemblyColors, assembly, assemblyColors["default"]);
};

var getAssembly = _.curry(function (datasets, dsID) {
  return _.getIn(datasets, [dsID, 'assembly'], _.getIn(datasets, [dsID, 'probemapMeta', 'assembly']));
});

var setBadge = function setBadge(datasets) {
  return function (ds) {
    return _.Let(function () {
      var assembly = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : getAssembly(datasets, ds.value);
      return assembly ? _objectSpread(_objectSpread({}, ds), {}, {
        badge: {
          label: assembly,
          style: {
            color: assemblyColor(assembly)
          }
        }
      }) : ds;
    });
  };
};

var setAssembly = function setAssembly(datasets, groups) {
  return groups.map(function (group) {
    return _.updateIn(group, ['options'], function (list) {
      return list.map(setBadge(datasets));
    });
  });
};

var defaultAssembly = 'hg38'; // For gene lookup, use the first assembly we find. If no datasets
// are selected, use a default so the user can get gene suggestions before
// selecting a dataset.

var firstAssembly = function firstAssembly(datasets, selected) {
  return selected.length === 0 ? defaultAssembly : _.findValue(selected, getAssembly(datasets));
};

var GenotypicForm = function GenotypicForm(props) {
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(GeneSuggest, {
    dataset: props.selected.length === 1 && _.indexOf(['genomicMatrix', 'clinicalMatrix'], props.datasets[props.selected[0]].type) !== -1 ? props.selected[0] : undefined,
    assembly: firstAssembly(props.datasets, props.selected),
    error: props.error,
    value: props.value,
    onKeyDown: returnPressed(props.onReturn),
    onChange: props.onFieldChange,
    type: "text"
  }), /*#__PURE__*/React.createElement(XCheckboxGroup, {
    label: "Dataset",
    additionalAction: !_.isEmpty(props.preferred) && (props.advanced ? 'Show Basic' : 'Show Advanced'),
    onAdditionalAction: props.onAdvancedClick,
    onChange: props.onChange,
    hideBadge: props.hideAssembly,
    options: selectedOptions(props.selected, setAssembly(props.datasets, props.advanced ? datasetList(props.datasets) : preferredList(props.preferred)))
  }));
};

var basicFeatureLabels = function basicFeatureLabels(features, basicFeatures) {
  return basicFeatures.map(function (i) {
    return {
      value: i.toString(),
      label: features[i].label
    };
  });
};

var allFeatureLabels = function allFeatureLabels(features) {
  return features.map(function (f, i) {
    return {
      value: i.toString(),
      label: f.label
    };
  });
};

var PhenotypicForm = function PhenotypicForm(props) {
  var options = (props.advanced ? allFeatureLabels : basicFeatureLabels)(props.features, _.union(props.basicFeatures, props.selected));
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(XCheckboxGroup, {
    label: "Phenotype",
    additionalAction: !_.isEmpty(props.basicFeatures) && (props.advanced ? 'Show Basic' : 'Show All'),
    onAdditionalAction: props.onAdvancedClick,
    onChange: props.onChange,
    options: selectedOptions(props.selected, [{
      options: options
    }])
  }), props.advanced ? null : /*#__PURE__*/React.createElement(PhenotypeSuggest, {
    error: props.error,
    value: props.value,
    features: props.features,
    onSuggestionSelected: function onSuggestionSelected(ev, _ref5) {
      var suggestion = _ref5.suggestion;
      return props.onAddFeature(suggestion);
    },
    onKeyDown: returnPressed(props.onAddFeature),
    onChange: props.onFieldChange,
    type: "text"
  }));
};

var AnalyticForm = function AnalyticForm(props) {
  var options = props.analytic.map(function (_ref6, i) {
    var label = _ref6.label;
    return {
      value: i.toString(),
      label: label
    };
  });
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(XCheckboxGroup, {
    label: "Variable",
    onChange: props.onChange,
    options: selectedOptions(props.selected, [{
      options: options
    }])
  }));
};

var getModeFields = {
  Genotypic: GenotypicForm,
  Phenotypic: PhenotypicForm,
  Analytic: AnalyticForm
};
var applyInitialState = {
  Genotypic: function Genotypic(text, fields, dataset, datasets, features, preferred, defaults) {
    var mode = 'Genotypic',
        isPreferred = _.contains(_.pluck(preferred, 'dsID'), dataset),
        // old bookmarks may not have a 'text' property
    value = text || fields.join(' '),
        selected = [dataset];

    return _.assocIn(defaults, ['mode'], mode, ['advanced', mode], !isPreferred, ['value', mode], value, ['selected', mode, !isPreferred], selected);
  },
  Phenotypic: function Phenotypic(text, fields, dataset, datasets, features, preferred, defaults) {
    var mode = 'Phenotypic',
        i = _.findIndex(features, _.matcher({
      dsID: dataset,
      name: fields[0]
    })).toString(),
        selected = [i];

    return i === '-1' ? _.assocIn(defaults, ['unavailable'], true) : _.assocIn(defaults, ['mode'], mode, ['basicFeatures'], defaults.basicFeatures, ['selected', mode, false], selected, ['selected', mode, true], selected);
  },
  'undefined': function undefined(text, fields, dataset, datasets, features, preferred, defaults) {
    return _.assocIn(defaults, ['unavailable'], true);
  }
};

var datasetMode = function datasetMode(datasets, dataset) {
  return datasets[dataset] ? notIgnored(datasets[dataset]) ? 'Genotypic' : 'Phenotypic' : undefined;
};

var pluralDataset = function pluralDataset(i) {
  return i === 1 ? 'A dataset' : 'Some datasets';
};

var pluralDo = function pluralDo(i) {
  return i === 1 ? 'does' : 'do';
}; //var pluralHas = i => i === 1 ? 'has' : 'have';


function getWarningText(matches, datasets, selected, topWarnings, value) {
  var pos = parsePos(value),
      warnings = _.groupBy(matches, function (m) {
    return m.warning;
  }),
      unsupported = _.getIn(warnings, ['position-unsupported', 'length'], 0),
      uwarn = unsupported ? ["".concat(pluralDataset(unsupported), " in your selection ").concat(pluralDo(unsupported), " not support a chromosome view.")] : [],
      probes = _.getIn(warnings, ['too-many-probes', 'length'], 0),
      max = _.min(warnings['too-many-probes'], function (m) {
    return m.end;
  }),
      pwarn = probes && pos ? ["There are too many data points to display. Please try a smaller region like ".concat(pos.chrom, ":").concat(max.start, "-").concat(max.end, ".")] : [];

  return [].concat((0, _toConsumableArray2["default"])(topWarnings), uwarn, pwarn);
}

var featureIndexes = function featureIndexes(features, list) {
  return list.map(function (f) {
    return _.findIndex(features, _.matcher(f)).toString();
  }).filter(function (x) {
    return x !== "-1";
  });
};

var toDsID = function toDsID(_ref7) {
  var host = _ref7.host,
      name = _ref7.name;
  return JSON.stringify({
    host: host,
    name: name
  });
};

var doMatch = function doMatch(datasets, dsID, field) {
  var opts = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];
  return (0, _columns.matchDatasetFields)(datasets, dsID, field).map(function (r) {
    return _objectSpread(_objectSpread({}, r), {}, {
      dataset: datasets[dsID],
      opts: opts
    });
  });
};

var assemblyError = 'Your dataset selections include two different assemblies. For chromosome coordinates, the assembly must be unique.';
var fieldError = 'None of these fields are available on all selected datasets.';
var sigError = 'Unable to parse signature.';

function intersectFields(matches) {
  if (matches.length === 0) {
    return matches;
  }

  var intersection = _.filterIndices(matches[0].fields, function (f, i) {
    return _.every(matches, function (m) {
      return m.fields[i];
    });
  });

  return _.map(matches, function (m) {
    return _.updateIn(m, ['fields'], function (fields) {
      return intersection.map(function (i) {
        return fields[i];
      });
    });
  });
}

var fieldAssembly = function fieldAssembly(datasets) {
  return function (match) {
    return getAssembly(datasets, match.dataset.dsID);
  };
};

var genomicMatches = function genomicMatches(datasets, text) {
  return function (matchesIn) {
    var matches = intersectFields(matchesIn),
        _ref8 = parsePos(text) || {},
        hasCoord = _ref8.hasCoord,
        assemblies = _.uniq(_.map(matches, fieldAssembly(datasets)).filter(function (x) {
      return x;
    })),
        assembly = hasCoord && assemblies.length > 1 ? [assemblyError] : [],
        nomatch = matches.length && matches[0].fields.length === 0 ? [fieldError] : [],
        sig = text.trim()[0] === '=' && !_.getIn(matches, [0, 'sig']),
        warnings = sig ? [sigError] : [].concat(assembly, nomatch);

    return {
      matches: matches,
      hasCoord: hasCoord,
      warnings: warnings,
      valid: !_.any(matches, function (m) {
        return m.warning;
      }) && _.isEmpty(warnings)
    };
  };
}; // This is still kinda wonky, dispatching on mode before dispatching on type.


var matchFields = {
  Phenotypic: function Phenotypic(_ref9, selected) {
    var datasets = _ref9.datasets,
        features = _ref9.features;
    return Observable.zipArray.apply(Observable, (0, _toConsumableArray2["default"])(selected.map(function (i) {
      return doMatch(datasets, features[i].dsID, features[i].name);
    }))).map(function (matches) {
      return {
        matches: matches,
        valid: selected.length > 0
      };
    });
  },
  Genotypic: function Genotypic(_ref10, selected, text) {
    var datasets = _ref10.datasets;
    return text.trim().length === 0 || !selected.length ? Observable.of({
      valid: false
    }, Scheduler.asap) : Observable.zipArray.apply(Observable, (0, _toConsumableArray2["default"])(selected.map(function (dsID) {
      return doMatch(datasets, dsID, text);
    }))).map(genomicMatches(datasets, text));
  },
  Analytic: function Analytic(_ref11, selected) {
    var datasets = _ref11.datasets,
        analytic = _ref11.analytic;
    return Observable.zipArray.apply(Observable, (0, _toConsumableArray2["default"])(selected.map(function (i) {
      return doMatch(datasets, toDsID(analytic[i]), analytic[i].fields, (0, _columnsParam.getOpts)(analytic[i]));
    }))).map(function (matches) {
      return {
        matches: matches,
        valid: selected.length > 0
      };
    });
  }
};

var VariableSelect = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(VariableSelect, _PureComponent);

  var _super = _createSuper(VariableSelect);

  function VariableSelect(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, VariableSelect);
    _this = _super.call(this, props);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onChange", function (selectValue, isOn) {
      _this.on.select({
        selectValue: selectValue,
        isOn: isOn
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onDone", function () {
      var _this$props = _this.props,
          pos = _this$props.pos,
          onSelect = _this$props.onSelect,
          matches = _this.state.matches;
      onSelect(pos, matches);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onDoneInvalid", function () {
      var mode = _this.state.mode,
          value = _this.state.value[mode]; // Highlight the input field, since the user has forgotten it.
      // Might want to also scroll it into position, and also
      // scroll it into position if there's another error, like
      // assembly mismatch.

      if (mode === 'Genotypic' && value.trim().length === 0) {
        _this.setState({
          error: true
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onAddFeature", function (featureIn) {
      var features = _this.props.features,
          _this$state = _this.state,
          basicFeatures = _this$state.basicFeatures,
          value = _this$state.value,
          mode = _this$state.mode,
          i = (featureIn ? features.indexOf(featureIn) : _.findIndex(features, _.matcher({
        label: value[mode]
      }))).toString();

      if (i !== "-1") {
        _this.setState({
          basicFeatures: _.uniq([].concat((0, _toConsumableArray2["default"])(basicFeatures), [i]))
        });

        _this.on.select({
          selectValue: i,
          isOn: true
        });
      }

      _this.on.field("");
    });

    var text = props.text,
        fields = props.fields,
        dataset = props.dataset,
        datasets = props.datasets,
        _features = props.features,
        preferred = props.preferred,
        _basicFeatures = props.basicFeatures,
        _props$mode = props.mode,
        _mode = _props$mode === void 0 ? 'Genotypic' : _props$mode;

    var defaults = {
      mode: _mode,
      advanced: {
        Genotypic: _.isEmpty(preferred),
        Phenotypic: _.isEmpty(_basicFeatures),
        Analytic: false
      },
      basicFeatures: featureIndexes(_features, _basicFeatures),
      selected: {
        Genotypic: {
          "true": [],
          // advanced
          "false": [] // !advanced

        },
        Phenotypic: {
          "true": [],
          // advanced
          "false": [] // !advanced

        },
        Analytic: {
          "false": []
        }
      },
      value: {
        Genotypic: '',
        Phenotypic: '',
        Analytic: ''
      },
      valid: false,
      hasCoord: false,
      warnings: []
    };
    _this.state = fields && dataset ? applyInitialState[datasetMode(datasets, dataset)](text, fields, dataset, datasets, _features, preferred, defaults) : defaults;
    return _this;
  }

  (0, _createClass2["default"])(VariableSelect, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(_ref12) {
      var features = _ref12.features,
          basicFeatures = _ref12.basicFeatures;
      this.setState({
        basicFeatures: featureIndexes(features, basicFeatures)
      });
    } // Sharing these streams, to avoid recompute, is complicated by the
    // startWith() operator, which does not subscribe to base observable until
    // the queued value is emitted. The result of this is that the
    // withLatestFrom() operators do not subscribe to their upstream sources,
    // and miss the startWith() of those. The workaround here is to use replay
    // subjects. This is all much too complex.

  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      var events = rxEvents(this, 'mode', 'advanced', 'field', 'select');
      var mode = events.mode.startWith(this.state.mode).publishReplay(1).refCount(),
          advanced = events.advanced.withLatestFrom(mode, function (advanced, mode) {
        return mode;
      }).scan(function (advanced, mode) {
        return _.updateIn(advanced, [mode], function (a) {
          return !a;
        });
      }, this.state.advanced).startWith(this.state.advanced).publishReplay(1).refCount(),
          selected = events.select.withLatestFrom(advanced, mode, function (dataset, advanced, mode) {
        return [dataset, mode, advanced[mode]];
      }).scan(function (selected, _ref13) {
        var _ref14 = (0, _slicedToArray2["default"])(_ref13, 3),
            _ref14$ = _ref14[0],
            selectValue = _ref14$.selectValue,
            isOn = _ref14$.isOn,
            mode = _ref14[1],
            advanced = _ref14[2];

        return _.updateIn(selected, [mode, advanced], function (selected) {
          return _.uniq((isOn ? _.conj : _.without)(selected, selectValue));
        });
      }, this.state.selected).startWith(this.state.selected).publishReplay(1).refCount(),
          value = events.field.withLatestFrom(mode, function (field, mode) {
        return [field, mode];
      }).scan(function (value, _ref15) {
        var _ref16 = (0, _slicedToArray2["default"])(_ref15, 2),
            field = _ref16[0],
            mode = _ref16[1];

        return _.assoc(value, mode, field);
      }, this.state.value).startWith(this.state.value).publishReplay(1).refCount();
      this.modeSub = mode.subscribe(function (mode) {
        return _this2.setState({
          mode: mode,
          error: false
        });
      });
      this.advancedSub = advanced.subscribe(function (advanced) {
        return _this2.setState({
          advanced: advanced
        });
      });
      this.selectedSub = selected.subscribe(function (selected) {
        return _this2.setState({
          selected: selected
        });
      });
      this.valueSub = value.subscribe(function (value) {
        return _this2.setState({
          value: value,
          error: false
        });
      }); // valid should only be set true after assessing disposition, but should be set false immediately on
      // user input.

      this.validSub = mode.combineLatest(advanced, selected, value, function (mode, advanced, selected, value) {
        return [mode, selected[mode][advanced[mode]], value[mode]];
      })["do"](function () {
        return _this2.setState({
          valid: false,
          loading: true
        });
      }) // XXX side-effects
      .debounceTime(200).switchMap(function (_ref17) {
        var _ref18 = (0, _slicedToArray2["default"])(_ref17, 3),
            mode = _ref18[0],
            selected = _ref18[1],
            value = _ref18[2];

        return matchFields[mode](_this2.props, selected, value);
      }).subscribe(function (valid) {
        return _this2.setState(_objectSpread({
          loading: false,
          warnings: [],
          matches: []
        }, valid));
      }, function (err) {
        console.log(err);

        _this2.setState({
          valid: false,
          loading: false
        });
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.modeSub.unsubscribe();
      this.advancedSub.unsubscribe();
      this.selectedSub.unsubscribe();
      this.valueSub.unsubscribe();
      this.validSub.unsubscribe();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state2 = this.state,
          mode = _this$state2.mode,
          matches = _this$state2.matches,
          hasCoord = _this$state2.hasCoord,
          advanced = _this$state2.advanced,
          valid = _this$state2.valid,
          warnings = _this$state2.warnings,
          loading = _this$state2.loading,
          error = _this$state2.error,
          unavailable = _this$state2.unavailable,
          basicFeatures = _this$state2.basicFeatures,
          value = this.state.value[mode],
          selected = this.state.selected[mode][advanced[mode]],
          _this$props2 = this.props,
          colId = _this$props2.colId,
          controls = _this$props2.controls,
          datasets = _this$props2.datasets,
          features = _this$props2.features,
          preferred = _this$props2.preferred,
          analytic = _this$props2.analytic,
          title = _this$props2.title,
          helpText = _this$props2.helpText,
          width = _this$props2.width,
          formError = getWarningText(matches, datasets, selected, warnings, value).join(' ') || error,
          subtitle = unavailable ? 'This variable is currently unavailable. You may choose a different variable, or cancel to continue viewing the cached data.' : undefined,
          contentSpecificHelp = _.getIn(helpText, [mode]),
          ModeForm = getModeFields[mode],
          wizardProps = {
        colId: colId,
        controls: controls,
        subtitle: subtitle,
        title: title,
        contentSpecificHelp: contentSpecificHelp,
        onDone: this.onDone,
        onDoneInvalid: this.onDoneInvalid,
        valid: valid,
        loading: loading,
        width: width
      },
          dataTypeProps = {
        label: 'Select Data Type',
        value: mode,
        onChange: this.on.mode,
        options: [{
          label: 'Genomic',
          value: 'Genotypic'
        }, {
          label: 'Phenotypic',
          value: 'Phenotypic'
        }].concat((0, _toConsumableArray2["default"])(!_.isEmpty(analytic) ? [{
          label: 'Analytic',
          value: 'Analytic'
        }] : []))
      };

      return /*#__PURE__*/React.createElement(WizardCard, wizardProps, /*#__PURE__*/React.createElement(XRadioGroup, dataTypeProps), /*#__PURE__*/React.createElement(ModeForm, {
        error: formError,
        onChange: this.onChange,
        onReturn: valid ? this.onDone : undefined,
        onFieldChange: this.on.field,
        hideAssembly: !hasCoord,
        datasets: datasets,
        selected: selected,
        value: value,
        features: features,
        preferred: preferred,
        analytic: analytic,
        basicFeatures: basicFeatures,
        onAddFeature: this.onAddFeature,
        onAdvancedClick: this.on.advanced,
        advanced: advanced[mode]
      }));
    }
  }]);
  return VariableSelect;
}(_PureComponent2["default"]); // Render a load warning in a wrapper component so we don't
// try to initialize state when we're not holding the cohort
// data. There might be a better state model that avoids this.
//
// We are passed data incrementally as it arrives from the servers,
// so use a timeout to decide if we should keep waiting.


var LoadingNotice = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(LoadingNotice, _React$Component);

  var _super2 = _createSuper(LoadingNotice);

  function LoadingNotice() {
    var _this3;

    (0, _classCallCheck2["default"])(this, LoadingNotice);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this3 = _super2.call.apply(_super2, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "state", {
      wait: true
    });
    return _this3;
  }

  (0, _createClass2["default"])(LoadingNotice, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this4 = this;

      this.timeout = setTimeout(function () {
        return _this4.setState({
          wait: false
        });
      }, 3000);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.timeout);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          analytic = _this$props3.analytic,
          preferred = _this$props3.preferred,
          datasets = _this$props3.datasets,
          features = _this$props3.features,
          basicFeatures = _this$props3.basicFeatures,
          wait = this.state.wait;

      if (wait && (!preferred || _.isEmpty(datasets) || _.isEmpty(features) || !basicFeatures || !analytic)) {
        var _this$props4 = this.props,
            colId = _this$props4.colId,
            controls = _this$props4.controls,
            title = _this$props4.title,
            width = _this$props4.width,
            wizardProps = {
          colId: colId,
          controls: controls,
          loading: true,
          loadingCohort: true,
          title: title,
          width: width
        };
        return /*#__PURE__*/React.createElement(WizardCard, wizardProps);
      }

      return /*#__PURE__*/React.createElement(VariableSelect, this.props);
    }
  }]);
  return LoadingNotice;
}(React.Component);

module.exports = LoadingNotice;