"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _dialog = require("react-toolbox/lib/dialog");

var _dropdown = require("react-toolbox/lib/dropdown");

var _button = require("react-toolbox/lib/button");

var _input = require("react-toolbox/lib/input");

var _VizSettingsModule = _interopRequireDefault(require("./VizSettings.module.css"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/*eslint camelcase: 0, no-use-before-define: 0 */
// Config UI for custom viz settings for heatmaps.
//
// State schema. This is the goal, not the current implementation. If
// the user has never modified the default settings, vizSettings is undefined.
//
// When the user modifies colNormalization or color parameters, they are
// written into vizSettings. vizSettings can have normalization or color
// parameters, or both. All color parameters are present if any are set.
// The minStart/maxStart are optional, so may be null if other color parameters
// are set.
//
// vizSettings = undefined |
//               {
//                 colNormalization: 'subset' | 'none'
//               } |
//               {
//                 min: float,
//                 minStart: float | null,
//                 maxStart: float | null,
//                 max: float
//               } |
//               {
//                 colNormalization: 'subset' | 'none'
//                 min: float,
//                 minStart: float | null,
//                 maxStart: float | null,
//                 max: float
//               }
// Refactoring notes:
// The default column normalization is fetched from the server. Instead it should come from
// the state, or from a data cache, because we've fetched that already.
var _ = require('../underscore_ext')["default"];

var React = require('react');

var ReactDOM = require('react-dom');

var _require = require("react-material-responsive-grid"),
    Row = _require.Row,
    Col = _require.Col;

var _require2 = require("../colorScales"),
    categoryMore = _require2.categoryMore;

function vizSettingsWidget(node, onVizSettings, vizState, id, hide, defaultNormalization, defaultColorClass, valueType, fieldType, data, units, column) {
  var DatasetSetting = /*#__PURE__*/function (_React$Component) {
    (0, _inherits2["default"])(DatasetSetting, _React$Component);

    var _super = _createSuper(DatasetSetting);

    function DatasetSetting() {
      (0, _classCallCheck2["default"])(this, DatasetSetting);
      return _super.apply(this, arguments);
    }

    (0, _createClass2["default"])(DatasetSetting, [{
      key: "render",
      value: function render() {
        var settingsContent = valueType === "float" || valueType === 'segmented' ? /*#__PURE__*/React.createElement(AllFloat, null) : valueType === "mutation" && fieldType === 'SV' ? /*#__PURE__*/React.createElement(Sv, null) : valueType === "coded" ? /*#__PURE__*/React.createElement(Coded, null) : /*#__PURE__*/React.createElement(NoSettings, null);
        return /*#__PURE__*/React.createElement("div", null, settingsContent, /*#__PURE__*/React.createElement(FinishButtonBar, null));
      }
    }]);
    return DatasetSetting;
  }(React.Component);

  var AllFloat = /*#__PURE__*/function (_React$Component2) {
    (0, _inherits2["default"])(AllFloat, _React$Component2);

    var _super2 = _createSuper(AllFloat);

    function AllFloat() {
      (0, _classCallCheck2["default"])(this, AllFloat);
      return _super2.apply(this, arguments);
    }

    (0, _createClass2["default"])(AllFloat, [{
      key: "render",
      value: function render() {
        return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(ColorDropDown, null)), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(ScaleChoice, null)), /*#__PURE__*/React.createElement("br", null));
      }
    }]);
    return AllFloat;
  }(React.Component);

  var Sv = /*#__PURE__*/function (_React$Component3) {
    (0, _inherits2["default"])(Sv, _React$Component3);

    var _super3 = _createSuper(Sv);

    function Sv() {
      (0, _classCallCheck2["default"])(this, Sv);
      return _super3.apply(this, arguments);
    }

    (0, _createClass2["default"])(Sv, [{
      key: "render",
      value: function render() {
        return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(SvColorDropDown, null)), /*#__PURE__*/React.createElement("br", null));
      }
    }]);
    return Sv;
  }(React.Component);

  var Coded = /*#__PURE__*/function (_React$Component4) {
    (0, _inherits2["default"])(Coded, _React$Component4);

    var _super4 = _createSuper(Coded);

    function Coded() {
      (0, _classCallCheck2["default"])(this, Coded);
      return _super4.apply(this, arguments);
    }

    (0, _createClass2["default"])(Coded, [{
      key: "render",
      value: function render() {
        return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(CategoricalTable, null)), /*#__PURE__*/React.createElement("br", null));
      }
    }]);
    return Coded;
  }(React.Component);

  var NoSettings = /*#__PURE__*/function (_React$Component5) {
    (0, _inherits2["default"])(NoSettings, _React$Component5);

    var _super5 = _createSuper(NoSettings);

    function NoSettings() {
      (0, _classCallCheck2["default"])(this, NoSettings);
      return _super5.apply(this, arguments);
    }

    (0, _createClass2["default"])(NoSettings, [{
      key: "render",
      value: function render() {
        return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", null, "No setting adjustments available."), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("br", null));
      }
    }]);
    return NoSettings;
  }(React.Component); // discard user changes & close.


  var FinishButtonBar = /*#__PURE__*/function (_React$Component6) {
    (0, _inherits2["default"])(FinishButtonBar, _React$Component6);

    var _super6 = _createSuper(FinishButtonBar);

    function FinishButtonBar() {
      var _this;

      (0, _classCallCheck2["default"])(this, FinishButtonBar);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _super6.call.apply(_super6, [this].concat(args));
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleCancelClick", function () {
        hide();
        onVizSettings(id, oldSettings);
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDoneClick", function () {
        hide();
      });
      return _this;
    }

    (0, _createClass2["default"])(FinishButtonBar, [{
      key: "render",
      value: function render() {
        return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(_button.Button, {
          onMouseUp: this.handleCancelClick,
          className: _VizSettingsModule["default"].cancelButton
        }, "Cancel"), /*#__PURE__*/React.createElement(_button.Button, {
          onMouseUp: this.handleDoneClick,
          className: _VizSettingsModule["default"].confirmButton
        }, "Done"));
      }
    }]);
    return FinishButtonBar;
  }(React.Component);

  function getInputSettingsFloat(settings) {
    return _.fmap(settings, parseFloat);
  }

  var validateSettings = {
    "float": function float(s) {
      var vals = _.fmap(s, parseFloat),
          fmtErrors = _.fmap(vals, function (v, k) {
        return isNaN(v) && s[k] ? "Invalid number." : "";
      }),
          missing = _.fmap(s, _.constant(null)),
          rangeErrors;
      /*jshint -W018 */

      /* allow xor idiom */


      if (!s.minstart !== !s.maxstart) {
        // xor
        missing.minstart = 'Both 0% values must be given to take effect.';
      } // XXX check for missin min & max


      if (s.minstart && s.maxstart && !fmtErrors.minstart && !fmtErrors.maxstart) {
        // wrong if missing maxStart: we compare against the wrong thing.
        rangeErrors = {
          max: null,
          maxstart: vals.maxstart <= vals.max ? null : 'Should be lower than max',
          minstart: vals.minstart <= vals.maxstart ? null : 'Should be lower than maxStart',
          min: vals.min <= vals.minstart ? null : 'Should be lower than minStart'
        };
      } else {
        rangeErrors = {
          max: null,
          min: vals.min <= vals.max ? null : 'Should be lower than max'
        };
      }

      return _.fmap(fmtErrors, function (err, k) {
        return _.filter([err, rangeErrors[k], missing[k]], _.identity).join(' ');
      });
    },
    segmented: function segmented(s) {
      var vals = _.fmap(s, parseFloat),
          fmtErrors = _.fmap(vals, function (v) {
        return isNaN(v) ? "Invalid number." : "";
      }),
          rangeErrors = {
        thresh: vals.thresh >= 0 ? null : 'Should be positive',
        max: vals.max >= 0 ? null : 'Should be positive'
      };

      return _.fmap(fmtErrors, function (err, k) {
        return _.filter([err, rangeErrors[k]], _.identity).join(' ');
      });
    }
  };

  function settingsValid(errors) {
    return _.every(errors, function (s) {
      return !s;
    });
  }

  var scaleAnnotations = {
    "float": {
      "max": "max: high color 100% saturation",
      "maxstart": "maxStart: high color 0% saturation",
      "minstart": "minStart: low color 0% saturation",
      "min": "min: low color 100% saturation"
    },
    segmented: {
      "origin": "Origin: value for copy number normal (typically: 0 or 2)",
      "thresh": "Threshold: absolute value from origin to start showing color",
      "max": "Saturation: absolute value to draw full color"
    }
  };
  var scaleDefaults = {
    "float": {
      max: 1,
      maxstart: null,
      minstart: null,
      min: -1
    },
    segmented: {
      origin: 0,
      thresh: 0,
      max: 1
    }
  };

  var ScaleChoice = /*#__PURE__*/function (_React$Component7) {
    (0, _inherits2["default"])(ScaleChoice, _React$Component7);

    var _super7 = _createSuper(ScaleChoice);

    function ScaleChoice(props) {
      var _this2;

      (0, _classCallCheck2["default"])(this, ScaleChoice);
      _this2 = _super7.call(this, props); //check if there is custom value

      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "autoClick", function () {
        _this2.setState({
          mode: "Auto"
        });

        _this2.setState({
          errors: {}
        });

        onVizSettings(id, _.omit(currentSettings.state, colorParams[valueType]));
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "customClick", function () {
        _this2.setState({
          mode: "Custom"
        });

        onVizSettings(id, _.merge(currentSettings.state, getInputSettingsFloat(_this2.state.settings)));
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "handleChange", function (name, value) {
        var settings = _this2.state.settings,
            newSettings = _.assoc(settings, name, value),
            errors = validateSettings[valueType](newSettings);

        _this2.setState((0, _defineProperty2["default"])({
          settings: newSettings,
          errors: errors
        }, name, value));

        if (settingsValid(errors)) {
          onVizSettings(id, _.merge(currentSettings.state, getInputSettingsFloat(newSettings)));
        }
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "buildCustomColorScale", function () {
        var node = colorParams[valueType].map(function (param) {
          var label = scaleAnnotations[valueType][param],
              error = _this2.state.errors[param];
          return /*#__PURE__*/React.createElement(Row, {
            key: param
          }, /*#__PURE__*/React.createElement(Col, {
            xs4: 4,
            xs8: 8,
            sm: 6,
            smOffset: 6
          }, /*#__PURE__*/React.createElement("label", {
            className: _VizSettingsModule["default"].errorLabel
          }, error)), /*#__PURE__*/React.createElement(Col, {
            xs4: 4,
            xs8: 4,
            sm: 6
          }, /*#__PURE__*/React.createElement("div", {
            className: _VizSettingsModule["default"].inputLabel
          }, label)), /*#__PURE__*/React.createElement(Col, {
            xs4: 4,
            xs8: 4,
            sm: 6
          }, /*#__PURE__*/React.createElement(_input.Input, {
            type: "text",
            value: _this2.state[param],
            className: _VizSettingsModule["default"].rangeInput,
            hint: _.contains(['minThresh', 'maxThresh'], param) ? 'Auto' : '',
            onChange: _this2.handleChange.bind((0, _assertThisInitialized2["default"])(_this2), param)
          })));
        });
        return node;
      });
      var custom = colorParams[valueType].some(function (param) {
        if (getVizSettings(param)) {
          return true;
        }
      }),
          dataMin,
          dataMax;

      if (valueType === "float") {
        dataMin = _.minnull(_.map(data.req.values, function (values) {
          return _.minnull(values);
        }));
        dataMax = _.maxnull(_.map(data.req.values, function (values) {
          return _.maxnull(values);
        }));
        scaleDefaults[valueType].min = dataMin;
        scaleDefaults[valueType].max = dataMax;
      } else if (valueType === 'segmented') {
        dataMin = _.minnull(_.map(data.req.rows, function (row) {
          return row.value;
        }));
        dataMax = _.maxnull(_.map(data.req.rows, function (row) {
          return row.value;
        }));

        if (dataMin >= 0) {
          scaleDefaults[valueType].origin = 2;
          scaleDefaults[valueType].max = 6;
        } else {
          scaleDefaults[valueType].origin = 0;
          scaleDefaults[valueType].max = dataMax;
        }
      }

      _this2.state = {
        mode: custom ? "Custom" : "Auto",
        settings: custom ? _.pick(oldSettings, colorParams[valueType]) : scaleDefaults[valueType],
        errors: {}
      };
      return _this2;
    }

    (0, _createClass2["default"])(ScaleChoice, [{
      key: "componentWillMount",
      value: function componentWillMount() {
        var _this3 = this;

        var initStates = colorParams[valueType].map(function (colorParam) {
          return _.valToStr(_this3.state.settings[colorParam]);
        });
        this.setState(_.object(colorParams[valueType], initStates));
      }
    }, {
      key: "render",
      value: function render() {
        var _this4 = this;

        var mode = this.state.mode,
            autoMode = this.state.mode === "Auto",
            modes = ["Auto", "Custom"],
            funcMapping = {
          "Auto": this.autoClick,
          "Custom": this.customClick
        },
            buttons = modes.map(function (mode) {
          var active = _this4.state.mode === mode,
              style = _VizSettingsModule["default"][active ? 'activeModeButton' : 'inactiveModeButton'],
              func = funcMapping[mode];
          return /*#__PURE__*/React.createElement(_button.Button, {
            key: mode,
            onMouseUp: func,
            className: style
          }, mode);
        }),
            enterInput = autoMode ? null : this.buildCustomColorScale(),
            autocolorTransformation = valueType === "float" && fieldType !== 'clinical' ? /*#__PURE__*/React.createElement(NormalizationDropDown, null) : valueType === 'segmented' ? /*#__PURE__*/React.createElement(SegCNVnormalizationDropDown, null) : null,
            notransformation = /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
          xs4: 4,
          xs8: 3,
          sm: 3
        }, "Color transformation"), /*#__PURE__*/React.createElement(Col, {
          xs4: 4,
          xs8: 5,
          sm: 9
        }, "no transformation")),
            colorTransformation = autoMode ? autocolorTransformation : notransformation;
        return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
          xs4: 4,
          xs8: 3,
          sm: 3
        }, /*#__PURE__*/React.createElement("div", {
          className: _VizSettingsModule["default"].buttonGroupLabel
        }, "Mode")), /*#__PURE__*/React.createElement(Col, {
          xs4: 4,
          xs8: 5,
          sm: 9
        }, buttons, /*#__PURE__*/React.createElement("div", null, enterInput))), /*#__PURE__*/React.createElement("br", null), colorTransformation);
      }
    }]);
    return ScaleChoice;
  }(React.Component);

  function setVizSettings(key, value) {
    onVizSettings(id, _.assoc(currentSettings.state, key, value));
  }

  function getVizSettings(key) {
    return _.getIn(state, [key]);
  } //color transformation for dense genomics matrix floats


  var NormalizationDropDown = /*#__PURE__*/function (_React$Component8) {
    (0, _inherits2["default"])(NormalizationDropDown, _React$Component8);

    var _super8 = _createSuper(NormalizationDropDown);

    function NormalizationDropDown(props) {
      var _this5;

      (0, _classCallCheck2["default"])(this, NormalizationDropDown);
      _this5 = _super8.call(this, props);
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this5), "handleChange", function (value) {
        var key = "colNormalization";
        setVizSettings(key, value);

        _this5.setState({
          optionValue: value
        });
      });

      var _value = getVizSettings('colNormalization') || defaultNormalization || 'none',
          mapping = {
        "none": "none",
        "subset": "subset",
        "log2(x)": "log2(x)",
        "true": "subset"
      };

      _this5.state = {
        optionValue: mapping[_value] || "none"
      };
      return _this5;
    }

    (0, _createClass2["default"])(NormalizationDropDown, [{
      key: "render",
      value: function render() {
        var dataMin = _.minnull(_.map(data.req.values, function (values) {
          return _.minnull(values);
        })),
            optionValue = this.state.optionValue,
            options = [{
          "key": "none",
          "label": "none"
        }, {
          "key": "subset",
          "label": "center by column mean : x - column average"
        }];

        if (dataMin >= 0 && !_.any(units, function (unit) {
          return unit && unit.search(/log/i) !== -1;
        })) {
          // we allow log(0), necessary for RNAseq data, value =0 (no expression is very common).
          // display can handle this
          options.push({
            "key": "log2(x)",
            "label": "log scale : log2(x+1)"
          });
        }

        var normalizations = options.map(function (option) {
          return {
            value: option.key,
            label: option.label
          };
        });
        return /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
          xs4: 4,
          xs8: 3,
          sm: 3
        }, /*#__PURE__*/React.createElement("div", {
          className: _VizSettingsModule["default"].selectLabel
        }, "Color transformation")), /*#__PURE__*/React.createElement(Col, {
          xs4: 4,
          xs8: 5,
          sm: 9
        }, /*#__PURE__*/React.createElement(_dropdown.Dropdown, {
          auto: true,
          onChange: this.handleChange,
          source: normalizations,
          value: optionValue,
          className: _VizSettingsModule["default"].dropDown,
          theme: {
            selected: _VizSettingsModule["default"].selected
          }
        })));
      }
    }]);
    return NormalizationDropDown;
  }(React.Component); //color transformation for segmented cnv


  var SegCNVnormalizationDropDown = /*#__PURE__*/function (_React$Component9) {
    (0, _inherits2["default"])(SegCNVnormalizationDropDown, _React$Component9);

    var _super9 = _createSuper(SegCNVnormalizationDropDown);

    function SegCNVnormalizationDropDown(props) {
      var _this6;

      (0, _classCallCheck2["default"])(this, SegCNVnormalizationDropDown);
      _this6 = _super9.call(this, props);
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this6), "handleChange", function (value) {
        var key = "colNormalization";
        setVizSettings(key, value);

        _this6.setState({
          optionValue: value
        });
      });

      var _value2 = getVizSettings('colNormalization') || defaultNormalization || 'none',
          mapping = {
        "none": "none",
        "normal2": "normal2"
      };

      _this6.state = {
        optionValue: mapping[_value2] || "none"
      };
      return _this6;
    }

    (0, _createClass2["default"])(SegCNVnormalizationDropDown, [{
      key: "render",
      value: function render() {
        var optionValue = this.state.optionValue,
            options = [{
          "key": "none",
          "label": "normal = 0"
        }, {
          "key": "normal2",
          "label": "normal = 2"
        }],
            normalizations = options.map(function (option) {
          return {
            value: option.key,
            label: option.label
          };
        });
        return /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
          xs4: 4,
          xs8: 3,
          sm: 3
        }, /*#__PURE__*/React.createElement("div", {
          className: _VizSettingsModule["default"].selectLabel
        }, "Color transformation")), /*#__PURE__*/React.createElement(Col, {
          xs4: 4,
          xs8: 5,
          sm: 9
        }, /*#__PURE__*/React.createElement(_dropdown.Dropdown, {
          auto: true,
          onChange: this.handleChange,
          source: normalizations,
          value: optionValue,
          className: _VizSettingsModule["default"].dropDown,
          theme: {
            selected: _VizSettingsModule["default"].selected
          }
        })));
      }
    }]);
    return SegCNVnormalizationDropDown;
  }(React.Component); //color palette dense matrix floats and segmented CNV


  var ColorDropDown = /*#__PURE__*/function (_React$Component10) {
    (0, _inherits2["default"])(ColorDropDown, _React$Component10);

    var _super10 = _createSuper(ColorDropDown);

    function ColorDropDown(props) {
      var _this7;

      (0, _classCallCheck2["default"])(this, ColorDropDown);
      _this7 = _super10.call(this, props);
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this7), "handleChange", function (value) {
        var key = "colorClass";
        setVizSettings(key, value);

        _this7.setState({
          optionValue: value
        });
      });

      var _value3 = getVizSettings('colorClass') || 'default';

      _this7.state = {
        optionValue: _value3
      };
      return _this7;
    }

    (0, _createClass2["default"])(ColorDropDown, [{
      key: "render",
      value: function render() {
        var optionValue = this.state.optionValue,
            options = {
          "float": [{
            "key": "default",
            "label": "red-white-blue"
          }, {
            "key": "expression",
            "label": "red-black-green"
          }, {
            "key": "blueBlackYellow",
            "label": "yellow-black-blue"
          }, {
            "key": "whiteBlack",
            "label": "black-white"
          }],
          segmented: [{
            "key": "default",
            "label": "red-white-blue"
          }, {
            "key": "expression",
            "label": "red-white-green"
          }, {
            "key": "blueBlackYellow",
            "label": "yellow-white-blue"
          }]
        },
            colors = options[valueType].map(function (option) {
          return {
            value: option.key,
            label: option.label
          };
        });
        return /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
          xs4: 4,
          xs8: 3,
          sm: 3
        }, /*#__PURE__*/React.createElement("div", {
          className: _VizSettingsModule["default"].selectLabel
        }, "Color palette")), /*#__PURE__*/React.createElement(Col, {
          xs4: 4,
          xs8: 5,
          sm: 9
        }, /*#__PURE__*/React.createElement(_dropdown.Dropdown, {
          auto: true,
          onChange: this.handleChange,
          source: colors,
          value: optionValue,
          className: _VizSettingsModule["default"].dropDown,
          theme: {
            selected: _VizSettingsModule["default"].selected
          }
        })));
      }
    }]);
    return ColorDropDown;
  }(React.Component); //color palette for SV


  var SvColorDropDown = /*#__PURE__*/function (_React$Component11) {
    (0, _inherits2["default"])(SvColorDropDown, _React$Component11);

    var _super11 = _createSuper(SvColorDropDown);

    function SvColorDropDown(props) {
      var _this8;

      (0, _classCallCheck2["default"])(this, SvColorDropDown);
      _this8 = _super11.call(this, props);
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this8), "handleChange", function (value) {
        var key = "svColor";
        setVizSettings(key, value);

        _this8.setState({
          optionValue: value
        });
      });

      var _value4 = getVizSettings('svColor') || 'default';

      _this8.state = {
        optionValue: _value4
      };
      return _this8;
    }

    (0, _createClass2["default"])(SvColorDropDown, [{
      key: "render",
      value: function render() {
        var optionValue = this.state.optionValue,
            options = {
          SV: [{
            "key": "default",
            "label": "lavender"
          }, {
            "key": "chromosomeGB",
            "label": "by chromosome (Genome Browser)"
          }, {
            "key": "chromosomePCAWG",
            "label": "by chromosome (PCAWG)"
          }]
        },
            colors = options[fieldType].map(function (option) {
          return {
            value: option.key,
            label: option.label
          };
        });
        return /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
          xs4: 4,
          xs8: 3,
          sm: 3
        }, /*#__PURE__*/React.createElement("div", {
          className: _VizSettingsModule["default"].selectLabel
        }, "Color palette")), /*#__PURE__*/React.createElement(Col, {
          xs4: 4,
          xs8: 5,
          sm: 9
        }, /*#__PURE__*/React.createElement(_dropdown.Dropdown, {
          auto: true,
          onChange: this.handleChange,
          source: colors,
          value: optionValue,
          className: _VizSettingsModule["default"].dropDown,
          theme: {
            selected: _VizSettingsModule["default"].selected
          }
        })));
      }
    }]);
    return SvColorDropDown;
  }(React.Component); //user label for Categories


  var CategoricalTable = /*#__PURE__*/function (_React$Component12) {
    (0, _inherits2["default"])(CategoricalTable, _React$Component12);

    var _super12 = _createSuper(CategoricalTable);

    function CategoricalTable(props) {
      var _this9;

      (0, _classCallCheck2["default"])(this, CategoricalTable);

      var parseVizSettingCodes = function parseVizSettingCodes(str) {
        if (!_.isString(str)) {
          return undefined;
        }

        var codes = JSON.parse(str),
            observed = JSON.stringify(_.keys(codes).sort(function sortNumber(a, b) {
          return a - b;
        })),
            expected = JSON.stringify(_.range(_.keys(codes).length).map(function (x) {
          return x.toString();
        }));

        if (observed === expected) {
          return codes;
        }

        return undefined;
      };

      _this9 = _super12.call(this, props);
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this9), "handleChange", function (i, value) {
        var codes = _this9.state;
        codes[i] = value;
        setVizSettings('codes', JSON.stringify(codes));

        _this9.setState((0, _defineProperty2["default"])({}, i, value));
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this9), "onRest", function (i, originalCode) {
        var codes = _this9.state,
            value = originalCode;
        codes[i] = value;
        setVizSettings('codes', JSON.stringify(codes));

        _this9.setState((0, _defineProperty2["default"])({}, i, value));
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this9), "buildCoded", function (index, codes, originalCodes, customColors) {
        var node = index.map(function (i) {
          var code = codes[i.toString()],
              originalCode = originalCodes[i],
              backgroundColor = customColors ? customColors[i] : categoryMore[i % categoryMore.length];
          return /*#__PURE__*/React.createElement(Row, {
            key: i
          }, /*#__PURE__*/React.createElement(Col, {
            xs4: 1,
            xs8: 1,
            sm: 1
          }, /*#__PURE__*/React.createElement("div", {
            className: _VizSettingsModule["default"].categoryColor,
            style: {
              backgroundColor: backgroundColor
            }
          })), /*#__PURE__*/React.createElement(Col, {
            xs4: 4,
            xs8: 4,
            sm: 6
          }, /*#__PURE__*/React.createElement(_input.Input, {
            type: "text",
            value: code,
            className: _VizSettingsModule["default"].categoryInput,
            onChange: _this9.handleChange.bind((0, _assertThisInitialized2["default"])(_this9), i)
          })), code !== originalCode ? /*#__PURE__*/React.createElement(Col, null, /*#__PURE__*/React.createElement(_button.Button, {
            onMouseUp: _this9.onRest.bind((0, _assertThisInitialized2["default"])(_this9), i, originalCode),
            className: _VizSettingsModule["default"].cancelButton
          }, "Reset")) : null);
        });
        return node;
      });
      _this9.state = parseVizSettingCodes(getVizSettings('codes')) || _.object(_.range(data.codes.length), data.codes);
      return _this9;
    }

    (0, _createClass2["default"])(CategoricalTable, [{
      key: "render",
      value: function render() {
        var customColors = _.getIn(column, ['colors', 0, 2]),
            codes = this.state,
            originalCodes = _.getIn(data, ['codes']),
            index = _.intersection(_.getIn(data, ['req', 'values', 0]), _.range(data.codes.length));

        index.sort(function sortNumber(a, b) {
          return a - b;
        }).reverse();
        return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
          xs4: 1,
          xs8: 1,
          sm: 1
        }, /*#__PURE__*/React.createElement("div", {
          className: _VizSettingsModule["default"].selectLabel
        }, "Color")), /*#__PURE__*/React.createElement(Col, {
          xs4: 4,
          xs8: 4,
          sm: 6
        }, /*#__PURE__*/React.createElement("div", {
          className: _VizSettingsModule["default"].selectLabel
        }, "Label"))), this.buildCoded(index, codes, originalCodes, customColors));
      }
    }]);
    return CategoricalTable;
  }(React.Component);

  var state = vizState,
      oldSettings = state,
      currentSettings = {
    state: state
  },
      colorParams = {
    "float": ["max", "maxstart", "minstart", "min"],
    segmented: ["origin", "thresh", "max"]
  };
  ReactDOM.render(React.createElement(DatasetSetting), node);
  return currentSettings;
} // react wrapper for the legacy DOM code, above.


var SettingsWrapper = /*#__PURE__*/function (_React$Component13) {
  (0, _inherits2["default"])(SettingsWrapper, _React$Component13);

  var _super13 = _createSuper(SettingsWrapper);

  function SettingsWrapper() {
    (0, _classCallCheck2["default"])(this, SettingsWrapper);
    return _super13.apply(this, arguments);
  }

  (0, _createClass2["default"])(SettingsWrapper, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      return false;
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(newProps) {
      this.currentSettings.state = newProps.vizSettings;
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var content = this.refs.content,
          _this$props = this.props,
          data = _this$props.data,
          column = _this$props.column,
          units = _this$props.units,
          onVizSettings = _this$props.onVizSettings,
          vizSettings = _this$props.vizSettings,
          id = _this$props.id,
          defaultNormalization = _this$props.defaultNormalization,
          colorClass = _this$props.colorClass,
          valueType = _this$props.valueType,
          fieldType = _this$props.fieldType,
          onRequestHide = _this$props.onRequestHide;
      this.currentSettings = vizSettingsWidget(content, onVizSettings, vizSettings, id, onRequestHide, defaultNormalization, colorClass, valueType, fieldType, data, units, column);
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement("div", {
        ref: "content"
      });
    }
  }]);
  return SettingsWrapper;
}(React.Component);

var VizSettings = /*#__PURE__*/function (_React$Component14) {
  (0, _inherits2["default"])(VizSettings, _React$Component14);

  var _super14 = _createSuper(VizSettings);

  function VizSettings() {
    (0, _classCallCheck2["default"])(this, VizSettings);
    return _super14.apply(this, arguments);
  }

  (0, _createClass2["default"])(VizSettings, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      document.documentElement.scrollTop = 0;
      var body = document.getElementById("body");
      body.style.overflow = "auto";
    }
  }, {
    key: "render",
    value: function render() {
      var onRequestHide = this.props.onRequestHide;
      var actions = [{
        children: [/*#__PURE__*/React.createElement("i", {
          className: "material-icons"
        }, "close")],
        className: _VizSettingsModule["default"].dialogClose,
        onClick: onRequestHide
      }];
      return /*#__PURE__*/React.createElement(_dialog.Dialog, {
        actions: actions,
        active: true,
        title: "Adjust Display Settings",
        className: _VizSettingsModule["default"].dialog,
        onEscKeyDown: onRequestHide,
        onOverlayClick: onRequestHide,
        theme: {
          wrapper: _VizSettingsModule["default"].dialogWrapper,
          overlay: _VizSettingsModule["default"].dialogOverlay
        }
      }, /*#__PURE__*/React.createElement(SettingsWrapper, this.props));
    }
  }]);
  return VizSettings;
}(React.Component);

module.exports = VizSettings;