"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _button = require("react-toolbox/lib/button");

var _card = require("react-toolbox/lib/card");

var _ajaxLoader = _interopRequireDefault(require("../ajax-loader.gif"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Card displayed during (wizard-based) setup.
 *
 * State
 * -----
 * colId - ID of column (eg 'A', 'B'). Only applicable on edit of column.
 * controls - Icons and/or menu displayed at right of card title.
 * helpText - Text displayed under title/subtitle and above children.
 * title - Text displayed as title.
 * valid - True if wizard card is complete and done button is enabled.
 * width - Width of card.
 *
 * Actions
 * -------
 * onDone - Called when DONE button is clicked.
 */
// Core dependencies, components
var React = require('react');

// App dependencies
var CardAvatar = require('./CardAvatar'); // Styles


var compStyles = require('./WizardCard.module.css');

var cardStyles = require('./RTCardTheme.module.css');

var classname = require('classnames');

var WizardCard = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(WizardCard, _React$Component);

  var _super = _createSuper(WizardCard);

  function WizardCard() {
    var _this;

    (0, _classCallCheck2["default"])(this, WizardCard);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onDone", function () {
      _this.props.onDone();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onDoneInvalid", function (ev) {
      var _this$props = _this.props,
          valid = _this$props.valid,
          onDoneInvalid = _this$props.onDoneInvalid;

      if (onDoneInvalid && !valid) {
        onDoneInvalid(ev);
      }
    });
    return _this;
  }

  (0, _createClass2["default"])(WizardCard, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          children = _this$props2.children,
          colId = _this$props2.colId,
          controls = _this$props2.controls,
          contentSpecificHelp = _this$props2.contentSpecificHelp,
          title = _this$props2.title,
          subtitle = _this$props2.subtitle,
          valid = _this$props2.valid,
          loading = _this$props2.loading,
          loadingCohort = _this$props2.loadingCohort,
          width = _this$props2.width;
      return /*#__PURE__*/React.createElement(_card.Card, {
        style: {
          width: width
        },
        className: compStyles.WizardCard
      }, /*#__PURE__*/React.createElement("div", {
        className: compStyles.headerContainer
      }, /*#__PURE__*/React.createElement(CardAvatar, {
        colId: colId
      }), /*#__PURE__*/React.createElement("div", {
        className: compStyles.controls
      }, controls)), /*#__PURE__*/React.createElement("div", {
        className: compStyles.titleContainer
      }, /*#__PURE__*/React.createElement(_card.CardTitle, {
        className: classname(compStyles.title, subtitle ? cardStyles.warning : ''),
        title: title,
        subtitle: subtitle
      })), /*#__PURE__*/React.createElement("div", {
        className: compStyles.content
      }, contentSpecificHelp ? /*#__PURE__*/React.createElement(_card.CardText, null, contentSpecificHelp) : null, loadingCohort ? /*#__PURE__*/React.createElement(_card.CardText, null, "Loading datasets...") : null, children), /*#__PURE__*/React.createElement(_card.CardActions, {
        className: compStyles.actions
      }, loading ? /*#__PURE__*/React.createElement("img", {
        src: _ajaxLoader["default"]
      }) : null, valid ? /*#__PURE__*/React.createElement("i", {
        className: "material-icons"
      }, "done") : null, /*#__PURE__*/React.createElement("span", {
        onClick: this.onDoneInvalid
      }, /*#__PURE__*/React.createElement(_button.Button, {
        accent: true,
        disabled: !valid,
        onClick: this.onDone
      }, "Done"))));
    }
  }]);
  return WizardCard;
}(React.Component);

module.exports = WizardCard;