"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _radio = require("react-toolbox/lib/radio");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Standard Xena radio group, with UI/UX based on Material Design's full-width inputs. This is a light wrapper component
 * around React Toolbox's RadioGroup (applies custom class name for styling radio group).
 *
 * State
 * -----
 * label - radio group field name.
 * additionalAction - display text of additional action.
 * options - array of radio options in format {label, value, meta: [{label, value}]}
 *
 * Actions
 * -------
 * onAdditionalAction - called when additional action link is clicked.
 * onChange - called when selected radio value is changed.
 */
// Core dependencies, components
var React = require('react');

//import {RadioButton} from 'react-toolbox/lib/radio';
var _ = require('../underscore_ext')["default"];

var XRadioMeta = require('./XRadioMeta');

var XInputToolbar = require('./XInputToolbar'); // Styles


var compStyles = require('./XRadioGroup.module.css');

var XRadioGroup = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(XRadioGroup, _React$Component);

  var _super = _createSuper(XRadioGroup);

  function XRadioGroup() {
    var _this;

    (0, _classCallCheck2["default"])(this, XRadioGroup);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onChange", function (value) {
      _this.props.onChange(value);
    });
    return _this;
  }

  (0, _createClass2["default"])(XRadioGroup, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          additionalAction = _this$props.additionalAction,
          label = _this$props.label,
          onAdditionalAction = _this$props.onAdditionalAction,
          options = _this$props.options,
          value = _this$props.value;
      return /*#__PURE__*/React.createElement("div", {
        className: compStyles.XRadioGroup
      }, /*#__PURE__*/React.createElement(XInputToolbar, {
        label: label,
        additionalAction: additionalAction,
        onAdditionalAction: onAdditionalAction
      }), /*#__PURE__*/React.createElement(_radio.RadioGroup, {
        value: value,
        onChange: this.onChange
      }, _.map(options, function (o) {
        return [/*#__PURE__*/React.createElement(_radio.RadioButton, {
          label: o.label,
          value: o.value
        }), o.meta ? /*#__PURE__*/React.createElement(XRadioMeta, {
          meta: o.meta
        }) : null];
      })));
    }
  }]);
  return XRadioGroup;
}(React.Component);

module.exports = XRadioGroup;