"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react'); // Styles


var compStyles = require('./ZoomCarriage.module.css');

var classNames = require('classnames');

var ZoomCarriage = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(ZoomCarriage, _PureComponent);

  var _super = _createSuper(ZoomCarriage);

  function ZoomCarriage() {
    var _this;

    (0, _classCallCheck2["default"])(this, ZoomCarriage);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getRotation", function (angle) {
      return 'rotate(' + angle + 'deg)';
    });
    return _this;
  }

  (0, _createClass2["default"])(ZoomCarriage, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          addColumnAddHover = _this$props.addColumnAddHover,
          enableTransition = _this$props.enableTransition,
          samplesCount = _this$props.samplesCount,
          zoom = _this$props.zoom,
          zoomCarriageMargin = addColumnAddHover ? 3 : 11,
          carriageStart = Math.floor(zoom.height / samplesCount * zoom.index),
          carriageHeight = Math.floor(zoom.height / samplesCount * zoom.count),
          carriageEnd = carriageStart + carriageHeight,
          heightBelowCarriage = zoom.height - carriageStart - carriageHeight,
          upperAngle = -Math.atan(carriageStart / zoomCarriageMargin) * 180 / Math.PI,
          upperLine = Math.sqrt(Math.pow(zoomCarriageMargin, 2) + Math.pow(carriageStart, 2)),
          lowerAngle = Math.atan(heightBelowCarriage / zoomCarriageMargin) * 180 / Math.PI,
          lowerLine = Math.sqrt(Math.pow(zoomCarriageMargin, 2) + Math.pow(heightBelowCarriage, 2));
      return /*#__PURE__*/React.createElement("div", {
        className: compStyles.zoomCarriage
      }, /*#__PURE__*/React.createElement("div", {
        className: compStyles.carriage,
        style: {
          height: carriageHeight,
          top: carriageStart
        }
      }), /*#__PURE__*/React.createElement("div", {
        className: classNames(compStyles.carriageLines, compStyles.upper, (0, _defineProperty2["default"])({}, compStyles.transitionRotate, enableTransition)),
        style: {
          top: carriageStart,
          transform: this.getRotation(upperAngle),
          width: upperLine
        }
      }), /*#__PURE__*/React.createElement("div", {
        className: classNames(compStyles.carriageLines, compStyles.lower, (0, _defineProperty2["default"])({}, compStyles.transitionRotate, enableTransition)),
        style: {
          top: carriageEnd,
          transform: this.getRotation(lowerAngle),
          width: lowerLine
        }
      }));
    }
  }]);
  return ZoomCarriage;
}(_PureComponent2["default"]);

;
var _default = ZoomCarriage;
exports["default"] = _default;