var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Zoom help tag displayed on mousedown and drag over gene or samples zoom.
 */
// Core dependencies, components
var React = require('react');

var _require = require('react-overlays'),
    Portal = _require.Portal;

var columnZoom = require('../columnZoom'); // Styles


var compStyles = require('./ZoomHelpTag.module.css'); // Return zoom text when user has pressed mouse down but has not yet moved the mouse


var defaultText = function defaultText() {
  return 'Drag to zoom';
}; // Return zoom text when user is currently executing a horizontal zoom


var geneZoomText = function geneZoomText(annotationPct) {
  return "Zoom to ".concat(annotationPct < 1 ? "< 1" : annotationPct, "%");
}; // Return zoom text when user is currently executing a vertical zoom


var sampleZoomText = function sampleZoomText(zoomTo) {
  var sampleRowFrom = zoomTo.index + 1,
      sampleRowTo = zoomTo.index + zoomTo.count;
  return zoomTo.count === 1 ? "Zoom to row ".concat(sampleRowFrom) : "Zoom to rows ".concat(sampleRowFrom, " - ").concat(sampleRowTo);
};

var ZoomHelpTag = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(ZoomHelpTag, _React$Component);

  var _super = _createSuper(ZoomHelpTag);

  function ZoomHelpTag() {
    _classCallCheck(this, ZoomHelpTag);

    return _super.apply(this, arguments);
  }

  _createClass(ZoomHelpTag, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          column = _this$props.column,
          selection = _this$props.selection;

      if (selection) {
        var crosshair = selection.crosshair,
            direction = selection.direction,
            offset = selection.offset,
            overlay = selection.overlay,
            zone = selection.zone,
            zoomTo = selection.zoomTo,
            fieldType = column.fieldType,
            zoomToLength = columnZoom.zoomToLength({
          fieldType: fieldType,
          zoomTo: zoomTo
        }),
            geneZoomPct = Math.round(zoomToLength / columnZoom.maxGeneZoomLength(column) * 100),
            annotationZoom = direction === 'h',
            noZoom = overlay.sstart === overlay.send,
            tagInstruction = noZoom ? defaultText() : annotationZoom ? geneZoomText(geneZoomPct) : sampleZoomText(zoomTo),
            crosshairVFromRightBounds = document.body.offsetWidth - crosshair.x,
            tagPosLeft = zone === 'a' ? crosshair.x : annotationZoom ? offset.x + overlay.sstart === crosshair.x ? 'unset' : crosshair.x : crosshair.x,
            tagPosRight = annotationZoom && zone === 's' && offset.x + overlay.sstart === crosshair.x ? crosshairVFromRightBounds : 'unset',
            tagPosTop = zone === 'a' ? offset.y - 48 : annotationZoom ? crosshair.y : offset.y + overlay.sstart === crosshair.y ? crosshair.y - 40 : crosshair.y;
      }

      return /*#__PURE__*/React.createElement(Portal, {
        container: document.body
      }, selection ? /*#__PURE__*/React.createElement("div", {
        className: compStyles.zoomHelpTag,
        style: {
          left: tagPosLeft,
          right: tagPosRight,
          top: tagPosTop
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: compStyles.zoomInstructions
      }, tagInstruction)) : null);
    }
  }]);

  return ZoomHelpTag;
}(React.Component);

module.exports = ZoomHelpTag;