var _defineProperty = require("@babel/runtime/helpers/defineProperty");

var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Overlay displayed on mousedown and drag over gene or samples zoom.
 */
// Core dependencies, components
var React = require('react');

var classNames = require('classnames'); // Styles


var compStyles = require('./ZoomOverlay.module.css');

var ZoomOverlay = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(ZoomOverlay, _React$Component);

  var _super = _createSuper(ZoomOverlay);

  function ZoomOverlay() {
    _classCallCheck(this, ZoomOverlay);

    return _super.apply(this, arguments);
  }

  _createClass(ZoomOverlay, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          geneHeight = _this$props.geneHeight,
          height = _this$props.height,
          positionHeight = _this$props.positionHeight,
          selection = _this$props.selection,
          children = _this$props.children;

      if (selection) {
        var direction = selection.direction,
            offset = selection.offset,
            overlay = selection.overlay,
            annotationZoom = direction === 'h',
            noSamples = overlay.send === null && overlay.sstart === null,
            iEnd = overlay.iend,
            iStart = overlay.istart,
            sEnd = annotationZoom && noSamples ? (iEnd - iStart) / 2 + iStart : overlay.send,
            sStart = annotationZoom && noSamples ? (iEnd - iStart) / 2 + iStart : overlay.sstart,
            sEndSamples = sEnd + offset.y,
            sStartSamples = sStart + offset.y,
            iStartSamples = iStart ? iStart + offset.y : sStartSamples,
            iEndSamples = iEnd ? iEnd + offset.y : sEndSamples,
            posY1Annotation = 0,
            posY2Annotation = 8,
            posY5Annotation = posY2Annotation + geneHeight + height,
            posY4Annotation = posY5Annotation - height - 2,
            posY3Annotation = posY4Annotation - positionHeight + 2,
            posX1Samples = iStartSamples === sStartSamples && iEndSamples === sEndSamples ? 20 : 26,
            posX2Samples = iStartSamples === sStartSamples && iEndSamples === sEndSamples ? posX1Samples : posX1Samples + 12,
            posX3Samples = window.innerWidth,
            polygonPoints = annotationZoom ? "".concat(iStart, ",").concat(posY1Annotation, " ").concat(iEnd, ",").concat(posY1Annotation, " ").concat(iEnd, ",").concat(posY3Annotation, " ").concat(sEnd, ",").concat(posY4Annotation, " ").concat(sEnd, ",").concat(posY5Annotation, " ").concat(sStart, ",").concat(posY5Annotation, " ").concat(sStart, ",").concat(posY4Annotation, " ").concat(iStart, ",").concat(posY3Annotation, " ").concat(iStart, ",").concat(posY1Annotation) : "0,".concat(iStartSamples, " ").concat(posX1Samples, ",").concat(iStartSamples, " ").concat(posX2Samples, ",").concat(sStartSamples, " ").concat(posX3Samples, ",").concat(sStartSamples, " ").concat(posX3Samples, ",").concat(sEndSamples, " ").concat(posX2Samples, ",").concat(sEndSamples, " ").concat(posX1Samples, ",").concat(iEndSamples, " 0,").concat(iEndSamples, " 0,").concat(sStartSamples);
      }

      return /*#__PURE__*/React.createElement("div", {
        className: compStyles.ZoomOverlay
      }, children, selection ? /*#__PURE__*/React.createElement("svg", {
        className: classNames(compStyles.overlay, _defineProperty({}, compStyles.overlayV, !annotationZoom), _defineProperty({}, compStyles.overlayH, annotationZoom)),
        style: {
          height: annotationZoom ? posY5Annotation : '100%'
        }
      }, /*#__PURE__*/React.createElement("polygon", {
        points: polygonPoints
      })) : null);
    }
  }]);

  return ZoomOverlay;
}(React.Component);

module.exports = ZoomOverlay;