/*global define: false */
var Rx = require('./rx')["default"];

var encodeObject = require('./util')["default"].encodeObject;

var _require$default = require('./underscore_ext')["default"],
    isArray = _require$default.isArray,
    merge = _require$default.merge;

function update(host, files, flags) {
  files = isArray(files) ? files : [files];
  return {
    headers: {
      'Content-Type': 'application/x-www-form-urlencoded'
    },
    url: host + '/update/',
    body: encodeObject(merge({
      file: files
    }, flags)),
    method: 'POST',
    crossDomain: true
  };
}

module.exports = {
  load: function load(host, files, always) {
    return Rx.Observable.ajax(update(host, files, always ? {
      always: true
    } : {}));
  },
  "delete": function _delete(host, files) {
    return Rx.Observable.ajax(update(host, files, {
      "delete": true
    }));
  }
};